/*
 * ADDW SCCS: @(#)ebind.h	1.52 05/17/20 22:46:46
 */

/*	EBIND:		Initial default key to function bindings for
 *			MicroEMACS 3.9ex
 */

/* Prefix binding map.
 */
PRETAB	preftab[] = {
	{ChrToCtrl('['),	metaPrefix},	// CharEscape
	{ChrToCtrl('u'),	ctlu},
	{ChrToCtrl('x'),	ctlx},
	{0,			NULL}
};

/* Command table.
 * This table  is *roughly* in ASCII order, left to right across the
 * characters of the command. This explains the funny location of the
 * control-X commands.
 * The k_flag field is filled in when the program starts.
 *
 * Where CNTRL is used below the character must be in the range 40x to 5Fx,
 * this means that all letters are upper case.
 *
 * The {} around the 2nd value is to stop compiler warnings;
 * the reason is that the element in the structure is a union.
 */
KEYTAB  keytab[NBINDS] = {
	{ChrToCtrl('@'),	{setmark} },	// Internally C-SPC is held as C-@ (CNTRL | '@')
	{ChrToCtrl('A'),	{gotobol} },
#if	TONY_BINDINGS
	{ChrToCtrl('B'),	{backword} },
#else
	{ChrToCtrl('B'),	{backchar} },
#endif
	{ChrToCtrl('C'),	{reposition} },
	{ChrToCtrl('D'),	{forwdel} },
	{ChrToCtrl('E'),	{gotoeol} },
	{ChrToCtrl('F'),	{forwchar} },
	{ChrToCtrl('G'),	{ctrlg} },
#if	TONY_BINDINGS
	{ChrToCtrl('H'),	{backchar} },
#else
	{ChrToCtrl('H'),	{backdel} },
#endif
	{ChrToCtrl('I'),	{instab} },
	{ChrToCtrl('J'),	{newlineMaybeIndent} },
	{ChrToCtrl('K'),	{killtext} },
	{ChrToCtrl('L'),	{refreshScreen} },
	{ChrToCtrl('M'),	{newline} },
	{ChrToCtrl('N'),	{forwline} },
	{ChrToCtrl('O'),	{openline} },
	{ChrToCtrl('P'),	{backline} },
	{ChrToCtrl('Q'),	{quote} },
#if	ISRCH
	{ChrToCtrl('R'),	{risearch} },
#else
	{ChrToCtrl('R'),	{backsearch} },
#endif
	{ChrToCtrl('S'),	{fisearch} },
	{ChrToCtrl('T'),	{twiddle} },
	{ChrToCtrl('V'),	{forwpage} },
	{ChrToCtrl('W'),	{killregion} },
	{ChrToCtrl('Y'),	{yank} },
/*	{ChrToCtrl('Z'),	{backpage} },*/
	{ChrToCtrl('Z'),	{bktoshell} },
/*	{ChrToCtrl('['),	??? },			The ESC key is C-[	*/
	{ChrToCtrl('\\'),	{topbot} },
	{ChrToCtrl('_'),	{undo} },
	{ChrToCtrl(']'),	{invert} },
	{ChrToCtrl('^'),	{cscan} },
	{CTLX|ChrToCtrl('A'),	{pamark} },
	{CTLX|ChrToCtrl('B'),	{listbuffers} },
	{CTLX|ChrToCtrl('C'),	{quit} },		/* Hard quit */
#if	TONY_BINDINGS
	{CTLX|ChrToCtrl('D'),	{changedir} },
	{CTLX|ChrToCtrl('E'),	{ctlxe} },
#else
	{CTLX|ChrToCtrl('D'),	{detab} },
	{CTLX|ChrToCtrl('E'),	{entab} },
#endif
	{CTLX|ChrToCtrl('G'),	{ctrlg} },
	{CTLX|ChrToCtrl('F'),	{filefind} },
	{CTLX|ChrToCtrl('I'),	{insfile} },
	{CTLX|ChrToCtrl('L'),	{lowerregion} },
	{CTLX|ChrToCtrl('M'),	{delMode} },
	{CTLX|ChrToCtrl('N'),	{mvdnwind} },
	{CTLX|ChrToCtrl('O'),	{deblank} },
	{CTLX|ChrToCtrl('P'),	{mvupwind} },
	{CTLX|ChrToCtrl('R'),	{fileread} },
	{CTLX|ChrToCtrl('S'),	{filesave} },
#if	AEDIT
	{CTLX|ChrToCtrl('T'),	{trim} },
#endif
	{CTLX|ChrToCtrl('U'),	{upperregion} },
	{CTLX|ChrToCtrl('V'),	{viewfile} },
	{CTLX|ChrToCtrl('W'),	{filewrite} },
	{CTLX|ChrToCtrl('X'),	{swapmark} },
	{CTLX|ChrToCtrl('Z'),	{shrinkwind} },
	{CTLX|ChrToCtrl('^'),	{getcscan} },
	{CTLX|'?',		{deskey} },
	{CTLX|'!',		{spawn} },
	{CTLX|'@',		{pipecmd} },
	{CTLX|'#',		{filterBuffer} },
	{CTLX|'$',		{spawn} },
	{CTLX|'=',		{showcpos} },
	{CTLX|'<',		{narrow} },
	{CTLX|'>',		{widen} },
	{CTLX|'(',		{ctlxlp} },
	{CTLX|')',		{ctlxrp} },
	{CTLX|'^',		{enlargewind} },
	{CTLX|'.',		{renew} },
	{CTLX|'0',		{delwind} },
	{CTLX|'1',		{onlywind} },
	{CTLX|'2',		{owinbuf} },
	{CTLX|'3',		{splitwindhorizbuf} },
	{CTLX|'4',		{owinfil} },
	{CTLX|'5',		{oHorizWinfil} },
	{CTLX|'a',		{retamark} },	/* Return to Alphabetic mark */
	{CTLX|'A',		{fileappend} },
	{CTLX|'b',		{usebuffer} },
	{CTLX|'c',		{spawncli} },
//#ifdef	SIGTSTP					/* USG as well as BSD these days */
//	{CTLX|'d',		{bktoshell} },
//#endif
	{CTLX|'d',		{changedir} },
	{CTLX|'e',		{ctlxe} },
	{CTLX|'f',		{setfillcol} },
	{CTLX|'g',		{dispvar} },
	{CTLX|'k',		{killbuffer} },
	{CTLX|'m',		{setMode} },
	{CTLX|'M',		{showMarks} },
	{CTLX|'n',		{filename} },
	{CTLX|'o',		{nextwind} },
	{CTLX|'p',		{prevwind} },
	{CTLX|'q',		{quote} },
//#if	CBMODE
 	{CTLX|'s',		{filesave} },
//#else
//	{CTLX|'s',		{fisearch} },
//#endif
	{CTLX|'u',		{insUnicode} },
	{CTLX|'v',		{setvar} },
	{CTLX|'w',		{windowManipulate} },
	{CTLX|'W',		{regionwrite} },
	{CTLX|'x',		{nextbuffer} },
	{CTLX|'z',		{enlargewind} },
#if	ISRCH
	{CTLX|'/',		{fisearch} },
#endif
	{CTLX|'|',		{PipeToCommand} },
#if	WORDPRO
	{META|ChrToCtrl('C'),	{wordcount} },
#endif
#if	CFENCE
	{META|ChrToCtrl('F'), 	{getfence} },
#endif
	{META|ChrToCtrl('G'),	{ctrlg} },
	{META|ChrToCtrl('H'),	{delbword} },
#if	CFENCE
	{META|ChrToCtrl('I'), 	{getfence} },
#endif
	{META|ChrToCtrl('K'),	{unbindkey} },
	{META|ChrToCtrl('L'),	{reposition} },
	{META|ChrToCtrl('M'),	{delgMode} },
	{META|ChrToCtrl('N'),	{namebuffer} },
	{META|ChrToCtrl('O'),	{DelWindowOpt} },
	{META|ChrToCtrl('R'),	{qreplace} },
	{META|ChrToCtrl('V'),	{scrnxtdw} },
#if	WORDPRO
	{META|ChrToCtrl('W'),	{killpara} },
#endif
	{META|ChrToCtrl('X'),	{execcmd} },
	{META|ChrToCtrl('Z'),	{scrnxtup} },
	{META|'!',		{spawn} },
	{META|'@',		{pipecmd} },
	{META|'#',		{filterRegion} },
	{META|'$',		{spawncli} },
	{META|'%',		{inscmd} },
	{META|'}',		{FindCError} },
	{META|' ',		{setmark} },
	{META|'?',		{help} },
	{META|'.',		{setmark} },
	{META|'/',		{forwsearch} },
	{META|'>',		{gotoeob} },
	{META|'<',		{gotobob} },
	{META|'(',		{unidentRegion} },
	{META|')',		{indentRegion} },
	{META|'[',		{unindentLines} },
	{META|']',		{indentLines} },
	{META|'~',		{unmark} },
#if	APROP
	{META|'a',		{apro} },
#endif
	{META|'b',		{backword} },
	{META|'c',		{capword} },
	{META|'C',		{commentRegion} },
	{META|'d',		{delfword} },
#if	CRYPT
	{META|'e',		{crysetkey} },
#endif
	{META|'f',		{forwword} },
	{META|'g',		{gotoline} },
	{META|'G',		{gotocolumn} },
	{META|'k',		{bindtokey} },
	{META|'l',		{lowerword} },
	{META|'m',		{setgMode} },
#if	WORDPRO
	{META|'n',		{gotoeop} },
#endif
	{META|'o',		{AddWindowOpt} },
#if	WORDPRO
	{META|'p',		{gotobop} },
// Cannot bind twice:
//	{META|'q',		{fillpara} },
#endif
#if	CBMODE
 	{META|'q',		{quote} },
#else
 	{META|'q',		{fillpara} },
#endif
	{META|'r',		{sreplace} },
#ifdef	SIGTSTP				/* USG as well as BSD these days */
	{META|'s',		{bktoshell} },
#endif
#if	CTAGS
 	{META|'t',		{findtag} },
 	{META|'T',		{findcurtag} },
#endif
	{META|'u',		{upperword} },
	{META|'v',		{backpage} },
	{META|'w',		{copyregion} },
	{META|'x',		{namedcmd} },
	{META|'y',		{reyank} },
	{META|'z',		{quickexit} },
	{META|CharDelete,	{delbword} },

#if	MSDOS && (HP150 == 0) && (WANGPC == 0) && (HP110 == 0)
	{SPEC|CNTRL|'_',	{forwhunt} },
	{SPEC|CNTRL|'S',	{backhunt} },
	{SPEC|71,		{gotobob} },
	{SPEC|72,		{backline} },
	{SPEC|73,		{backpage} },
	{SPEC|75,		{backchar} },
	{SPEC|77,		{forwchar} },
	{SPEC|79,		{gotoeob} },
	{SPEC|80,		{forwline} },
	{SPEC|81,		{forwpage} },
	{SPEC|82,		{insspace} },
	{SPEC|83,		{forwdel} },
	{SPEC|115,		{backword} },
	{SPEC|116,		{forwword} },
#if	WORDPRO
	{SPEC|132,		{gotobop} },
	{SPEC|118,		{gotoeop} },
#endif
	{SPEC|84,		{cbuf1} },
	{SPEC|85,		{cbuf2} },
	{SPEC|86,		{cbuf3} },
	{SPEC|87,		{cbuf4} },
	{SPEC|88,		{cbuf5} },
	{SPEC|89,		{cbuf6} },
	{SPEC|90,		{cbuf7} },
	{SPEC|91,		{cbuf8} },
	{SPEC|92,		{cbuf9} },
	{SPEC|93,		{cbuf10} },
#endif

#if	HP150
	{SPEC|32,		{backline} },
	{SPEC|33,		{forwline} },
	{SPEC|35,		{backchar} },
	{SPEC|34,		{forwchar} },
	{SPEC|44,		{gotobob} },
	{SPEC|46,		{forwpage} },
	{SPEC|47,		{backpage} },
	{SPEC|82,		{nextwind} },
	{SPEC|68,		{openline} },
	{SPEC|69,		{killtext} },
	{SPEC|65,		{forwdel} },
	{SPEC|64,		{ctlxe} },
	{SPEC|67,		{refreshScreen} },
	{SPEC|66,		{reposition} },
	{SPEC|83,		{help} },
	{SPEC|81,		{deskey} },
#endif

#if	HP110
	{SPEC|0x4b,		{backchar} },
	{SPEC|0x4d,		{forwchar} },
	{SPEC|0x48,		{backline} },
	{SPEC|0x50,		{forwline} },
	{SPEC|0x43,		{help} },
	{SPEC|0x73,		{backword} },
	{SPEC|0x74,		{forwword} },
	{SPEC|0x49,		{backpage} },
	{SPEC|0x51,		{forwpage} },
	{SPEC|84,		{cbuf1} },
	{SPEC|85,		{cbuf2} },
	{SPEC|86,		{cbuf3} },
	{SPEC|87,		{cbuf4} },
	{SPEC|88,		{cbuf5} },
	{SPEC|89,		{cbuf6} },
	{SPEC|90,		{cbuf7} },
	{SPEC|91,		{cbuf8} },
#endif

#if	AMIGA
	{SPEC|'?',		{help} },
	{SPEC|'A',		{backline} },
	{SPEC|'B',		{forwline} },
	{SPEC|'C',		{forwchar} },
	{SPEC|'D',		{backchar} },
	{SPEC|'T',		{backpage} },
	{SPEC|'S',		{forwpage} },
	{SPEC|'a',		{backword} },
	{SPEC|'`',		{forwword} },
	{SPEC|'P',		{cbuf1} },
	{SPEC|'Q',		{cbuf2} },
	{SPEC|'R',		{cbuf3} },
	{SPEC|'S',		{cbuf4} },
	{SPEC|'T',		{cbuf5} },
	{SPEC|'U',		{cbuf6} },
	{SPEC|'V',		{cbuf7} },
	{SPEC|'W',		{cbuf8} },
	{SPEC|'X',		{cbuf9} },
	{SPEC|'Y',		{cbuf10} },

#endif

#if	ST520
	{SPEC|'b',		{help} },
	{SPEC|'H',		{backline} },
	{SPEC|'P',		{forwline} },
	{SPEC|'M',		{forwchar} },
	{SPEC|'K',		{backchar} },
	{SPEC|'t',		{setmark} },
	{SPEC|'a',		{yank} },
	{SPEC|'R',		{insspace} },
	{SPEC|'G',		{gotobob} },
	{127,			{forwdel} },
	{SPEC|84,		{cbuf1} },
	{SPEC|85,		{cbuf2} },
	{SPEC|86,		{cbuf3} },
	{SPEC|87,		{cbuf4} },
	{SPEC|88,		{cbuf5} },
	{SPEC|89,		{cbuf6} },
	{SPEC|90,		{cbuf7} },
	{SPEC|91,		{cbuf8} },
	{SPEC|92,		{cbuf9} },
	{SPEC|93,		{cbuf10} },
#endif

#if  WANGPC
	{SPEC|0xE0,		{quit} },		/* Cancel */
	{SPEC|0xE1,		{help} },		/* Help */
	{SPEC|0xF1,		{help} },		/* ^Help */
	{SPEC|0xE3,		{ctrlg} },		/* Print */
	{SPEC|0xF3,		{ctrlg} },		/* ^Print */
	{SPEC|0xC0,		{backline} },		/* North */
	{SPEC|0xD0,		{gotobob} },		/* ^North */
	{SPEC|0xC1,		{forwchar} },		/* East */
	{SPEC|0xD1,		{gotoeol} },		/* ^East */
	{SPEC|0xC2,		{forwline} },		/* South */
	{SPEC|0xD2,		{gotobop} },		/* ^South */
	{SPEC|0xC3,		{backchar} },		/* West */
	{SPEC|0xD3,		{gotobol} },		/* ^West */
	{SPEC|0xC4,		{ctrlg} },		/* Home */
	{SPEC|0xD4,		{gotobob} },		/* ^Home */
	{SPEC|0xC5,		{filesave} },		/* Execute */
	{SPEC|0xD5,		{ctrlg} },		/* ^Execute */
	{SPEC|0xC6,		{insfile} },		/* Insert */
	{SPEC|0xD6,		{ctrlg} },		/* ^Insert */
	{SPEC|0xC7,		{forwdel} },		/* Delete */
	{SPEC|0xD7,		{killregion} },		/* ^Delete */
	{SPEC|0xC8,		{backpage} },		/* Previous */
	{SPEC|0xD8,		{prevwind} },		/* ^Previous */
	{SPEC|0xC9,		{forwpage} },		/* Next */
	{SPEC|0xD9,		{nextwind} },		/* ^Next */
	{SPEC|0xCB,		{ctrlg} },		/* Erase */
	{SPEC|0xDB,		{ctrlg} },		/* ^Erase */
	{SPEC|0xDC,		{ctrlg} },		/* ^Tab */
	{SPEC|0xCD,		{ctrlg} },		/* BackTab */
	{SPEC|0xDD,		{ctrlg} },		/* ^BackTab */
	{SPEC|0x80,		{ctrlg} },		/* Indent */
	{SPEC|0x90,		{ctrlg} },		/* ^Indent */
	{SPEC|0x81,		{ctrlg} },		/* Page */
	{SPEC|0x91,		{ctrlg} },		/* ^Page */
	{SPEC|0x82,		{ctrlg} },		/* Center */
	{SPEC|0x92,		{ctrlg} },		/* ^Center */
	{SPEC|0x83,		{ctrlg} },		/* DecTab */
	{SPEC|0x93,		{ctrlg} },		/* ^DecTab */
	{SPEC|0x84,		{ctrlg} },		/* Format */
	{SPEC|0x94,		{ctrlg} },		/* ^Format */
	{SPEC|0x85,		{ctrlg} },		/* Merge */
	{SPEC|0x95,		{ctrlg} },		/* ^Merge */
	{SPEC|0x86,		{setmark} },		/* Note */
	{SPEC|0x96,		{ctrlg} },		/* ^Note */
	{SPEC|0x87,		{ctrlg} },		/* Stop */
	{SPEC|0x97,		{ctrlg} },		/* ^Stop */
	{SPEC|0x88,		{forwsearch} },		/* Srch */
	{SPEC|0x98,		{backsearch} },		/* ^Srch */
	{SPEC|0x89,		{sreplace} },		/* Replac */
	{SPEC|0x99,		{qreplace} },		/* ^Replac */
	{SPEC|0x8A,		{ctrlg} },		/* Copy */
	{SPEC|0x9A,		{ctrlg} },		/* ^Copy */
	{SPEC|0x8B,		{ctrlg} },		/* Move */
	{SPEC|0x9B,		{ctrlg} },		/* ^Move */
	{SPEC|0x8C,		{namedcmd} },		/* Command */
	{SPEC|0x9C,		{spawn} },		/* ^Command */
	{SPEC|0x8D,		{ctrlg} },		/* ^ */
	{SPEC|0x9D,		{ctrlg} },		/* ^^ */
	{SPEC|0x8E,		{ctrlg} },		/* Blank */
	{SPEC|0x9E,		{ctrlg} },		/* ^Blank */
	{SPEC|0x8F,		{gotoline} },		/* GoTo */
	{SPEC|0x9F,		{usebuffer} },		/* ^GoTo */
#endif
 
	{CharDelete,		{backdel} },

#if	0
	/* special internal bindings */
	{SPEC|META|'W',		{wrapword} },		/* called on word wrap */
	{SPEC|META|'C',		{nullproc} },		/*  every command input */
	{SPEC|META|'R',		{nullproc} },		/*  on file read */
#endif

#if	TERMCAP
	{ UTC_UP,		{backline} },		/* Up arrow */
	{ UTC_DOWN,		{forwline} },		/* Down arrow */
	{ UTC_LEFT,		{backchar} },		/* Left arrow */
	{ UTC_RIGHT,		{forwchar} },		/* Right arrow */
	{ UTC_PGUP,		{backpage} },		/* Back a page */
	{ UTC_PGDOWN,		{forwpage} },		/* Forward page */
	{ UTC_HOME,		{gotobol} },		/* Start of line */
	{ UTC_END,		{gotoeol} },		/* End of line */
	{ UTC_DEL,		{forwdel} },		/* Delete forwards */
	{ UTC_INS,		{ToggleInsertMode} },
	{ UTC_FN_KEY(1),	{fisearch} },		// incremental-search
	{ UTC_FN_KEY(2),	{risearch} },		// reverse-incremental-search
	{ UTC_FN_KEY(3),	{mvdnwind} },		// move-window-down
	{ UTC_FN_KEY(4),	{mvupwind} },		// move-window-up
	{ UTC_FN_KEY(5),	{moveRightWind} },	// move-window-right
	{ UTC_FN_KEY(6),	{moveLeftWind} },	// move-window-left
	{ UTC_FN_KEY(7),	{nextbuffer} },		// next-buffer
	{ UTC_FN_KEY(8),	{filefind} },		// find-file
	{ UTC_FN_KEY(9),	{filesave} },		// save-file
	{ UTC_FN_KEY(10),	{quit} },		// exit-emacs
	{ UTC_FN_KEY(11),	{nullproc } },
	{ UTC_FN_KEY(12),	{nullproc } },

#endif	/* TERMCAP */

	{0,			{NULL} }
};

#if RAINBOW

#include "rainbow.h"

/*
 * Mapping table from the LK201 function keys to the internal EMACS character.
 */

short lk_map[][2] = {
	Up_Key,				CNTRL+'P',
	Down_Key,			CNTRL+'N',
	Left_Key,			CNTRL+'B',
	Right_Key,			CNTRL+'F',
	Shift+Left_Key,			META+'B',
	Shift+Right_Key,		META+'F',
	Control+Left_Key,		CNTRL+'A',
	Control+Right_Key,		CNTRL+'E',
	Prev_Scr_Key,			META+'V',
	Next_Scr_Key,			CNTRL+'V',
	Shift+Up_Key,			META+'<',
	Shift+Down_Key,			META+'>',
	Cancel_Key,			CNTRL+'G',
	Find_Key,			CNTRL+'S',
	Shift+Find_Key,			CNTRL+'R',
	Insert_Key,			CNTRL+'Y',
	Options_Key,			CNTRL+'D',
	Shift+Options_Key,		META+'D',
	Remove_Key,			CNTRL+'W',
	Shift+Remove_Key,		META+'W',
	Select_Key,			CNTRL+'@',
	Shift+Select_Key,		CTLX+CNTRL+'X',
	Interrupt_Key,			CNTRL+'U',
	Keypad_PF2,			META+'L',
	Keypad_PF3,			META+'C',
	Keypad_PF4,			META+'U',
	Shift+Keypad_PF2,		CTLX+CNTRL+'L',
	Shift+Keypad_PF4,		CTLX+CNTRL+'U',
	Keypad_1,			CTLX+'1',
	Keypad_2,			CTLX+'2',
	Do_Key,				CTLX+'E',
	Keypad_4,			CTLX+CNTRL+'B',
	Keypad_5,			CTLX+'B',
	Keypad_6,			CTLX+'K',
	Resume_Key,			META+'!',
	Control+Next_Scr_Key,		CTLX+'N',
	Control+Prev_Scr_Key,		CTLX+'P',
	Control+Up_Key,			CTLX+CNTRL+'P',
	Control+Down_Key,		CTLX+CNTRL+'N',
	Help_Key,			CTLX+'=',
	Shift+Do_Key,			CTLX+'(',
	Control+Do_Key,			CTLX+')',
	Keypad_0,			CTLX+'Z',
	Shift+Keypad_0,			CTLX+CNTRL+'Z',
	Main_Scr_Key,			CNTRL+'C',
	Keypad_Enter,			CTLX+'!',
	Exit_Key,			CTLX+CNTRL+'C',
	Shift+Exit_Key,			CNTRL+'Z'
};

#define lk_map_size	(sizeof(lk_map)/2)
#endif

/* Map functions onto internal pseudo keys (INTL values).
 * Terminated by a NULL entry.
 */
RMTAB	ismap[] = {
	{ ISI_RUBOUT,			backdel  },
	{ ISI_FORWARD,			fisearch },
	{ ISI_REVERSE,			risearch },
	{ ISI_ABORT,			ctrlg    },
	{ ISI_QUOTE,			quote    },
	{ ISI_UPLINE,			backline },
	{ ISI_DOWNLINE,			forwline },
	{ ISI_MOVE_DOWN,		mvdnwind },
	{ ISI_MOVE_UP,			mvupwind },
	{ ISI_MOVE_LEFT,		moveLeftWind },
	{ ISI_MOVE_RIGHT,		moveRightWind },
	{ ISI_REFRESH_SCREEN,		refreshScreen },
	{ 0,				(int(*)(int, Cnt))NULL }
};

/* end */
