/*
 * ADDW SCCS: @(#)edef.h	1.485 10/14/20 16:22:09
 */

/*	EDEF:		Global variable definitions for
			MicroEMACS 3.9e

			written by Dave G. Conroy
			modified by Steve Wilhite, George Jones
			greatly modified by Daniel Lawrence
*/

#include <stdlib.h>
#include <string.h>

/* Those from standard C library.
 * Not always available.
 */
#if	UNIX  == 0	/* May need to be a bit smarter for legacy platforms */
int		atoi(BYTE* st);
long		atol(BYTE* st);
void		exit();
void		free();
char*		getenv();
void		sleep();
char*		strcat();
char*		strcpy();
size_t		strlen();
char*		strncpy();
#endif

#if	MSC
char*		malloc();
#endif

#ifndef	abs
int		abs(int x);
#endif

/* These 2 functions don't need the lockfl argument if we don't
 * do file locking.
 * Their real names have a _ prepended.
 */
#if	FILOCK
#define	getfile(fname, lockfl)					_getfile(fname, lockfl)
#define	readin(fname,  lockfl, readTail, checkSave)		_readin(fname,  lockfl, readTail, checkSave)
#else
#define	getfile(fname, lockfl)					_getfile(fname)
#define	readin(fname,  lockfl, readTail, checkSave)		_readin(fname,  readTail, checkSave)
#endif

/* All global fuction declarations
 * Alphabetic order - case insensitive.
 */



int		addHistoryText(BUFFER* bp, const TEXT* text, int flags); /* Add TEXT to a history buffer */
int		addHistoryLine(BUFFER* bp, const BYTE* str, int flags);	/* Add string to a history buffer */
int		addLINE(const TEXT* text, BUFFER* bp, int u8clean);	/* Append a TEXT line to abuffer */
int		addline(const BYTE* str, BUFFER* bp, int u8clean);	/* Append a string to abuffer */
int		AddRetchar(BUFFER* bp);				/* Add \r to every line in the buffer */
int		AddWindowOpt(int f, Cnt n);			/* Add window specifc option */
int		adjustmode(int kind, int global, int f, Cnt n);	/* Change editor mode status */
void		adjustTopLineNum(BufLns inserted);		/* Fixup line # in other windows after line ins/del */
#if	RAMSIZE
BYTE*		allocate();					/* Malloc debugging */
#endif
int		allock(void);					/* Use in assert check of the malloc arena */
Window*		allocWindow(int ntrows, LineLn mslen);		/* Allocate a Window */
BUFFER*		alreadyHaveFile(BYTE* fname, char** reason);	/* Is fname already in a buffer */
int		anycb(void);					/* Return count of buffers changed */
#if	APROP
int		apro(int f, Cnt n);				/* apropos function */
#endif
void		AttribSet(void);				/* Write current attributes to the terminal */

int		backchar(int f, Cnt n);				/* Move backward by characters*/
int		backCharSeveral(int f, Cnt n);			/* Move backward several characters*/
int		backdel(int f, Cnt n);				/* Backward delete */
int		backhunt(int f, Cnt n);				/* hunt backwards for next match */
int		backline(int f, Cnt n);				/* Move backward a line */
int		backLineSeveral(int f, Cnt n);			/* Move backwards by several lines */
int		backpage(int f, Cnt n);				/* Move backward by pages */
int		backsearch(int f, Cnt n);			/* Search backwards */
int		backword(int f, Cnt n);				/* Backup by words */
int		BackWordMatch(const char* str);			/* Test if str is just before "." */
int		bDiscardOK(const BUFFER* bp);			/* Check if user wants changes discarded */
int		bclear(BUFFER* bp);				/* Blow away all text in a buffer */
void		bclearMarks(BUFFER* bp);			/* Blow away all marks in a buffer */
void		bel(void);					/* Quick, dirty, unbuffered - ring the bell - for debug use */
BUFFER*		bfind(const BYTE* bname, int cflag, int bflag);	/* Lookup a buffer by name */
BUFFER*		bfindCheck(BYTE* bname, int cflag);		/* bfind() & error message on fail */
BUFFER*		bfindFile(BYTE* bname, BYTE* fname);		/* bfindCheck() & read file in if needed */
int		bindProcToKey(int f, Cnt n);			/* Bind a procedure to a key */
int		bindtokey(int f, Cnt n);			/* bind a function to a key */
int		bindNbToKey(NBIND* bindp, KeyCode c);		/* Bind NBIND* to a key */
// #ifdef	SIGTSTP						/* USG as well as BSD these days */
int		bktoshell(int f, Cnt n);			/* suspend Emacs to parent shell*/
// #endif
void		bLinesFix(BUFFER* bp);				/* Fix a buffer's line count, "." and topLine */
KeyCode		bnexpand(const char* prompt, int dirn, Window* win);	/* Buffer name expansion */
void		botch(char* s);					/* Malloc debugging */
int		boundry(LINE* curline, LineLn curoff, int dir);	/* Test search boundary */
void		bquicksave(BUFFER* bp);				/* Quick/emergency save of a buffer */
LINE*		BufAppendLine(BUFFER* bp);			/* Append a line to a buffer */
int		buffertrim(int f, Cnt n);			/* trim lines from a buffer */
int		bufRegWrite(const char* prompt, int force, int flags); 	/* Write a buffer or region to a file */
int		buildlist(const char* mstring);			/* Build a binding list */
int		BuildProcInfo(BUFFER* bp);			/* Scan a buffer for procedure/macro info to cache */
MapCell*	BuildWindowMap(void);				/* Build map of windows on a screen */
char*		bytecopy(char* dst, const char* src, size_t maxlen);	/* Copy string, max len, always NUL terminate */

int		CacheStat(const BYTE* filename);		/* Stat file and cache result in statbuf */
TEXT*		CapsReplaceMangle(TEXT* replaceLine, wDesc fD);	/* Change replacement to match found string */
int		capword(int f, Cnt n);				/* Initial capitalize word */
void		catpath(TEXT* name, BYTE* comps[], BUFFER* bp, TEXT* newdir);	/* Make simplified path name */
int		cbuf(int f, Cnt n, int bufnum);			/* Execute the contents of a numbered buffer */
int		cbuf1(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf10(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf11(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf12(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf13(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf14(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf15(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf16(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf17(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf18(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf19(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf2(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf20(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf21(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf22(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf23(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf24(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf25(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf26(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf27(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf28(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf29(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf3(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf30(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf31(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf32(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf33(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf34(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf35(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf36(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf37(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf38(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf39(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf4(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf40(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf5(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf6(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf7(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf8(int f, Cnt n);				/* execute numbered comd buffer */
int		cbuf9(int f, Cnt n);				/* execute numbered comd buffer */
int		cex(void);					/* dummy function for binding to control-x prefix */
#if	CALLED
int		cexit(int status);				/* Clean exit - terminate Emacs - as a function */
#else
void		cexit(int status);				/* Clean exit - terminate Emacs */
#endif
int		changedir(int f, Cnt n);			/* Change directory */
int		changeWindowRows(Window* wp, int ntrows);	/* Change number of rows that a window displays */
int		checkage(int RenewModeOnly);			/* Check out of date buffers */
void		CheckAutoWidth(void);				/* Check wordwrap position depending on screen width */
int		CheckBufferRenew(BUFFER* bp);			/* Check & renew an out of date buffer */
int		CheckCanMoveUp(int page);			/* Check that there is a page/line above */
void		CheckCaselessSearch(void);			/* Check if to do caseless search */
void		CheckCMode(BUFFER* bp);				/* Check if a file is C or PHP - suffix */
void		CheckCursorHexSync(void);			/* Check if any window in HEX option */
void		CheckEveryCommand(void);			/* Debugging - called frequently */
void		CheckForScroll(Window* wp);			/* Check if a window has scrolled */
int		checkNewModes(BUFFER* bp, int newModes);	/* Check that newModes can be set on bp & un/set them */
int		checknext(BYTE* chr, TEXT* patrn, int dir);	/* Check character in search */
int		CheckNotInUtf8(void);				/* Chr cursor not inside UTF8 char */
void		checkNumberWidth(Window* wp);			/* Check/fix width of line numbers */
void		CheckRenewVisible(void);			/* Is a buffer in RENEW mode visible ? */
void		CheckSizes(void);				/* Check window sizes */
void		chkmode(BUFFER* bufp);				/* Check C/PHP modes not set with INDENT */
int		ChoseAnotherBuffer(void);			/* Choose a buffer and swap to it */
int		cinsert(void);					/* Insert a newline in C mode */
LineLn		CKeyMatch(LineLn Interesting);			/* Check for C keywords */
void		cleantag(TEXT* tag);				/* Clean up pattern in CTAGS */
void		ClearInodeInfo(BUFFER* bp);			/* Set bp's inode state to non-existing */
void		ClearOut(BYTE* line, int size);			/* Clear a buffer to spaces */
void		ClearProcInfo(BUFFER* bp);			/* Clear out proc hints & stuff */
int		clrmes(int f, Cnt n);				/* clear the message line */
void		cmdstr(KeyCode c, BYTE* seq);			/* Get printable version of command string */
int		c_modeset(BUFFER* bp, int set, int global, int f, Cnt n); /* Called before setting C mode */
int		commentRegion(int f, Cnt n);			/* Un/comment the current region */
void		ConnectBuffer(BUFFER* bp, Window* wp, int reConnect);	/* A buffer to a window */
int		copyregion(int f, Cnt n);			/* Copy region to kill buffer */
LineLn		countWhiteBytes(const TEXT* tp);		/* Number of space/tab at TEXT start */
int		createVariable(int varType);			/* Create a local/global variable */
#if	CRYPT
void		cryptBuffer(char* bptr, LineLn len);		/* en/de-crypt a buffer */
int		crysetkey(int f, Cnt n);			/* set encryption key */
#endif
int		cscan(int f, Cnt n);				/* repeat the previous getcscan	*/
int		cstrcmp(const BYTE* bfile, const BYTE* name);	/* Case-independent string comparison */
KeyCode		ctlu(KeyCode ch, int* displayit, int* reprocess);	/* Process ^U -> count */
KeyCode		ctlx(KeyCode ch, int* displayit, int* reprocess);	/* Process ^X Prefix -> command	*/
int		ctlxe(int f, Cnt n);				/* Execute macro */
int		ctlxlp(int f, Cnt n);				/* Begin macro */
int		ctlxrp(int f, Cnt n);				/* End macro */
int		ctoec(int c);					/* Cntrl character to CNTRL & printable */
int		ctrlg(int f, Cnt n);				/* Abort out of things */
void		curgoalSet(void);				/* Set w_goalCol & w_goalLeftoffset - for line movements */
int		cyclegbcolor(int f, Cnt n);			/* Cycle background colour */
int		cyclegfcolor(int f, Cnt n);			/* Cycle foreground colour */

int		deblank(int f, Cnt n);				/* Delete blank lines */
int		debug(BUFFER* bp, TEXT* eline, LineLn off, int* skipflag);	/* Interactive debugger */
int		DelMergeWindow(MapCell* map, int EdgeToMove);	/* Delete window, merge in specified direction */
int		delbword(int f, Cnt n);				/* Delete backward word */
int		delfword(int f, Cnt n);				/* Delete forward word */
int		delgMode(int f, Cnt n);				/* delete a global mode */
int		delins(LineLn dlength, TEXT* rep, int use_meta);/* Delete length and replace - search */
int		delMode(int f, Cnt n);				/* delete a mode */
int		delwind(int f, Cnt n);				/* delete the current window */
int		DelWindowOpt(int f, Cnt n);			/* Delete window specifc option */
int		desbind(int f, Cnt n);				/* describe bindings */
int		deskey(int f, Cnt n);				/* describe a key's binding */
#if	AEDIT
int		detab(int f, Cnt n);				/* detab rest of line */
int		detabRegion(int f, Cnt n);			/* Detab the region */
#endif
void		__NOT_RETURN(Die(BYTE* msg, ...));		/* Print a message and quit */
void		Die_a(void);					/* First part of Die() */
void		__NOT_RETURN(Die_b(void));			/* Last  part of Die() */
void		DisconnectBuffer(Window* wp);			/* Disconnect buffer from the window */
void		disp(KeyCode c);				/* Display char - command prompt */
void		dispc(BYTE* buf, KeyCode c);			/* Display count, prefix - command prompt */
void		displaySomething(void);				/* Fix show empty window */
void		DispModes(BYTE* line, int mode, int flag);	/* Put the mode letters in line */
int		dispvar(int f, Cnt n);				/* Display an environment or user variable */
int		dobuf(BUFFER* bp, VAL** retval);		/* Execute the contents of a buffer */
int		docmd(void);					/* Execute a string */
void		__NOT_RETURN(doExecl(const char* cmd, int sigDfl)); /* Execute a program, print error on failure */
int		dofile(BYTE* fname);				/* yank a file into a buffer and execute it */
int		dolhello(void);					/* Dummy function in lock module */
pid_t		doFork(void);					/* fork() with error message on fail */
int		DontReallyWantToScroll(int top, int bottom, int diff, int LnoAdj);	/* What is more costly ? */
int		doscan(void);					/* Move the cursor to a chosen one on a line */
void		DoSleep(unsigned int seconds);			/* Sleep with housekeeping */
void		DoScrolled(void);				/* Updated screen by scrolling */
int		dos_modeset(BUFFER* bp, int set, int global, int f, Cnt n);	/* When DOS mode is un/set */
int		do_tag(int f, VAL* tag);			/* CTAGS lookup */
char*		dolock(char* fname);				/* Creating lock file */
int		dspram(void);					/* Memory usage debugging */
Window*		dup_window_on_split(void);			/* Duplicate window, show same buffer */

int		ectoc(KeyCode c);				/* Return real char removing K_CODE_MASK */
void		edinit(char bname[]);				/* Initialise fundamental buffers, etc */
BYTE		EditSearchOpts(int opts);			/* Change search options */
int		emacs(int argc, char* argv[]);			/* Editor as a callable function */
int		enlargewind(int f, Cnt n);			/* Enlarge the current window */
int		EnlargeWindLeftRight(int n, MapCell* map, int obliterate, int right, int TestMovable); /* Enlarge window in specified direction */
int		EnlargeWindMsg(int res);			/* Print error after failed enlarge display window */
int		EnlargeWindUpDown(int n, MapCell* map, int obliterate, int bottom, int TestMovable); /* Enlarge window in specified direction */
void		EnsureCurbpConnectedToCurwp(void);		/* Reestablish the connection of curwp & curbp */
#if	AEDIT
int		entab(int f, Cnt n);				/* entab rest of line */
int		entabRegion(int f, Cnt n);			/* Entab the region */
#endif
int		eq(const BYTE* subc, const BYTE* patc);		/* Compare two characters - subject & pattern */
long		ernd(void);					/* Returns random number */
void		errormesg(const char *mesg, const BUFFER *bp, const LINE *lp);	/* Show macro error with buffer & line # */
void		ErrorWrite(const char* msg);			/* Write msg to file descriptor 2 */
void		ErrorWriteList(const char* msg, ...);		/* ErrorWrite() list of messages */
int		execbuf(int f, Cnt n);				/* exec commands from a buffer */
int		execcmd(int f, Cnt n);				/* execute a command line */
int		execfile(int f, Cnt n);				/* exec commands from a file */
int		execprg(int f, Cnt n);				/* execute a program */
#if	PROC
int		execproc(int f, Cnt n);				/* execute procedure */
#endif
int		execprog(const char* cmd);			/* Execute named program */
BYTE*		exp_twiddle(TEXT* fname, int promptLen);	/* Expand ~ in file name */

int		fexist(const char* fname);			/* Test that a file exists */
int		ffclose(void);					/* Close a file */
int		ffgetline(LINE** newline, int utf8);		/* Read a line from a file */
int		ffind_fun(const TEXT* key, TEXT* file, TEXT* patt, FILE* fp);	/* Search for function in tag file */
int		ffputline(const BYTE* buf, LineLn nbuf, int nonl, int DosLine);	/* Write a line to a file */
int		ffWriteRegion(REGION* reg);			/* Write the region to ffp */
int		ffropen(const char* fn);			/* Open a file for reading */
int		ffwopen(const char* fn, int append);		/* Open a file for writeing */
int		fileDoWrite(const BYTE* fname, int force, int flags);/* Write/write-append a buffer to a file */
int		fileappend(int f, Cnt n);			/* Append buffer to a file */
int		filefind(int f, Cnt n);				/* Get a file, read write */
int		filemode(const char* fn);			/* Return file mode - permissions */
int		filename(int f, Cnt n);				/* Adjust file name */
int		fileread(int f, Cnt n);				/* Get a file, read only */
char*		fileErrString(int s, int incompleteFlag);	/* Return error string from code s */
int		filesave(int f, Cnt n);				/* Save current file */
int		filewrite(int f, Cnt n);			/* Write a file */
void		FillMapRectangle(MapCell* Origin, int Lines, int Columns, int LineLength, MapCell Value); /* Colour a rectangle in window map */
#if	WORDPRO
int		fillpara(int f, Cnt n);				/* Fill current paragraph */
#endif
Window*		FindWinByMapno(int n);				/* Find a window */
void		FillWindowMap(MapCell* map, Window* wp, MapCell WindowNum); /* Fill in the window map for an individual window */
int		filterBuffer(int f, Cnt n);			/* filter buffer through command */
int		filterRegion(int f, Cnt n);			/* filter region through command */
int		find_fun(TEXT* key, TEXT* file, TEXT* patt, TEXT* dirn); /* Find the function in the tag file */
Window*		findAndFreeWp(Window* wp);			/* Find a window and remove it from the linked list */
int		FindCError(int f, Cnt n);			/* Find error in C source */
int		findcurtag(int f, Cnt n);			/* Take the current word as the tag to search for */
#ifdef	CTAGS
int		findtag(int f, Cnt n);				/* find tag from tags file */
#endif
int		findvar(TEXT* var, VDESC* vd, int size, int scope);	/* find a variable's type and name */
off_t		fileSize(const BYTE* fname);			/* Return size of file */
int		fill1para(void);				/* Fill the current paragraph */
int		filterLines(LINE* cmd, LINE* startLine, LINE* endLine); /* For filter-buffer and filter-region */
int		findFile(const BYTE* fname, findTypes type);	/* Find file in path dependent on type */
int		findFilePath(const char* path, const BYTE* fname, findTypes type); /* Find file in path provided */
char*		findNthNULstr(const TEXT* text, int nth);	/* Find the nth string in a set of NUL separated strings in text */
BUFFER* 	findProcedure(BYTE* procName);			/* Find a procedure - auto-load if needed */
#if	ISRCH
int		fisearch(int f, Cnt n);				/* forward incremental search */
#endif
void		FixOffsets(const LINE* lp, LineLn offset, LineLn inserted, BUFFER* bp, int BeforeMark);	/* Fix "." & marks after ins/dev bytes in a line */
void		FixWindowSizes(int lines, int columns);		/* Ensure window fits on screen */
BYTE*		flook(BYTE* fname, int hflag);			/* find a file along a path */
int		fmatch(int ch, int matchBeforeCpp);		/* Fence match */
NBIND*		fncmatch(const BYTE* cname);			/* Find Emacs command cname in CmdNames table */
#if	FLABEL
void		fnclabel(int f, Cnt n);				/* set function key label */
#endif
KeyCode		fnexpand(const BYTE* prompt, int dirn, int* errflag);	/* File name expansion */
int		forwchar(int f, Cnt n);				/* Move forward a character */
int		forwCharSeveral(int f, Cnt n);			/* Move forward several characters*/
int		forwdel(int f, Cnt n);				/* Forward delete */
int		forgetFilename(int f, Cnt n);			/* Forget the name of file associated with curbp */
int		forwhunt(int f, Cnt n);				/* hunt forward for next match */
int		forwline(int f, Cnt n);				/* Move forward by lines */
int		forwLineSeveral(int f, Cnt n);			/* Move forward by several lines */
int		forwpage(int f, Cnt n);				/* Move forward by pages */
int		forwsearch(int f, Cnt n);			/* Search forward */
int		forwword(int f, Cnt n);				/* Advance by words */
void		FreeLine(LINE* lp);				/* Free a line */
void		FreeText(TEXT* tp);				/* Free a text */
void		freeWp(Window* wp);				/* Free a window pointer */
int		FuncExec(const NBIND* Binding, int f, Cnt n);	/* Execute a function */

KeyCode		get1key(void);					/* Get one keystroke */
KeyCode		get_char(int raw);				/* Get next character from tty or command string */
NBIND*		getbind(KeyCode c, int helpOK);			/* looks up a key binding in the binding table */
LineLn		getccol(int bflg);				/* Get current display column */
LineLn		getccolAtCol(int bflg, LineLn pos);		/* Return display column for LINE position pos */
KeyCode		getckey(int mflag);				/* get a command key sequence from the keyboard */
LineLn		GetColAtPtr(const BYTE* cptr);			/* Get column number of a point in the current line */
BufLns		getcline(void);					/* get the current line number */
KeyCode		getcmd(KeyCode c, int* flag, Cnt* count);	/* Get command key handling Meta/^x/^u prefixes */
int		getCmdBindings(const char* cmd, TEXT* binds);	/* Get bindings for cmd */
int		getcscan(int f, Cnt n);				/* move to given char on line */
BYTE*		getctext(void);					/* grab and return a string with the text of the current line */
LineLn		getdcol(int Disp);				/* return current display column */
KeyCode		getDelayedKey(KeyCode ch, int* displayit);	/* Read prefixed key with delay in display */
int		GetDirection(KeyCode ch);			/* Convert direction keystroke to DIRECTION_xxx */
LineLn		getdiscol(const Window* wp, const LINE* lp, LineLn byteoffset, int wpCount); /* Get display column of byte offset in LINE */
LineLn		getdoto(const Window* wp, const LINE* lp, LineLn column, int CountMode);  /* Get byte offset of display column */
#if	CFENCE
int		getfence(int f, Cnt n);				/* move cursor to a matching fence */
#endif
int		getfile(BYTE fname[], int lockfl);		/* Prompt for and read a file in */
char*		getFileType(const char* file, char* ftype);	/* Find out what sort of file it is */
BYTE*		getfname(int (*const func)(int f, Cnt n));	/* Get command name that is bound to a function */
LineLn		getgoal(const LINE* dlp);			/* Get byte offset in LINE for desired column (goal) */
BYTE*		getkill(void);					/* Return string from kill buffer */
LineLn 		getlinenum(const BUFFER* bp, const LINE* sline);/* get the a line number */
BYTE*		getlinestr(LINE* lp);				/* Return string of text from current line */
NBIND*		getname(const char* prompt);			/* Get command name from command line */
LineLn		GetNonBlankCol(void);				/* Get first non white char in curr line */
BufLns		getNumLines(void);				/* Return the number of lines in the current buffer */
char*		getpath(char* filespec);			/* Locking function */
int		getregion(REGION* rp);				/* Find bounds of current region */
void		getRepDesc(wDesc* desc, TEXT* text);		/* Examine search, matched, replacement string */
int		getstring(const BYTE* prompt, VAL** value, int option, BUFFER* history); /* Prompt for a CLI string */
void		GetTermDims(void);				/* Read the screen size */
int		gettyp(const TEXT* token);			/* Find type of token */
VAL*		getval(TEXT* token);				/* Get the value of a token */
int		getVarValue(const char* vname, TEXT* vvalue);	/* Get the value of user or environment variable vname */
int		getwpos(void);					/* Get screen offset of current line in current window */
LineLn		GetWordCol(int joinedPunct);			/* Get position of first word on the current line */
int		global_var(int f, Cnt n);			/* declare a global variable */
int		gotobob(int f, Cnt n);				/* Move to start of buffer */
int		gotobol(int f, Cnt n);				/* Move to start of line */
#if	WORDPRO
int		gotobop(int f, Cnt n);				/* go to beginning/paragraph */
#endif
int		GotoColNumber(LineLn col);			/* Move "." to display column col */
int		gotocolumn(int f, Cnt n);			/* Go to a numbered column */
int		gotoeob(int f, Cnt n);				/* Move to end of buffer */
int		gotoeol(int f, Cnt n);				/* Move to end of line */
#if	WORDPRO
int		gotoeop(int f, Cnt n);				/* go to end/paragraph */
#endif
int		gotoline(int f, Cnt n);				/* Go to a numbered line */
int		GotoLineNumber(BufLns lnum);			/* Move "." to line lnum */
BYTE*		gtenv(const BYTE* vname);			/* Get value of environment var */
VAL*		gtfun(const BYTE* fname);			/* Evaluate a function */
char*		gtname(char* filespec);				/* Get name of lock file */
BYTE*		gtusr(const BYTE* vname);			/* Get value of user variable */
VAL*		gtusrCk(const BYTE* vname);			/* Get value of user variable - check got something */
VAL*		gtusrVAL(const BYTE* vname);			/* Get value of user variable */
void		gwd(void);					/* Get current working directory into cwDir */

int		hashAdd(hashSt* td, void* val, hashNx index);	/* Add new index to hash */
int		hashAlloc(hashSt* td, int slots);		/* Allocate the hash index */
void		hashEmpty(hashSt* td);				/* Make all hash index slots empty */
void		hashFree(hashSt* td);				/* Deallocate hash index */
int		hashInit(hashSt* td);				/* Initialise a hash */
void		hashInitBinds(void);				/* Initialise CmdNames hash */
void		hashInsTable(hashSt* td);			/* Insert/index a table into a hash */
hashNx		hashKeyCode(hashSt* td, const void* valp);	/* Compute a hash for a KeyCode */
int		hashKeyCodecmp(const void*a, const void*b);	/* Compare 2 pointers to keycode */
hashNx		hashLookup(hashSt* td, const void* valp);	/* Find a hashed entry */
hashNx		hashStr(hashSt* td, const void* valp);		/* Compute a hash for a char* */
int		hashStrcmp(const void* a, const void* b);	/* Commpare 2 pointers to char* */
int		hasSuffix(char* name, char* suffixes);		/* Does name end in one of the suffixes ? */
int		help(int f, Cnt n);				/* get the help file here */
void		helpAppendTmpl(BUFFER* hbp, const BUFFER* tmpl, char ltype); /* Append template lines to the help buffer */
int		helpAprbuf(void);				/* Show help on an Emacs command within apropos */
int		helpBufferMassage(void);			/* Process curbp so that it can be easily scanned */
int		helpCmdShow(const BYTE* cmd);			/* Display help for the Emacs command cmd */
int		helpKeyFind(const BYTE* dir, const BYTE* link, const BYTE* keyword); /* Read a help file and find a keyword in it */
int		helpKeyPrompt(int newHelp);			/* Prompt for search keys & show a list of matches */
LINE*		helpLineMassage(LINE* lp);			/* Changes to raw .help files so can show to the user */
int		helpLink(int f, Cnt n);				/* Follow a help Link */
int		helpLinkCommand(const BYTE* p, const BYTE* ep);	/* Do the work for a command like ||>close|| */
int		helpLoadFile(const BYTE* dir, const BYTE* name);/* Load a help file into the [Help] buffer */
BUFFER*		helpLoadIndex(const char* name);		/* Load all index files with name name */
int		helpNextPlace(int f, Cnt n);			/* Find the next place, any place will do */
void		helpParse_tnc(void);				/* Parse the t n c values in the top [Help Stack] entry */
int		helpPrevious(int f, Cnt n);			/* Go back to the previous help page viewed */
int		helpPreviousPlace(int f, Cnt n);		/* Find the previous place, any place will do */
void		helpPushStack(int Type, ...);			/* Push onto the end of [Help Stack] */
void		helpRestore_tnc(void);				/* Restore a previous window framing to what it used to be */
int		helpSearch(const BYTE* keywords);		/* Search all _keywords files */
int		helpSearchKeys(const char* keyword);		/* Find keyword in curbp */
int		helpSSchop(TEXT* l);				/* Chop a string at spaces into substrings */
int		helpStorePosition(void);			/* Store the t n c values in [Help Stack] */
BYTE*		helpSubstValue(LINE*lp, LineLn Off, struct sv_parm* parm); /* Substitute a value as part of help file massaging */

int		ifile(BYTE fname[]);				/* Insert from file into current buffer */
int		indent_modeset(BUFFER* bp, int set, int global, int f, Cnt n); /* Called before setting INDENT mode */
int		initkill(int f, Cnt n);				/* Initialise kill buffer */
int		indentFromPlay(int From2, LineLn Indent);	/* Insert contents of playText at "." */
int		indentLines(int f, Cnt n);			/* Indent n lines by buffer's tab size */
int		indentLns(Cnt tabs, BufLns lines);		/* Insert tabs TABs at the start of lines lines */
int		indentRegion(int f, Cnt n);			/* Indent a region n tab-stops */
int		insbrace(Cnt n, UniChar c);			/* Insert brace in C mode */
int		insChar(UniChar c, Cnt n);			/* Insert a character */
int		inscmd(int f, Cnt n);				/* pipe command into current buffer */
int		insfile(int f, Cnt n);				/* insert a file */
int		insHexChar(UniChar c, Cnt n);			/* Char insert - window hex option */
int		insHash(void);					/* Insert # - in C mode */
int		insspace(int f, Cnt n);				/* Insert a space forward */
int		InsSpec(int f, Cnt n, const char* act, int bits); /* Insert a character literally */
LineLn		insStrText(TEXT* tp, LineLn offset, const BYTE* text, LineLn textLen, int u8clean); /* Insert bytes into a TEXT */
int		insUnicode(int f, Cnt n);			/* Prompt & insert Unicode character */
int     	instab(int f, Cnt n);				/* insert a tab forward */
BYTE*		IntToAsc(long i);				/* Convert int to ASCII string */
int		invert(int f, Cnt n);				/* Invert case of char */
int		inword(void);					/* True if "." is in a word */
int		is_num(const char *st);				/* True if string is number */
int		isdir(const BYTE* fn);				/* True if fn is a directory */
int		IsDosBuffer(const BUFFER* bp);			/* True if buffer has \t at the end of every line */
int		isearch(int Direction);				/* Incremental search */
int		isInNarrow(LINE* line, char* notMessage, ...);	/* Line is in the narrow */
int		isnasty(const BYTE* file, char* ftype);		/* True if not to edit the file */
int		isSymlink(const char* name);			/* Tests if the file is a symbolic link */
int		istream(const BYTE* what);			/* Insert from a stream into current buffer */
int		istring(int f, Cnt n);				/* insert string in text */
void		iwCreate(void);					/* Make info window */

void		keeptrack(int (*const func)(int f, Cnt n), int f, Cnt n); /* Duplicate movement in track mode */
int		killbuffer(int f, Cnt n);			/* Make a buffer go away */
int		killmany(int f, Cnt n);				/* Make many buffers go away */
#if	WORDPRO
int		killpara(int f, Cnt n);				/* kill the current paragraph */
#endif
int		killregion(int f, Cnt n);			/* Kill region */
int		killtext(int f, Cnt n);				/* Kill forward */
int		kinsert(const BYTE* cp, int back);		/* Insert char into kill buffer */
int		kNewline(void);					/* Insert a new, empty line into the kill buffer */

void		l_changeNmark(NMARK* mark, LINE* nlp, LineLn noff); /* Change what a numeric mark refers to */
void		l_checkNmark(LINE* line);			/* Check if line still has a numeric mark */
void		l_unmark(BUFFER* bp, LINE* lp);			/* Remove alphabetic mark */
void		l_unNmark(BUFFER* bp, LINE* line);		/* Remove references to line as numeric mark */
LINE*		lalloc(LineLn used);				/* Allocate a line */
int		tcatm(TEXT* tdest, const BYTE* src, LineLn len);/* Append len bytes from src to tdest */
int		tcatc(TEXT* tdest, UniChar c);			/* Append c to tdest */
void		lchange(int flag);				/* Set window flags when a char is changed */
void		lckerror(char* errstr);				/* Report a lock error */
int		tcpyt(TEXT* tdest, const TEXT* tsrc);		/* Copy tsrc to tdest */
int		tcpym(TEXT* tdest, const BYTE* src, LineLn len);/* Copy len bytes from src to tdest */
int		ldelnewline(void);				/* Delete a newline */
int		ldelete(BufChrs n, int kflag);			/* Delete chars starting at "." */
LINE*		lfakem(LINE* ln, const BYTE* m, LineLn len);	/* Make a fake LINE */
LINE*		lfakes(LINE* ln, const BYTE* str);		/* Make a fake LINE from a string */
void		lfree(BUFFER* bp, LINE* lp);			/* Free a LINE */
TEXT*		textToLower(TEXT* to, const TEXT* from);	/* Convert alphabetics in text from to lower case */
TEXT*		textToTitle(TEXT* to, const TEXT* from);	/* Convert alphabetics in text from to Title case */
TEXT*		textToUpper(TEXT* to, const TEXT* from);	/* Convert alphabetics in text from to UPPER case */
int		textMoreBytes(TEXT* lp, LineLn BytesNeeded);	/* Ensure a TEXT can contain enough bytes */
void		LinkBindings(void);				/* Startup: puts NBIND* into bindings table */
int		linsert(BufChrs n, UniChar c);			/* Insert a char n times at "." */
int		tinst(TEXT* tdest, LineLn offset, const TEXT* src);	/* Insert TEXT src at offset in tdest */
int		tinsm(TEXT* tdest, LineLn offset, const BYTE* src, LineLn len);	/* Insert len bytes from src at offset in tdest */
int		tinss(TEXT* tdest, LineLn offset, const BYTE* src);	/* Insert string from src at offset in tdest */
int		linTEXT(const TEXT* instr);			/* Insert TEXT at "." */
int		linstr(const BYTE* instr);			/* Insert a string at "." */
int		listbuffers(int f, Cnt n);			/* Display list of buffers */
void		ListCommands(int bindings);			/* List available commands/bindings to stdout */
void		ListKeys(void);					/* List available terminal keys to stdout */
int		lnewline(int Force);				/* Insert a newline at "." */
int		local_var(int f, Cnt n);			/* declare a local variable */
int		lock(char* fname);				/* Lock a file */
int		lockchk(char* fname);				/* Check a file for locking */
int		lockrel(void);					/* Release a lock */
int		lover(const LINE* ostr);			/* Overwrite a string at "." */
int		lowerregion(int f, Cnt n);			/* Lower case region */
int		lowerword(int f, Cnt n);			/* Lower case word */
int		lowrite(UniChar c);				/* Overwrite a char at "." */
BYTE*		ltos(int val);					/* Convert bool to string representation */
BYTE*		ltoyn(int val);					/* Convert bool to "yes"/"no" */
LINE*		lunstitch(LINE* ln);				/* Remove a line from the list of lines in a buffer and free it */

int		macarg(VAL** tok);				/* Get a macro line argument */
int		macFnStat(VAL* result, VAL* filename);		/* Macro function &stat */
int		makelist(int iflag);				/* Build buffer list + misc info for display */
BYTE*		makename(BYTE fname[]);				/* Make buffer name from file name */
int		mapkey(int f, Cnt n);				/* Map a key onto another */
UniChar		mapInterpKey(const char* prompt);		/* Read UniCode char for key mapping */
void		mapinit(void);					/* Initialise the mapping table */
void		MapPrint(MapCell* map);				/* Debug: Print window map table */
void		markmark(Window* wp);				/* Show the mark on the screen */
int		match_pat(const TEXT* patrn);			/* Used in isearch */
LineLn		MatchIndent(int c);				/* Find indent of opening brace */
void		mcclear(void);					/* search: clear CCL bitmaps */
int		mcscanner(const MC* mcpatrn, int direct, int beg_or_end); /* search for meta-pattern */
int		memcasecmp(void* a, void* b, size_t n);		/* Compare n bytes case insensitive */
void		memocpy(char* to, const char* from, size_t len);/* Copy overlapping bytes - with propagate */
void		memrcpy(char* to, const char* from, size_t len);/* Copy overlapping bytes - with propagate */
BYTE*		memrev(BYTE* mem, size_t len);			/* Reverse order of bytes */
KeyCode		metaPrefix(KeyCode ch, int* displayit, int* reprocess);	/* Process M- Prefix -> command */
int		meta_quote(int f, Cnt n);			/* Or 0x80 & insert literal */
int		metadummy(void);				/* dummy function for binding to meta prefix */
int		mk_wcwidth(wchar_t ucs);			/* ucs is wchar_t - but we always pass UniChar */
int		MkProcInfo(BUFFER* bp);				/* Allocate a buffer's b_procinfo */
BYTE*		mklower(BYTE* str);				/* Make string lower */
BYTE*		mkupper(BYTE* str);				/* Make string upper */
void		mlappend(const BYTE* mess, int pretty, const BYTE* syserr); /* Append string to existing message */
void		mlerase(void);					/* Erase message line */
KeyCode		mlerr(const BYTE* errmess, const BYTE* syserr);	/* Append an error string to message */
void		mlferase(void);					/* Force erase the message line */
void		mlFlush(void);					/* Force the message line out */
void		mlforce(const CHAR* fmt, ...);			/* Display message even if $discmd */
KeyCode		mlGetKey(int flags, const BYTE* toStr, const char* fmt, ...); /* Prompt in the message line and read a single character from input */
KeyCode		mlvGetKey(int flags, const BYTE* toStr, const char* fmt, va_list ap); /* Cnt pointer version of mlGetKey() */
void		mlNormalPallet(void);				/* Set the pallet for the message line to normal */
int		mlprompt(const BYTE* prompt, int option, BUFFER* history); /* Get string from message line or macro */
int		mlputc(CHAR c, CHAR* buf);			/* Put char on message line */
int		mlputf(int s, CHAR* buf);			/* Put scaled integer */
int		mlputi(int i, unsigned int r, CHAR* buf);	/* Put integer -- these days a macro */
int		mlputli(long l, unsigned int r, CHAR* buf);	/* Put long integer */
int		mlputp(void* l, char* buf);			/* Put pointer */
int		mlputs(CHAR* s, CHAR* buf);			/* Put string */
int		mlreply(const BYTE* prompt, VAL** buf, int option, BUFFER* history); /* Prompt & read reply */
void		mlSappend(const BYTE* str);			/* Append a string to the message line */
void		mlwrite(const CHAR* fmt, ...);			/* Write message */
int		mlyesno(const char* fmt, ...);			/* Ask a yes/no question */
KeyCode		mnexpand(const ModeDef* Opts, const BYTE* prompt, int dirn, int* errflag); /* Expand a mode */
void		modeline(Window* wp);				/* Redisplay window's mode line */
int		ModeMatch(const ModeDef* Opts, const BYTE* buf, int len, int dirn, int index); /* Match a mode */
void		mode_putc(Window* wp, UniChar c);		/* Special putc() for mode stuff */
Time_T		modtime(const BYTE* fname);			/* Get file modification time */
int		moveBack(LineLn n);				/* Move "." backwards n chars */
void		movecursor(int row, int col);			/* Position cursor on screen */
int		moveDown(BufLns nlines);			/* Move "." down nlines */
int		moveForw(LineLn n);				/* Move "." forward n chars */
int		movefunc(int f, Cnt n);				/* Find start of C function */
int		moveDownWinSev(int f, Cnt n);			/* Move the window's view onto the buffer several lines down */
int		moveHorizSeveral(Cnt n, int(*mv)(int f, Cnt n));/* Implement forwCharSeveral() & backCharSeveral() */
int		moveLeftWind(int f, Cnt n);			/* Move window left */
int		moveLeftWinSev(int f, Cnt n);			/* Move the window's view onto the buffer several columns left */
int		moveRightWind(int f, Cnt n);			/* Move window right */
int		moveRightWinSev(int f, Cnt n);			/* Move the window's view onto the buffer several columns right */
int		MoveToWindow(int Direction);			/* Move to window in Direction */
int		MoveToWindowUp(int f, Cnt n);			/* Move to window above */
int		MoveToWindowDown(int f, Cnt n);			/* Move to window below */
int		MoveToWindowLeft(int f, Cnt n);			/* Move to window to the left */
int		MoveToWindowRight(int f, Cnt n);		/* Move to window to the right */
int		moveUp(BufLns nlines);				/* Move "." up nlines */
int		moveUpWinSev(int f, Cnt n);			/* Move the window's view onto the buffer several lines up */
int		moveVertSeveral(Cnt n, int(*mv)(int f, Cnt n));	/* Do the work of forwLineSeveral() backLineSeveral() */
void		msglClear(void);				/* Clear the message line */
void		msglCpos(int col);				/* Cursor position */
void		msglFlush(void);				/* Flush before input */
void		msglGarbage(void);				/* Call this to say that the contents of message line are unknown */
void		msgPop(int showMsg);				/* Move up a line in message window */
void		msgPush(int rep);				/* New line in message window */
void		msgWrite(const CHAR* fmt, va_list ap);		/* Format & write to [Message Line] */
int		mvdnwind(int f, Cnt n);				/* Move window down */
int		mvupwind(int f, Cnt n);				/* Move window up */

int		narrow(int f, Cnt n);				/* Change commands only on part of the buffer */
int		namebuffer(int f, Cnt n);			/* rename the current buffer */
int		namedcmd(int f, Cnt n);				/* execute named command */
int		newline(int f, Cnt n);				/* Insert LF */
int		newlineAndIndent(int f, Cnt n);			/* Insert LF, then indent */
int		newlineMaybeIndent(int f, Cnt n);		/* Insert LF, then unless INDENT mode indent */
int		newsize(int f, Cnt n);				/* change the current screen size */
int		newwidth(int f, Cnt n);				/* change the current screen width */
int		nextarg(const BYTE* prompt, VAL** tok, int option, BUFFER* history); /* Next from prompt/input */
int		nextbuffer(int f, Cnt n);			/* switch to the next buffer */
KeyCode		NextCommand(void** pos, int dirn, const BYTE* prompt);	/* Find next Emacs command */
KeyCode		NextEnvVarName(void** pos, int dirn, const BYTE* prompt); /* Find next enviroment variable */
void		NextTag(const char* prompt, int dirn);		/* Display next CTAG */
KeyCode		NextUserVarName(void** pos, int dirn, const BYTE* prompt);	/* Find next user variable */
KeyCode		NextVarName(void** pos, int dirn, const BYTE* prompt);	/* Find next variable */
int		nextwind(int f, Cnt n);				/* Move to the next window */
int		NlReplaceMangle(TEXT* replaceLine, wDesc fD);	/* Insert newlines into replacement string */
int		nocrypt(void);					/* Dummy crypt function */
LineLn		nonCommentLength(const LINE* line);		/* Return the length of line, before any comment */
int		NotUnJoinedPunctuation(LineLn wp, LineLn* movedBy);	/* Check if what follows "." is not unjoined punctuation */
void		NoteEdgeChange(int Row, int Col);		/* Note window edge decoration is different */
BYTE*		num_to_onoff(const BYTE* value);		/* Convert boolean to string on/off */
int		nullproc(int f, Cnt n);				/* does nothing... */

int		oHorizWinfil(int f, Cnt n);			/* Split horizontally, new file in 2nd window */
int		onlywind(int f, Cnt n);				/* Make current window only one */
int		onoff_to_num(VAL** value);			/* Parse string on/off to int */
int		openPossGz(const BYTE* fname);			/* Open possibly gzipped file */
int		OpenSaveFile(const BYTE* fname);		/* Look for & open save file */
Window*		onscreen(const BUFFER* bp);			/* Find Window displaying a buffer */
int		openline(int f, Cnt n);				/* Open up a blank line */
int		openSave(const BUFFER* bp, const char* h, const char* dir);	/* Open an emergency save file */
int		ovstring(int f, Cnt n);				/* overwrite a string */
int		owinbuf(int f, Cnt n);				/* Put buffer into other window	*/
int		owinfil(int f, Cnt n);				/* Get file, r/w into 2nd window */

int		pamark(int f, Cnt n);				/* place alphabetic mark */
void		pnmark0(void);					/* Place numeric mark 0 at "." */
void		pnmark1(void);					/* Place numeric mark 1 at ".", rotate others */
int		parse_tag(FILE* fp, TEXT* func, TEXT* file, TEXT* patt);	/* Parse CTAGS line */
short		ParseGline(const char* num);			/* Parse command line +nn.cc */
VAL**		parseStructVar(VAL* value, int left);		/* Parse array-index/hash-key */
int		php_modeset(BUFFER* bp, int set, int global, int f, Cnt n); /* Called before setting PHP mode */
int		pi_close(void);					/* Close pipe open on ffp */
int		pi_open(const char* cmd, const char* mode, int io_fd);	/* Open a pipe command */
int		PipeToCommand(int f, Cnt n);			/* Pipe buffer/narrow to shell command */
int		pipecmd(int f, Cnt n);				/* pipe command into buffer */
int		placeChar(Window* wp, LINE* lp, LineLn loff, UniChar ch, int pen); /* Ephemerally put a character in a window */
void		placeCharPos(Window* wp, int lno, int loff, UniChar ch, int pen); /* Ephemerally put a character in a window */
BUFFER*		prevbuf(const BUFFER* pbuf);			/* Find previous buffer */
int		prevwind(int f, Cnt n);				/* Move to the previous window */
const BYTE*	prevword(const BYTE* buf, const TEXT* text);	/* Find previous NUL separated word */
int		printToText(TEXT* text, const CHAR* fmt, ...);	/* Formatted print to a TEXT */
NBIND*		procFind(BYTE* name, int create);		/* Look in ProcNames for stored procedure */
void		promptpattern(void);				/* prompt for I-Search string */
void		pushNmark(void);				/* Rename numeric mark 0 as 1, ... */
int		putctext(const BYTE* iline);			/* Replace text in line with string */
void		putline(int row, int col, CHAR buf[]);		/* Put line Rainbow display */
void		putnpad(const char* str, int n);		/* Put padded string */
void		putpad(const char*str);				/* Put terminal control string */

int		qreplace(int f, Cnt n);				/* search and replace w/query */
int		quickexit(int f, Cnt n);			/* low keystroke style exit */
int		quit(int f, Cnt n);				/* Quit */
int		quote(int f, Cnt n);				/* Insert literal */

int		readFD(int readTail);				/* Read from ffp into the current buffer */
int		rdonly(const NBIND* binding);			/* Say a file is read only */
int		readInactive(void);				/* Fill a buffer that has deferred read */
int		readin(const BYTE* fname, int lockfl, int readTail, int checkSave); /* Read a file into buffer */
int		readStream(const char* bname, const char* fname, int append); /* Read a stream into a buffer named bname */
void		ReconnectWindowsToBuffer(BUFFER* bp);		/* Do after major buffer update */
void		RecordDotAndMark(BufPos* pos, const LINE* startl, const LINE* endl); /* Save at *pos */
void		readword(FILE* fp, TEXT* buf);			/* CTAGS read a word from file */
int		reapChild(pid_t pid);				/* Wait for pid to die */
int		reframe(Window* wp);				/* Mark window for complete refresh */
int		refreshScreen(int f, Cnt n);			/* Refresh the screen */
int		regionwrite(int f, Cnt n);			/* Write the region to a file */
int		release(char* mp);				/* Debug: track free memory */
int		relink(const char* fname);			/* Relink a file */
int		RemoveRetchar(BUFFER* bp);			/* Remove \r from buffer lines */
int		renew(int f, Cnt n);				/* renew a buffer */
int		renew_modeset(BUFFER* bp, int set, int global, int f, Cnt n); /* When RENEW mode is set/unset */
int		renewbuf(BUFFER* bp, int readTail);		/* renew a buffer */
void		ReDraw(void);					/* Mark everything out of date; update */
void		RePaint(void);					/* Call after ^Z suspend */
void		ReportRead(const char* act, int s, BufLns lines); /* To be used after read/insert */
int		reposition(int f, Cnt n);			/* Reposition window */
int		resetkey(int verify);				/* Reset encryption key */
int		resize(int f, Cnt n);				/* resize current window */
int		respawn(int doPrompt);				/* Prompt & run shell command */
int		resterr(const NBIND* binding);			/* Write: command restricted error */
void		RestInit(void);					/* Init shell & shell_name */
void		RestoreDotAndMark(BufPos* pos, const LINE* startl, const LINE* endl); /* Restore from *pos */
void		RestoreSearchOpts(short opts);			/* From a history line */
int		restwnd(int f, Cnt n);				/* restore current window */
int		retamark(int f, Cnt n);				/* return to alphabetic mark */
int		retmark0(int swap);				/* Set "." to mark 0 - if it is set */
KeyCode		ReverseMap(KeyCode c);				/* Return string that shows function binding */
int		reyank(int f, Cnt n);				/* Reyank from killbuffer */
#if	ISRCH
int		risearch(int f, Cnt n);				/* reverse incremental search */
#endif
void		rmcclear(void);					/* Search: free up strings */
// #ifdef	SIGTSTP						/* USG as well as BSD these days - always do prototype */
int		rtfrmshell(void);				/* return from a suspended state*/
// #endif
void		rvstrcpy(BYTE* rvstr, const BYTE* str);		/* Reverse string copy */

void		sanitiseColours(void);				/* Check that the colours used make sense */
int		savemany(int f, Cnt n);				/* Save many buffers */
void		savematch(TEXT* saveto);			/* search: save pattern */
void		SaveWindowPosToBuffer(BUFFER* bp, Window* wp);	/* Save window "." and mark to buffer */
int		savewnd(int f, Cnt n);				/* save current window */
void		sayEndOf(void);					/* Tell that end of buffer/narrow reached */
void		sayLinks(void);					/* Tell if link count > 1 or is symbolic link */
void		sayTopOf(void);					/* Tell that start of buffer/narrow reached */
int		scanmore(TEXT* patrn, int dir);			/* isearch: find next */
int		scanner(TEXT* patrn, int direct, int beg_or_end); /* search for pattern */
int		scrnxtdw(int f, Cnt n);				/* scroll next window down */
int		scrnxtup(int f, Cnt n);				/* scroll next window back */
int		SelectTag(void);				/* Get user to choose which of multiple tags */
int		SelfInsert(int f, Cnt n);			/* Insert a character into the buffer */
int		setBufferName(const BYTE* str);			/* Set the name of the current buffer */
int		setccol(LineLn pos);				/* Set current cursor column */
void		setcmode(int value);				/* Init: set C mode on buffers from command line */
void		setCursorAttr(Window* wp, VidAttr pen, int find); /* Colour the cursor in window wp using pen */
void		SetBrush(VidAttr want);				/* Set physical brush colour/... */
int		setfillcol(int f, Cnt n);			/* Set fill column */
CHAR*		setFnames(BUFFER* bp, const CHAR* fname);	/* Set stored buffer file name to fname */
int		setgMode(int f, Cnt n);				/* set a global mode */
void		setScreenSizeForMap(int lines, int columns);	/* Determine size needed for window map */
int		setmark(int f, Cnt n);				/* Set mark */
int		setMode(int f, Cnt n);				/* set an editor mode */
int		SetToCol(LineLn target);			/* Move "." to target column */
int		setUserVar(BYTE* var, const BYTE* value);	/* Set $something to value */
int		setvar(int f, Cnt n);				/* set a variables value */
void		setVisibleFname(BUFFER* bp, const CHAR* fname);	/* Set a file name to be shown for the buffer - but only for show */
int		SetWindowOption(int add);			/* Set an option on a window */
void		SkipBackOverSpace(void);			/* Backspace to white space */
const BYTE*	sh_meta(const BYTE* fname);			/* Find shell meta character - file expansion */
int		shellprog(char* cmd);				/* Execute a command in a subshell */
int		showcpos(int f, Cnt n);				/* Show the cursor position */
void		showit(int ln);					/* Debug only - display debug */
int		showlist(BUFFER* dispbp);			/* Show list of active buffers */
int		showMarks(int f, Cnt n);			/* Show alpha & numeric marks */
void		ShowMatchingBrace(void);			/* Show opening brace, pause, return */
void		ShowModes(const char* explan, const ModeDef* Opts, int modes);	/* Show current buffer-modes/window-options */
int		showmods(int f, Cnt n);				/* Show module versions */
int		shrinkwind(int f, Cnt n);			/* Shrink window */
#if	BSD_UNIX
void		sigeat(void);					/* General signal handler */
#else
void		sigeat(int sig);				/* General signal handler */
#endif
int		sindex(const TEXT* source, const TEXT* pattern);/* Find string within string case insensitive */
int		signedForwline(Cnt n);				/* Move up/down the buffer by n lines */
int		SortWindows(void);				/* Sort internal order to reflect screen position */
void		spal(char* pal);				/* Display specific - colour pallets */
int		spawn(int f, Cnt n);				/* Run a command in a subjob */
int		spawncli(int f, Cnt n);				/* Run CLI in a subjob */
int		splitwind(int f, Cnt n);			/* Split current window in best way */
int		splitwindvert(int f, Cnt n);			/* Split current window top/bottom */
int		splitwindhoriz(int f, Cnt n);			/* Split current window left/right */
int		splitwindhorizbuf(int f, Cnt n);		/* Split window top/bottom prompt for buffer */
int		sreplace(int f, Cnt n);				/* search and replace */
int		startup(const BYTE* sfname);			/* Execute startup file */
KeyCode		stock(const BYTE* keyname);			/* String name to command key */
int		stol(const BYTE* val);				/* String to boolean */
int		storemac(int f, Cnt n);				/* store text for macro */
#if	PROC
int		storeproc(int f, Cnt n);			/* store names procedure */
#endif
char*		strinsstr(char* to, const char* from);		/* Strcpy but no NUL termiate */
char*		strocpy(char* to, const char* from);		/* Overlapped string copy */
void		strtrunc(BYTE* str, int len);			/* NUL truncate a string to len */
BYTE*		strmake(const BYTE* string);			/* Malloc copy of string */
BYTE*		strmake_t(const BYTE* string);			/* Malloc copy of string - fail on OOM */
BYTE*		strfmake(BYTE** newstr, const BYTE* string);	/* Malloc copy of string, store/replace *newstr */
int		strinc(BYTE* source, BYTE* sub);		/* Find string within string */
BYTE*		strrev(BYTE* str);				/* Reverse the order of bytes in string */
char*		strsstrs(const char* srch, const char* subj, int subjLen);	/* Determine if any of a set of strings is in another set of strings */
int		svar(VDESC* var, const VAL* value);		/* Set a variable */
int		swapmark(int f, Cnt n);				/* Swap "." and mark */
int		swbuffer(BUFFER* bp);				/* Make bp current buffer, maybe read in */
int		swbufferPrompt(int f, Cnt n, int(*split)(int f, Cnt n)); /* split window, switch buffer */
void		synccursor(void);				/* Track cursor between windows - hex option */

int		tab(int f, Cnt n);				/* Insert tab */
int		tabMangle(int insTab, Cnt n);			/* Do work of entab/detab */
int		tabMangleRegion(int insTab);			/* Do work of entabRegion/detabRegion */
void		TagDispInit(const char* prompt);		/* CTAGS - show initial prompt */
void		tagerr(const BYTE* tagname);			/* CTAGS - can't find tag */
TEXT*		talloc(LineLn used);				/* Allocate a TEXT - not in a LINE */
int		tcatc(TEXT* tdest, UniChar c);			/* Append c to tdest */
int		tcats(TEXT* tdest, const BYTE* src);		/* Append src to tdest */
int		tcatt(TEXT* tdest, const TEXT* tsrc);		/* Append tsrc to tdest */
int		tdeln(TEXT* text, LineLn offset, LineLn len);	/* Delete len bytes at offset in text */
int		tinsc(TEXT* tdest, LineLn offset, UniChar c);	/* Insert a character c at offset in tdest */
int		tcpyc(TEXT* tdest, UniChar c);			/* Copy c to tdest - clear first */
int		tcpys(TEXT* tdest, const BYTE* src);		/* Copy NUL terminated string src to tdest */
void		termcapRead(int CheckSufficient);		/* Read the termcap/terminfo database */
int		test_emacs(int f, Cnt n);			/* Current development test hook */
int		textcmp(const TEXT* t1, const TEXT* t2);	/* Compare 2 TEXTs for equality */
TEXT*		tfakem(TEXT* ln, const BYTE* m, LineLn len);	/* Make a fake TEXT */
TEXT*		tfakes(TEXT* ln, const BYTE* str);		/* Make a fake TEXT from a string */
int		ToggleInsertMode(int f, Cnt n);			/* Toggle buffer's overwrite flag */
int		token(TEXT* tok);				/* Get token from input */
int		topbot(int f, Cnt n);				/* Move to top or end of buffer */
BYTE*		transbind(const BYTE* skey);			/* String key name to binding name */
#if	AEDIT
int		trim(int f, Cnt n);				/* trim whitespace from end of line */
int		trimRegion(int f, Cnt n);			/* trim whitespace from end of lines in the region */
#endif
BufLns		trimbuffer(BUFFER* bp, BufLns lines);		/* Remove excess lines from buffer */
void		trimstr(TEXT* res, TEXT* str);			/* Trim whitespace off the end of a string */
int		tsetNUL(TEXT* tp);				/* Set NUL on a TEXT */
void		ttclose(void);					/* Close the terminal */
void		ttcondclose(int act);				/* Close the terminal if it has been opened */
int		ttflush(void);					/* Flush output to terminal */
KeyCode		ttgetc(long timeout);				/* Get character from terminal */
int		ttopen(void);					/* Open the terminal */
#if     AMIGA
int		ttputc(char c);					/* Put a char (byte) to terminal */
#else
int		ttputc(int c);					/* Put a char (byte) to terminal */
#endif
void		ttputs(const char* str);			/* put NUL terminated string to terminal */
void		ttputs_noNA(const char* str);			/* ttputs() but do not flush attributes first */
void		ttreopen(int kopen);				/* Reopen the terminal */
void		ttrim(TEXT* t);					/* Trim spaces, start/end */
KeyCode		ttungetc(KeyCode key);				/* Push a character back to keyboard */
int		twiddle(int f, Cnt n);				/* Twiddle (swap) characters */
int		typahead(int alwaysCheck);			/* Check if char waiting to be read */

int		unarg(void);					/* dummy function for binding to universal-argument */
int		unbindchar(KeyCode c);				/* Unbind a command key */
int		unbindkey(int f, Cnt n);			/* unbind a key's function */
int		unindentLines(int f, Cnt n);			/* Unindent n lines by buffer's tab size */
int		unindentLns(Cnt tabs, BufLns lines);		/* Remove tabs leading TABs for lines lines */
int		unidentRegion(int f, Cnt n);			/* undent/unindent/outdent a region n tab-stops */
int		unlock(char* fname);				/* Lock dummy */
int		unmark(int f, Cnt n);				/* unmark current buffer */
void		unmarkmark(Window* wp);				/* Remove coloured mark */
void		updall(Window* wp);				/* update all the lines in a window on the virtual screen */
void		update(int force);				/* Update the screen */
void		updateEdges(void);				/* Paint window edge decorations */
void		updedge(Window* wp);				/* Update window edge */
int		updateline(int row, int force);			/* Update the physical screen from the virtual one */
void		updatedotpos(Window* wp);			/* Ensure window can display "." */
void		updline(Window* wp, LINE* lp, int sline);	/* Update the line lp in window wp */
void		updgar(void);					/* Update whole screen */
void		UpdateMetaData(BUFFER* bp, const char* fname);	/* Update bp's inode information from file fname */
int		UnboundKey(int f, Cnt n);			/* Handle unbound keys */
int		undo(int f, Cnt n);				/* Undo change to buffer */
char*		undolock(char* fname);				/* Unlock */
void		updone(Window* wp);				/* update the current line to the virtual screen */
void		updupd(int force);				/* update the physical screen from the virtual screen */
void		upmode(BUFFER* bp, int flag);			/* update all mode lines */
int		upperregion(int f, Cnt n);			/* Upper case region */
int		upperword(int f, Cnt n);			/* Upper case word */
int		upscreen(int f, Cnt n);				/* force screen update */
int		usebuffer(int f, Cnt n);			/* Switch a window to a buffer */
void		Utf8Init(void);					/* Check $LANG, set gmode & try_utf8 */
void		utf8_ensurePosStart(BUFFER* bp, int EvenIfNotU8); /* Ensure "." & marks not in middle of multibyte character */
BYTE*		utf8_strfmake(BYTE** str, const BYTE* string);	/* utf8_strmake(), freeing old pointer */
BYTE*		utf8_strmake(const BYTE* string);		/* Return malloced NUL term, made UTF8 safe */
BYTE*		utf8_strmake_t(const BYTE* string);		/* utf8_strmake() but aborts if OOM */
void		uv_clean(UTABLE* ut);				/* discard the contents of a user variable table */
void		uv_init(UTABLE* ut);				/* initialize the entries in one user variable table */
int		UxGetChar(long timeout);			/* Read into tty input buffer */

VAL*		valIntToVAL(long l);				/* Create an INT VAL with value l */
void		valArrayPush(VAL* vp, VAL* newItem);		/* Push newItem to the end of an array */
void		valArraySize(VAL* vp, int elems);		/* Change array size */
void		valChangeType(VAL** vp, int type);		/* Change vp to be of type type */
void		valCopy(VAL** dest, VAL* src);			/* Copy src to dest */
int		valCopyValue(VAL** dest, VAL* src);		/* Copy src to dest convert to type of dest */
int		valFindRefs(VAL* top, VAL* scan);		/* Find references to top under scan */
void		valFree(VAL* vp);				/* Free a value */
VAL*		valGet(int type);				/* Get somewhere to keep a value */
VAL**		valHashAdd(VAL* vp, VAL* key, VAL* value);	/* Add {key, value} to hash vp */
VAL**		valHashAddKs(VAL* vp, char* key, VAL* value);	/* Add {key, value} to hash vp */
VAL**		valHashFind(VAL* vp, VAL* key, int create);	/* Find key in hash vp */
void		valHashSize(VAL* vp, int elems);		/* Change allocated elements to elems */
VAL*		valNewRef(VAL* src);				/* Return a new reference to src */
VAL*		valPrint(VAL* vp);				/* Return printable version of vp */
void		valRelease(VAL* vp);				/* No longer need the VAL */
VAL*		valStrClone(VAL* src);				/* Return a distinct copy of STR str */
VAL*		valStrToVAL(const BYTE* str);			/* Create a STR VAL containing str */
int		valToBool(VAL* vp);				/* Deduce a FALSE/not-FALSE value for vp */
VAL*		valToInt(VAL* vp);				/* Return new VAL* that is integer */
void		valTypeInit(VAL* vp, int type);			/* Set up vp for type */
void		varclean(UTABLE* ut);				/* discard the contents of a user variable table */
void		varinit(void);
int		view_modeset(BUFFER* bp, int set, int global, int f, Cnt n); /* When VIEW mode is set/unset */
int		viewfile(int f, Cnt n);				/* find a file in view mode */
int		vprintToText(TEXT* text, const CHAR* fmt, va_list ap);/* See printToText() */
void		vteeol(Window* wp, VideoC ch, VidAttr at);	/* Erase to line end in virtual screen */
void		vtfree(void);					/* Free video structures */
void		vtinit(int Cooked);				/* Initialise  video structures */
void		vtmove(int row, int col);			/* Move cursor in virtual screen */
void		vtputc(Window* wp, UniChar c);			/* Put char to virtual screen */
void		vtputStr(Window* wp, const unsigned char* str);	/* Put string to virtual screen */
void		vtputUniStr(Window* wp, const UniChar* str);	/* Put Unicode string to virtual screen */
void		vtputUniStrLeftEdge(Window* wp, const UniChar* cp);	/* Write Unicode string to virtual screen */
void		vtpututf8(Window* wp, const BYTE* up);		/* Put UTF8 string to virtual screen */
void		vttidy(void);					/* Clean virtual screen before return to OS */

int		widen(int f, Cnt n);				/* Changes can be anywhere in the buffer */
LINE*		WinBottomLine(Window* wp);			/* Find the bottom line in a window */
int		windowManipulate(int f, Cnt n);			/* Interactive window changes	*/
int		WindowNumber(Window* wp);			/* Return window number */
int		WindowNumberInDirection(int Direction, const MapCell* map); /* Determine window # in a direction from curpw */
int		WindowMoveTop(int f, Cnt n);			/* Move window top edge */
int		WindowMoveBottom(int f, Cnt n);			/* Move window bottom edge */
int		WindowMoveLeft(int f, Cnt n);			/* Move window left edge */
int		WindowMoveRight(int f, Cnt n);			/* Move window right edge */
#if	WORDPRO
int		wordcount(int f, Cnt n);			/* count words in region */
#endif
Window*		wpopup(void);					/* Pop up window creation */
int		wrapword(int f, Cnt n);				/* wordwrap function */
void		WindowsSync(void);				/* Force all windows on curbp to display the same thing */
int		WriteCmdFilesToBuffer(BUFFER* blistp);		/* Print info about command files to buffer */
int		WriteEnvVariablesToBuffer(BUFFER* buffer);	/* Print environment variables to buffer */
int		WriteInputKeyMappingToBuffer(BUFFER* buffer);	/* Mappings via map-key */
int		writeout(const BYTE* fn, int flags);		/* Write a buffer to a file */
int		writemsg(int f, Cnt n);				/* write text on message line */
int		WriteSearchPathsToBuffer(BUFFER* blp);		/* Show search paths */
int		WriteStatisticsToBuffer(BUFFER* buffer);	/* Print statistics to buffer */
int		WriteUserVariablesToBuffer(BUFFER* buffer);	/* Print user variables to buffer */

int		xlat(TEXT* result, const TEXT* source, const TEXT* lookup, const TEXT* trans);	/* Translate a string */

int		yank(int f, Cnt n);				/* Yank back from killbuffer */
int		yanksDo(Cnt n, const char* Msg);		/* Do the work of yanking */

void		ZapTrailingSpaces(LINE* line);			/* Throw away trailing white space on line */
void		ZapZeroWidthWindows(void);			/* Kill redundant windows */
int		zotbuf(BUFFER* bp, int silent);			/* Kill a buffer */


/* There are a lot of functions that are related to Terminal Output.
 * Collect them together here so that they don't clutter up the block
 * of other function definitions.
 * One particular instance of Emacs will only use one lot; which is
 * kind of assuming that some of these will ever be used.
 *
 * Beware: This is not a matter of one #if meaning one file, some
 * drivers use functions in other files.
 *
 * Similarly: functions that are operating system specific.
 * This is not to say that there will not be OS specific code elsewhere.
 */
#if	EGA				/* IBM-PC EGA			*/

int		egabcol();					/* Set background colour */
int		egabeep();
int		egacres();
int		egaeeol();
int		egaeeop();
int		egafcol();
void		egahello(void);
int		egakclose();
int		egakopen();
int		egamove();
int		egaopen();
int		egaputc();
int		egarev();
int		egaul();

#endif	// EGA

#if	ANSI    			/* ANSI escape sequences	*/

int		anseeol();
int		anseeop();
int		ansibcol();
int		ansibeep();
int		ansiclose();
int		ansicres();
int		ansifcol();
void		ansihello(void);
int		ansikclose();
int		ansikopen();
int		ansimove();
int		ansiopen();
int		ansiparm();
int		ansirev();
int		ansiul();

#endif	// ANSI

#if	HP150				/* HP150 screen driver		*/

int		agios();
int		ckeyoff();
int		ckeyon();
int		closehp();
int		defkey();					/* Change all special keys to intercept mode */
int		dsplbls();
int		gethpkey();					/* Read keyboard */
void		h15hello(void);
int		hp15bcol();
int		hp15beep();
int		hp15cres();
int		hp15eeol();
int		hp15eeop();
int		hp15fcol();
int		hp15kclose();
int		hp15kopen();
int		hp15move();
int		hp15parm();
int		hp15rev();
int		hp15ul();
int		hpflush();
int		keycoff();
int		keycon();
int		rawoff();
int		rawon();
int		undefkey();

#endif	// HP150

#if	HP110				/* HP110 screen driver		*/

int		h110bcol();
int		h110beep();
int		h110close();
int		h110cres();
int		h110eeol();
int		h110eeop();
int		h110fcol();
void		h110hello(void);
int		h110kclose();
int		h110kopen();
int		h110move();
int		h110open();
int		h110parm();
int		h110rev();
int		h110uk();
int		openhp();

#endif	// HP110

#if	VMSVT				/* various VMS terminal entries	*/
#endif	// VMSVT

#if	VT52				/* VT52 terminal (Zenith).	*/

int		vt52bcol();
int		vt52beep();
int		vt52cres();
int		vt52eeol();
int		vt52eeop();
int		vt52fcol();
void		vt52hello(void);
int		vt52kclose();
int		vt52kopen();
int		vt52move();
int		vt52open();
int		vt52rev();
int		vt52ul();

#endif	// VT52

#if	RAINBOW 			/* Use Rainbow fast video.	*/
#endif	// RAINBOW

#if	TERMCAP 			/* Use TERMCAP			*/

void		hello(void);
int		TcapFun(const char* FunBuf, int FunCnt, KeyCode* Token); /* Look for function key in input */
void		tcapbcol(int bc);				/* Set background colour */
void		tcapbeep(void);					/* Ring the bell */
int		tcapcres(const BYTE* res);			/* NULL function - screen resolution */
void		tcapDelete(int places);				/* Delete text at cursor position */
void		tcapEnterInsert(void);				/* Enter insert mode */
void		tcapeol(void);					/* Clear to end of line */
void		tcapeop(void);					/* Clear screen */
void		tcapExitInsert(void);				/* Leave insert mode */
void		tcapfcol(int fc);				/* Set foreground colour */
void		tcapInsert(int places);				/* Insert spaces or enter insert mode */
void		tcapkclose(void);				/* Close the keyboard */
void		tcapkopen(int ksOnly);				/* Open the keyboard */
void		tcapmove(int row, int col);			/* Move cursor */
int		tcapopen(void);					/* Open the terminal */
void		tcaprev(int state);				/* Set/unset reverse video */
void		tcapscroll(int topLine, int rlines, int moveBy);/* Scroll lines */
void		tcapul(int state);				/* Set/unset underline */
KeyCode		tgetc(int flags, long timeout);			/* Get char from macro stream or tty */

#endif	// TERMCAP


#if	FIXSG				/* Fix stand-out glitch		*/
#endif	// FIXSG

#if	IBMPC				/* IBM-PC specific driver	*/

int		getboard();					/* IBM PC - get display board */
int		egaclose();
int		ibmbcol();
int		ibmbeep();
int		ibmclose();
int		ibmcres();
int		ibmeeol();
int		ibmeeop();
int		ibmfcol();
int		ibmhello();
int		ibmkclose();
int		ibmkopen();
int		ibmmove();
int		ibmopen();
int		ibmputc();
int		ibmrev();
int		ibmul();
int		scinit();
int		scwrite();

#endif	// IBMPC

#if	DG10				/* Data General system/10	*/

int		dg10bcol();					/* DG10 set colour */
int		dg10beep();
int		dg10close();
int		dg10cres();
int		dg10eeol();
int		dg10eeop();
int		dg10fcol();
void		dg10hello(void);
int		dg10kclose();
int		dg10kopen();
int		dg10move();
int		dg10open();
int		dg10rev();
int		dg10ul();

#endif	// DG10

#if	TIPC				/* TI Profesional PC driver	*/

int		setatt();
int		tibcol();
int		tibeep();
int		ticlose()
int		ticres();
int		tieeol();
int		tieeop();
int		tifcol();
void		tihello(void);
int		timove();
int		tiopen();
int		tiputc();
int		tirev();
int		tiul();

#endif	// TIPC

#if	Z309				/* Zenith 100 PC family	driver	*/

int		z309bcol();
int		z309eeol();
int		z309fcol();
int		z309move();
int		z309rev();
int		z309ul();

#endif	// Z309

#if	MAC				/* Macintosh			*/
#endif	// MAC

#if	ATARI				/* Atari 520/1040ST screen	*/
#endif	// ATARI

#if	AMIGA				/* AmigaDOS			*/
int		amg_flush();					/* strange termio */
#endif	// AMIGA

#if	ST520				/* ST520, TOS			*/

int		init();
void		init_aline();
int		domouse();
int		mapcol();
int		stbcol();
int		stbeep();
int		stclose();
int		steeol();
int		steeop();
int		stfcol();
int		stgetc();
void		sthello(void);
int		stkclose();
int		stkopen();
int		stmove();
int		stopen();					/* ST520 screen open */
int		stputc();
int		strev();
int		strul();
int		strez();
int		switch_font();

#endif	// ST520

#if	MSDOS				/* MS-DOS			*/
#if	AZTEC
int		a1getc(FILE* fp);				/* Get an ascii char from the file input stream */
#endif
int		sys(char* cmd, char* tail);
void		arglower(char** argvec);			// Lower case array of strings
#endif	// MSDOS

#if	VMS				/* VAX/VMS			*/

void		hellovms(void);
int		sys(char* cmd);					/* Run command, non Unix */
int		vmsbcol();
int		vmsbeep();
int		vmscres();
int		vmseeol();
int		vmseeop();
int		vmsfcol();
BYTE*		vmsgetstr();
int		vmsgtty();
int		vmskclose();
int		vmskopen();
int		vmsmove();
int		vmsopen();
int		vmsrev();
int		vmsul();

#endif	// VMS

#if	CPM				/* CP/M-86			*/
#endif	// CPM

#if	FINDER				/* Macintosh OS			*/
#endif	// FINDER

#if	BSD_UNIX			/* UNIX BSD 4.2	and ULTRIX	*/
#endif	// BSD_UNIX

#if	USG				/* UNIX system V		*/
#endif	// USG



#ifdef	maindef	/* Defined in main.c only */
#define	EXTERN
#define	DCLXTRN(var, val)	var = val
#else
#define	EXTERN	extern
#define	DCLXTRN(var, val)	extern	var
#endif

/* for MAIN.C */

/* initialized global definitions */

DCLXTRN(int	WindowMargin, 1);		/* try to keep cursor away from window edges */
DCLXTRN(int	fillcol, 72);			/* Current fill column		*/
DCLXTRN(int	PrefSplitCols, 180);		/* Preferably split horizontally if window wider */
DCLXTRN(int	eolexist, TRUE);		/* does clear to EOL exist	*/
DCLXTRN(int	exec_error, FALSE);		/* macro execution error pending? */
DCLXTRN(int	revexist, FALSE);		/* does reverse video exist?	*/
DCLXTRN(int	flickcode, FALSE);		/* do flicker supression?	*/


// Variables to do with key input
EXTERN	int	ungetThere;			// If TRUE ungetKey is defined
EXTERN	KeyCode	ungetKey;			// The ungot key
DCLXTRN(long	ttytimeout, 50000);		/* UNIX read timeout on esc seqs & multi byte chars - microseonds*/
DCLXTRN(int	MaxQuestion, MAX_QUESTION);	// How many times to ask a question before giving up
DCLXTRN(long	mlerrMsgTimeout, 10 * MILLION);	// Timeout for mlerr() messages
EXTERN	Time_T	lastCheckedAge;			// The last time that we ran checkage() from tgetc()
EXTERN	int	in_execcmd;			// In execute-command-line - execcmd()

/* Names of modes.
 * Collect together in ModeBuf - given to mnexpand()
 */
#define	LONGEST_MODE_NAME	6	// For prompting
EXTERN	ModeName modeNameExplan[]	// Mode names & explanations;
#ifdef	maindef
    = {
	{"WRAP",	"Wrap long lines at $fillcol" },
	{"CMODE",	"C programming language formatting" },
	{"EXACT",	"Case sensitive search" },
	{"VIEW",	"Buffer read only" },
	{"OVER",	"Typing replaces existing text" },
	{"MAGIC",	"Reguar expressions search" },
	{"CRYPT",	"Simple file encryption" },
	{"ASAVE",	"Autosave buffer" },
	{"INDENT",	"Auto indent lines" },
	{"RENEW",	"Reread buffer when file changes, 'r': append" },
	{"NONL",	"Buffer does not end in newline" },
	{"PHP",		"Programming language formatting" },
	{"UTF-8",	"Unicode (multi-byte) characters" },
	{"DOS",		"DOS line endings, CR LF" },
	{"TABEXP",	"Expand new keyed tabs to spaces" },
    }
/* Update modecode if add something to modeNameExplan, also ModeCheckFuns[] in random.c
 * Also look at the GM_xxx offsets in buffer.c, used in makelist() when showing buffer modes.
 */
#endif
	;

// String to replace modeNameExplan.mn_name when BRENEWAPPEND
DCLXTRN(char	renewAppend[],	"renew");	// Same but lower case

// DispModes() & modeline() change 'R' for 'r' if BRENEWAPPEND
DCLXTRN(char	modecode[], "WCEVOMYAIRNPUDT");	/* letters to represent modes	 */
DCLXTRN(int	gmode, 0);			/* global editor mode		 */


EXTERN	ModeDef	ModeBuf
#ifdef	maindef
	= { modeNameExplan,
	    "no mode matches",
	    (sizeof(modeNameExplan) / sizeof(modeNameExplan[0])),
	}
#endif
	;


/* Now the names of window options
 * These set flags like WO_HEX.
 *
 * Tentative reserve of name: Diacritical Combining Marks Shown
 * That these are shown as separate positions (as now) rather than displayed
 * combined with the previous character.
 * https://en.wikipedia.org/wiki/Combining_character
 */
#define	LONGEST_WOPT_NAME	13		// For prompting
EXTERN	ModeName winOptsExplan[]		// Window option names and explanations
#ifdef	maindef
    = {
	{"HEX",			"Hexadecimal display" },
	{"COLOUR-TAB",		"Show tabs in colour" },
	{"NUMBER",		"Line number" },
	{"META-ATTRIB",		"Display meta & control chars with underline & standout modes" },
	{"TRACK",		"Link line movements between windows" },
	{"SHOW-LINE-END",	"Show where end of line is with a $" },
	{"POSITION-SHOW",	"Show col#/line# byte-position% in buffer" },
    }
#endif
	;
EXTERN	ModeDef	WinOpt
#ifdef	maindef
	= { winOptsExplan,
	    "no window option matches",
	    (sizeof(winOptsExplan) / sizeof(winOptsExplan[0])),
	}
#endif
	;

DCLXTRN(short	DefaultWindowOpts, WO_META_ATTRIB);	/* Default w_opts for new windows*/

/* Longest length of input with mlreply() & mlprompt()
 * 0 means unlimited length.
 */
EXTERN	const	short	MLmaxLengths[MLTYPEMASK + 1]
#ifdef	maindef
    = {
	[MLSTRING]		= 0,			// Non specific string
	[MLXFILE]		= NFILEN,		// Entering a filename
	[MLXBUF]		= NBUFN,		// Entering a buffer name
	[MLSHELLCOMM]		= 0,			// Entering a shell command
	[MLXMODE]		= LONGEST_MODE_NAME,	// Entering a mode
	[MLTAG]			= TAGSIZE,		// Choosing a C tag
	[MLWOPTION]		= LONGEST_WOPT_NAME,	// Entering a window option
	[MLEMACSCOMMAND]	= CMDMAXLEN,		// Entering an Emacs command
	[MLEMACSVAR]		= NVSIZE,		// Entering a variable name
	[MLINTEGER]		= INTWIDTH,		// Entering an integer (long)
    }
#endif
	;


DCLXTRN(int	gflags, GFREAD);		/* global control flag		 */
DCLXTRN(int	gfcolor, COLOUR_SYS_DEF);	/* global forground color	 */
DCLXTRN(int	gbcolor, COLOUR_SYS_DEF);	/* global backgrnd color	 */
DCLXTRN(int	gasave, 256);			/* global ASAVE size		 */
DCLXTRN(int	gacount, 256);			/* count until next ASAVE	 */
EXTERN	int	WaitOnChild;			/* True if waiting for a child to die	*/
DCLXTRN(int	WasSuspd, FALSE);		/* True if were suspended (^Z) or winch	*/
EXTERN 	int	ShowingImportantMessage;	/* Don't overwrite message on startup	*/
EXTERN 	int	ListBindings;			/* Seen --list-bindings command line option */
EXTERN	int	DisplayMessageLineOnly;		/* Because the rest is not of our making - command output */
EXTERN	int	IntSignalReceived;		/* SIGINT received */
EXTERN	int	PipeWriteFail;			/* Write to pipe failed - SIGPIPE received */
EXTERN	int	NotToKillBuffer;		/* kinsert() to not insert into kill buffer */
EXTERN	int	DieShouldAbort;			/* Set TRUE to make Die() abort	 */
EXTERN	int	RenewBufferIsVisible;		/* A buffer in RENEW mode is displayed */
DCLXTRN(int	sgarbf, TRUE);			/* TRUE if screen is garbage	 */
DCLXTRN(int	mpresf, FALSE);			/* TRUE if message in last line  */
DCLXTRN(int	clexec, FALSE);			/* command line execution flag	 */
DCLXTRN(int	mstore, FALSE);			/* storing text to macro flag	 */
DCLXTRN(int	discmd, TRUE);			/* display command flag		 */
DCLXTRN(int	disinp, TRUE);			/* display input characters	 */
DCLXTRN(int	relinking, TRUE);		/* dont relink files if false	 */
DCLXTRN(int	NoticeEmacsSave, TRUE);		/* Special handling of files with .emacssave suffix */
DCLXTRN(int	cmode, CMDOFF);			/* set CMODE if .c or .h file	 */
DCLXTRN(int	tpause, 1);			/* # Secs to sleep on () match	 */
DCLXTRN(int	try_utf8, 0);			/* Check a file for UTF8 on read */
DCLXTRN(int	syncmc, SYNC);			/* sync file (not machine) after writes	*/
DCLXTRN(int	ddelay, 2);			/* 2 second prefix echo delay	 */
DCLXTRN(int	RenewTimeout, 2);		/* Time between checks on RENEW buffers	*/
DCLXTRN(int	RenewBell, FALSE);		/* Ring the bell on buffer RENEW	*/
DCLXTRN(short	Tabsize, DEF_TAB);		/* A \t counts this many spaces */
						/* Also the C indent size        */
DCLXTRN(short	PhpTabsize, PHP_TAB);		/* How much to indent a PHP prog */
DCLXTRN(int	beterse, 0);			/* be terse with mode output	 */
DCLXTRN(int	ccount, 5);			/* keystrokes to clear msg line - $ccount  */
DCLXTRN(int	ccounted, 5);			/* strokes left to clear msg line*/
DCLXTRN(int	mlmsgcount, 0);			/* times mlwrite() called	 */
DCLXTRN(int	NumberOfWindows, -2);		/* -2 as message & info windows not counted */
DCLXTRN(int	wbuffs, FALSE);			/* write buffers out		 */
DCLXTRN(struct	BUFFER* bstore, NULL);		/* buffer to store macro text to */
DCLXTRN(int	vtrow, 0);			/* Row location of SW cursor	 */
DCLXTRN(int	vtcol, 0);			/* Column location of SW cursor  */
DCLXTRN(int	ttrow, TERM_HUGE);		/* Row location of HW cursor	 */
DCLXTRN(int	ttcol, TERM_HUGE);		/* Column location of HW cursor  */
DCLXTRN(int	ttDoScroll, TRUE);		/* Scroll lines up/down in display if possible */
DCLXTRN(int	ttDoScrollLr, TRUE);		/* Scroll lines left/right in display if possible */
EXTERN	int	ttInInsert;			/* The terminal is in insert mode */
EXTERN	int	needNewAttrib;			/* Need to set: colours, bold, underscore */
EXTERN	int	AllocLines;			/* # malloced so safe to use	*/
EXTERN	int	AllocColumns;			/* # malloced so safe to use	*/
DCLXTRN(int	msgColourFrom, -1);		// Colour message line after this position
EXTERN	int	msgColourLen;			// How much to colour

#if	MEMMAP
DCLXTRN(int	lbound, 0);			// leftmost column of current line
						// being displayed. Only in display.c
#endif

DCLXTRN(KeyCode	abortc, ChrToCtrl('G'));	/* current abort command char	 */
DCLXTRN(KeyCode	quotec, 0x11);			/* quote char during mlreply()	 */
DCLXTRN(int	PageContextLines, 2);		/* number of context lines when page up/down */
DCLXTRN(int	ScrollJumpBy, 1);		/* number of lines to scroll at top/bottom of window - $jump */
DCLXTRN(int	NoScrollJumpBy, 10);		/* $jump when a window cannot scroll - $jump-no-scroll */

DCLXTRN(int	AutoDos, TRUE);			/* Automatic detection of DOS format input */
DCLXTRN(int	FrenchSpacing, TRUE);		/* One space (not two) at sentence end on fill-paragraph */

// Commonly used strings & messages
// Having one of these strings is not just about saving memory but getting consistency of %E, etc
DCLXTRN(char	MsgAborted[], "%WAborted");
DCLXTRN(char	MsgNotFound[], "%WNot found");
DCLXTRN(char	MsgOutOfMemory[], "%E""%FOut of memory");
DCLXTRN(char*	OutOfMemory, MsgOutOfMemory + 4); // Out of memory without the %E %F
DCLXTRN(char	NewlineString[2], "\n");	/* A string with a newline	*/
DCLXTRN(char	MsgOutOfMemoryAlloc[], "%E""%FOut of memory allocating %s");
DCLXTRN(char	MsgOutOfMemoryWhile[], "%E""%FOut of memory while %s");
DCLXTRN(char	errorm[], "ERROR");		/* error literal		*/
DCLXTRN(char	BadVar[], "%EBad name or no such variable as '%t'");	// Error message
DCLXTRN(int	gtusrCkReport, TRUE);		// Nastyness for gtusrCk()


EXTERN	VAL*	playValStr;			// Play, ALWAYS V_STR
EXTERN	VAL*	playValUndef;
EXTERN	VAL*	playValChr;

// An error value, text: is ERROR -- it is the type that is important
// Cannot declare const as it will be put into read-only memory & then cannot change ref count
EXTERN	VAL	errorVAL
#ifdef	maindef
	= {
		.v_flags = V_ERROR | V_READONLY | V_NOFREE | (1 << V_REFSHIFT),
	}
#endif
	;

/* This is a nasty hack - play by the rules & it will be OK.
 * There will be times when a BYTE* is wanted as a VAL* String, done
 * properly it means valGet(V_STR), copy the string in, use it, valRelease().
 * Save the bother: there is a VAL (STR), just assign to vtext(&splatStrVAL),
 * don't bother to tidy up.
 *
 * Use the macros below to set values.
 * Do set the length as it might be used as the source of tcatt() or similar.
 */
#define	splatSetText(text)	(splatStrVAL.v_v.v_text.t_text = (BYTE*)(text))
#define	splatSetLen(len)	(splatStrVAL.v_v.v_text.t_used = (LineLn)(len))
EXTERN	VAL	splatStrVAL
#ifdef	maindef
	= {
		.v_flags = V_STR | V_READONLY | V_NOFREE | (1 << V_REFSHIFT),
	}
#endif
	;

// A literal V_UNDEF
EXTERN	VAL	undefVAL
#ifdef	maindef
	= {
		.v_flags = V_UNDEF | V_READONLY | V_NOFREE,
	}
#endif
	;

// Array of VALue type names
#define	LONGEST_TYPE_NAME	5	// Longest of the names below
EXTERN	const	char*	const	V_TypeNames[]
#ifdef	maindef
	= { "undef", "int", "str", "char", "bool", "array", "hash",
		"", "", "", "", "", "", "", "error", "any"

	}
#endif
	;

DCLXTRN(char	truem[], "TRUE");		/* true literal			*/
DCLXTRN(char	falsem[], "FALSE");		/* false literal		*/
DCLXTRN(char	StrOn[], "on");			// Useful literal
DCLXTRN(char	StrOff[], "off");		// Useful literal

#define	EMACS_SAVE_SUFFIX	".emacssave"	/* Save file suffix		*/
DCLXTRN(char	SaveSuffix[], EMACS_SAVE_SUFFIX); /* Suffix for buffer emergency save */
#define	SaveSuffixLen	(sizeof(EMACS_SAVE_SUFFIX) - 1)

DCLXTRN(char*	os, OPERATING_SYSTEM);		/* Name of the operating system	*/
EXTERN	char*	TermName;			/* Terminal type name		*/
EXTERN	char*	home;				/* $HOME - from environment, might be empty */
EXTERN	char*	language;			/* Human language (from $LANG)	*/
EXTERN	char*	territory;			/* Regional variation of language	*/
EXTERN	uid_t	uid;				/* Process real user ID */
EXTERN	uid_t	euid;				/* Process effective user ID */
EXTERN	int	suidRoot;			/* True if root file permissions */
extern	char*	pathname[];			/* Where files are, OS dependent	*/
EXTERN	char*	suffixesC;			// What gets C mode
EXTERN	char*	suffixesPHP;			// What gets PHP mode

DCLXTRN(char const hexdigits[], "0123456789ABCDEF"); /* 0-9A-F			*/
/* Allowable characters in a variable name
 * But the first character cannot be 0-9 or -, VarNameChar1 is that string.
 */
DCLXTRN(char const VarNameChars[], "0123456789-abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_");
#define	VarNameChar1	(VarNameChars + 11)




/* This is a little special. Built every time that Emacs is linked.
 * Value comes from CPP symbols.
 */
extern	char*	CompileTime;
DCLXTRN(char*	Version, VERSION);		// VERSION from evers.h

/* How some characters may be represented in binding and binding display.
 * BEWARE: the internal bind table representation of C-SPC is: CNTRL | '@' ???
 * This is because all the other controls are like: ChrToCtrl('A')
 * Also used on parsing keys when binding in, eg, startup file.
 */
EXTERN	BindSpecChrs	BindSpecials[]
#ifdef	maindef
	= {
		{ BindNameEscape,	CharEscape,	BS_prefCTL },
		{ BindNameSpace,	' ',		BS_ctlOK   },
		{ BindNameDelete,	CharDelete,	0          },
		{ BindNameCircumflex,	'^',		BS_ctlOK   },
		{ BindNameReturn,	'\r',		BS_prefCTL },
		{ BindNameTab,		'\t',		BS_prefCTL },
		{ NULL,			'\0',		0          }
	}
#endif
	;

EXTERN	const char*	cname[]			// names of colours
#ifdef	maindef
	= {
	"BLACK",
	"RED",
	"GREEN",
	"YELLOW",
	"BLUE",
	"MAGENTA",
	"CYAN",
	"WHITE"
	}
#endif
	;

/* File reading/writing.
 * ffp will be NULL if it is not a valid file handle, it is used for all
 * read/write purposes - except for filterLines() - which cannot use stdio.
 * Many of these are only valid if ffp is not NULL.
 * This means that Emacs can only read/write one stream at a time.
 *
 * pi_echo is now only TRUE when want what is read from a pipe echoed to the tty.
 * This is prob only for pipe-command.
 */
DCLXTRN(int	ffutf8err, 0);		/* Error reading UTF8 in ffgetline()	*/
DCLXTRN(FILE*	ffp, (FILE*)NULL);	/* File pointer				*/
EXTERN	int	eofflag;		/* end-of-file flag			*/
DCLXTRN(int	numLinks, 1);		/* Number of links on file (Unix only)	*/
DCLXTRN(int	isSlink, FALSE);	/* File is a symbolic link (Unix only)	*/
EXTERN	TEXT*	ffName;			/* Name of file opened, for error msgs	*/
EXTERN	int	ffpWrite;		/* True if ffp opened for writing	*/
EXTERN	int	ffpOnPipe;		/* True if ffp is connected to a pipe	*/
DCLXTRN(int	pi_echo, FALSE);	/* Echo characters when reading from pipe */
EXTERN	int	f_funnyfile;		/* set to true if non-writable file in a 
					 * writeable directory and relinking is on */
DCLXTRN(int	f_relink, FALSE);	/* File has been relinked		*/
DCLXTRN(short	w_relink, FALSE);	/* warn about relink			*/
#if	UNIX
// Stat cache, avoid repeated stat() on the same file
EXTERN	struct	stat	statbuf;	/* Do read notes in CacheStat()		*/
DCLXTRN(int	statbufInvalid, 1);	/* Set true to force another stat()	*/
EXTERN	TEXT*	statFileName;		/* Name of last file stat()ed		*/
EXTERN	int	statStatus;		/* What the last stat() returned	*/
EXTERN	int	statErrno;		/* What the last stat() set		*/
#endif

#if	!(_BSD_SOURCE || _POSIX_C_SOURCE >= 200112L || _XOPEN_SOURCE >= 600)
BYTE*	newPWD;				// New value for $PWD if we change directory
#endif

EXTERN	char*	StartupFiles[3];	/* NULL terminated array of startup files run */

DCLXTRN(int	FilterCanIntr, 1);	/* Can interrupt filter shell command */

DCLXTRN(BufLns	kill_lcount, 0);	/* count of number of lines killed	*/


DCLXTRN(Window*	swindow, NULL);		/* saved window pointer			*/
DCLXTRN(int	cryptflag, FALSE);	/* currently encrypting?		*/

EXTERN	TEXT*	kbdMacro;		/* Keyboard macro held here		*/
EXTERN	KeyCode*kbdptr;			/* current position in keyboard buf	*/
DCLXTRN(int	kbdmode, STOP);		/* current keyboard macro mode		*/
DCLXTRN(Cnt	kbdrep, 0);		/* number of repetitions		*/

DCLXTRN(int	restflag, FALSE);	/* restricted use?			*/
DCLXTRN(KeyCode	lastkey, 0);		/* last keystoke			*/
EXTERN	int	termEOF;		/* True if EOF on input			*/
DCLXTRN(KeyCode	CurKey, 0);		/* Last command key, ie M-, C-x added in */
DCLXTRN(int	seed, 0);		/* random number seed			*/
#if	SYSRAND
EXTERN	int	RandSeeded;		/* True if radom generated seeded	*/
#endif
DCLXTRN(long	envram, 0l);		/* # of bytes current in use by malloc 	*/
DCLXTRN(int	macbug, FALSE);		/* macro debuging flag			*/
DCLXTRN(int	cmdstatus, TRUE);	/* last command status			*/
DCLXTRN(char	palstr[49], "");	/* palette string			*/
DCLXTRN(int	agetime, FALSE);	/* time to check age of buffers		*/
DCLXTRN(int	saveflag, 0);		/* Flags, saved with the $target var	*/
DCLXTRN(int	rval, 0);		/* return value of a subprocess		*/
#define	EXIT_BADFORK	127		/* rval value when fork() failed	*/
#define	EXIT_SIGOFFSET	128		/* signal that killed child added to this */
#define	EXIT_UNKNOWN	256		/* rval value when unknown error on wait() */
EXTERN	int	CmdFlag;		/* $cmd-flag				*/
EXTERN	Cnt	CmdCount;		/* $cmd-count				*/
#if	CALLED
DCLXTRN(int	eexitflag, FALSE);	/* Emacs exit flag			*/
DCLXTRN(int	eexitval, 0);		/* and the exit return value		*/
#endif

/* Uninitialized global definitions.
 * Which means that they are set to zero.
 */

#if	TERMDEBUG
EXTERN	int	TermDebug;		/* Debugging of tty input & escape key generation */
EXTERN	FILE*	TermDebFD;		/* Where to write terminal debugging */
#endif
EXTERN	int	TtyReadFailure;		/* True if last read gave an error */
EXTERN	int	TtyWriteFailure;	/* Errno value if the last tty write failed */
EXTERN	int	OutputSlowness;		/* Output is slow, -S command line option */
EXTERN	int	DoTypahead;		/* Don't optimise typahead(), had a sleep */
EXTERN	ST_val	termOutChecked;		/* How much output to tty when last checked */
EXTERN	SETBsize_t termOutBufSize;	/* Size of output buffer to use */
EXTERN	int	TTopened;		// TTopen state, one of:
#define	TTneverOpened	0		// Never opened
#define	TTwasOpened	1		// Was opened but closed again, raw mode, term defs read in
#define	TTfullyOpened	2		// Fully open - ie raw mode

// These are the action flags to ttreopen()
#define	TTREopen	0x01		// Do TTopen()
#define	TTREkopen	0x02		// Call TTkopen() - do not use this
#define	TTREkopenTRUE	(TTREkopen | 0x04)	// TTkopen(TRUE)
#define	TTREkopenFALSE	TTREkopen		// TTkopen(FALSE)
#define	TTREpaint	0x08		// Call RePaint()
#define	TTCCmsgl	0x10		// Call msglGarbage() & msglCpos(0)

// These are the action flags to ttcondclose()
#define	TTCCnlcr	0x01		// Send \n\r
#define	TTCCkclose	0x02		// Do TTkclose()
#define	TTCCmsgc	0x04		// Do msglClear() & msglFlush()
#define	TTCCclose	0x08		// Do TTclose()
#define	TTCCgotobot	0x10		// Go to bottom of screen

EXTERN	int	xon_xoff;		// If true do not disable C-s/C-q flow control
DCLXTRN(int	EarlyLog, FALSE);	// Log to terminal before initialisation

// These are only defined if TTdoes(TT_DOES_INSERT_CHARS) returns true
DCLXTRN(int	TTCostDel2Move, 999);	// Cost of term delete & 2 moves along the line
DCLXTRN(int	TTCostIns2Move, 999);	// Cost of term insert (or mode in/out) & 2 moves along the line
DCLXTRN(int	TTCostDel, 999);	// Cost of delete several characters
DCLXTRN(int	TTCostIns, 999);	// Cost of insert several characters
DCLXTRN(int	TTCostAttChange, 0);	// Cost of attribute change - kind of


#if	USG || WINSIZE || UNIX		/* System V or UNIX Window size change supported */
EXTERN	sigjmp_buf susp_buf;		/* If we were suspended in a read() */
EXTERN	int	in_read;		/* True if read()ing */
EXTERN	char	InChBuf[20];		/* Read into here */
EXTERN	int	InChCnt;		/* # chars in InChBuf */
EXTERN	int	InChOff;		/* Offset of 1st char in InChBuf */
#endif	// USG || WINSIZE || UNIX

#if	LEGACY_DISPLAY || TERMCAP
/* # blank chars left by SO or SE.
 * This is for ancient terminals that when you 
 * Used in display.c
 */
EXTERN	int	SG;
#endif

EXTERN	int	noflash;		/* If true don't flash (visible bell) */
EXTERN	int	nobell;			/* If true don't ring the bell - be quiet */
EXTERN	int	doublestar;		/* True if comments lines start ** */
DCLXTRN(int	catchsuspend, 1);	/* True if to process ^z ourselves */
EXTERN	int	auto_width;		/* True if to set fillcol on WINCH */
EXTERN	int	thisflag;		/* Flags, this command CF...	*/
EXTERN	int	lastflag;		/* Flags, last command		*/
EXTERN	int	JustAutoIndented;	/* ^M indented the last line	*/
EXTERN	LineLn	WordColBytes;		/* Bytes before word - set in GetWordCol() */
EXTERN	LineLn	CKeyBytes;		/* Start of keyword found by CKeyMatch() */
EXTERN	int	CursorInPrompt;		// So do not disturb what is there
EXTERN	int	CursorInMsg;		/* Where to place cursor while in tgetc() */
EXTERN	LineLn	wasInCppComment;	/* Set in fmatch() to where C++ comment started */

EXTERN	Window*	curwp;			/* Current window		*/
EXTERN	BUFFER*	curbp;			/* Current buffer		*/
EXTERN	Window*	wheadp;			/* Head of list of windows	*/
EXTERN	Window*	wmessp;			/* Message line window, it's next is wheadp */
EXTERN	BUFFER*	bheadp;			/* Head of list of buffers	*/
EXTERN	Window*	winfop;			/* Informational (pop up) window*/
EXTERN	BUFFER*	binfop;			/* Informational buffer		*/
EXTERN	UTABLE*	uv_head;		/* head of list of user variables */
EXTERN	VAL*	valhead;		/* Head of list of values	*/
EXTERN	UTABLE*	uv_global;		/* global variable table	*/
EXTERN	BUFFER*	blistp;			/* Buffer for C-X C-B		*/
extern	UVAR	uv[];			/* User variables		*/

/* History buffers.
 * Well, that was the initial idea - now also used for other named non-file buffers.
 */
EXTERN	BUFFER*	bmlHistp;		// Message line history buffer
EXTERN	BUFFER*	bmlFileHistp;		// File name history buffer
EXTERN	BUFFER*	bmlBufHistp;		// Buffer name history buffer
EXTERN	BUFFER*	bmlSrchHistp;		// Search string history buffer
EXTERN	BUFFER*	bmlRepHistp;		// Replace string history buffer
EXTERN	BUFFER*	bmlCmdHistp;		// Shell command history buffer
EXTERN	BUFFER*	bmlEmCmdHistp;		// Emacs command history buffer
EXTERN	BUFFER*	bmlVarHistp;		// Variable name history buffer
EXTERN	BUFFER*	bmlValHistp;		// Variable value history buffer
EXTERN	BUFFER*	bmlProcHistp;		// Procedure history buffer
EXTERN	BUFFER*	bmlTagHistp;		// CTAGS history buffer
EXTERN	BUFFER*	bmlKill;		// Killed text buffer
EXTERN	BUFFER*	bmlDebug;		// Macro, etc, debug history
EXTERN	BUFFER*	bmlPromptHistp;		// Message & prompts Line buffer
EXTERN	BUFFER*	bmlHelpSearch;		// Help search history
EXTERN	BUFFER*	bmlHelpStack;		// Help breadcrumbs
EXTERN	BUFFER*	bmlEvalStack;		// Hold multiple in flight macro values
#if	TRACEBUFFER
EXTERN	BUFFER*	bmlTrace;		// Trace/debug
EXTERN	LINE*	traceKeys;		// Raw keys
EXTERN	LINE*	traceCmdKeys;		// Command Keys
EXTERN	LINE*	traceCommands;		// Commands executed
#endif

// These buffer names are used in several places:
DCLXTRN(char	bmlNameMlHist[], "[Message History]");	// Message history
DCLXTRN(char	CmdBname[],	 "command");		// Command Buffer Name
DCLXTRN(char	AprFname[],	 "Binding list");	// Apropos 'file' name
DCLXTRN(char	HelpBname[],	 "[Help]");		// Help buffer name
DCLXTRN(char	HelpNxBname[],	 "[Help index]");	// Search index buffer name
DCLXTRN(char	HelpTmplBname[], "[Help template]");	// Keyword template buffer name
DCLXTRN(char	ProcLoadBname[], "[Proc Load]");	// Temporary buffer used in procedure autoload
DCLXTRN(char	mainBname[],	 "main");		// Name of default buffer

DCLXTRN(int	SaveMlHist, 50);	// Save message history max lines - also other similar buffers

EXTERN	LASTCMD	CmdHistory[CMDSKEPT];	// Circular of commands executed
DCLXTRN(LASTCMD*CurCmd, CmdHistory);	// Current command

/* This is used to initialise the buffers.
 * OK: [List] [Info Window] [Help] not history buffers, but convenient to put here
 */
EXTERN	HistList HistoryBuffers[]
#ifdef	maindef
    = {
	{ &bmlHistp,		bmlNameMlHist		},	// [Message History]
	{ &binfop,		"[Info Window]"		},
	{ &blistp,		"[List]"		},
	{ &bmlFileHistp,	"[File History]"	},
	{ &bmlBufHistp,		"[Buffer History]"	},
	{ &bmlSrchHistp,	"[Srch History]"	},
	{ &bmlRepHistp,		"[Repl History]"	},
	{ &bmlCmdHistp,		"[Shell History]"	},
	{ &bmlEmCmdHistp,	"[Cmnd History]"	},
	{ &bmlTagHistp,		"[CTAGS History]"	},
	{ &bmlVarHistp,		"[Var History]"		},
	{ &bmlValHistp,		"[Value History]"	},
	{ &bmlProcHistp,	"[Proc History]"	},
	{ &bmlPromptHistp,	"[Prompt Line]"		},
	{ &bmlKill,		"[Kill Buffer]"		},
	{ &bmlDebug,		"[Debug History]"	},
	{ &bmlHelpSearch,	"[Help Search]"		},
	{ &bmlHelpStack,	"[Help Stack]"		},
	{ &bmlEvalStack,	"[Eval Stack]"		},
#if	TRACEBUFFER
	{ &bmlTrace,		"[Trace Buffer]" 	},
#endif
	{ NULL,			NULL			}
    }
#endif
	;


/* State of message line.
 * msgTop is where to save current state before pushing.
 * The stack is far too big, expect only 2-3 elements to be used,
 * (3 is when checkage() writes something)
 */
EXTERN	msgState msgStack[10];			// Stack
DCLXTRN	(msgState* msgTop,	msgStack);	// Top of stack - not yet used position

EXTERN	char	sres[NBUFN];		/* current screen resolution	*/



/* Last buffer name.
 * This can be a fixed size array as it will have a max size.
 * This removes a lot of complexity over malloc()/free() and tests
 * if that fails.
 * If there is not a last buffer, this contains the empty string.
 */
EXTERN	BYTE	lbufn[BUFFER_NAME_SIZE];

#if	BACKUP
EXTERN	char*	bup_file;		/* temporary filename for saved files	*/
#endif

EXTERN	CHAR*	shell;			/* The user's preferred shell */
EXTERN	CHAR*	shell_name;		/* Name of the user's preferred shell */
EXTERN	BYTE*	progname;		/* Name of the program */

EXTERN	NBIND*	BindWrapword;		/* Bind ptr of wrapword function */
EXTERN	NBIND*	BindNullproc;		/* Bind ptr of nullproc function */

/* Search variables.
 * The variable matchlen holds the length (characters, not BYTEs) of the matched
 * string - used by the replace functions.
 * The variable patmatch holds the string that satisfies
 * the search command.
 * The variables matchline and matchoff hold the line and
 * offset position of the *start* of match.
 *
 * If the string is to be compared case insensitively then set eqCompare_i true,
 * it is then assumed by eq() that the pattern has been converted to lower
 * case - so that it does not need to.
 *
 * If matchSpaceWhite then a space will match one or more tabs (non RE match) - see eq().
 * spaceMatchWhite is the configuration switch that matchSpaceWhite is set
 * to at the start of search.
 *
 * searchPat_d is a good place to store the downcased pattern, but not mandatory.
 * searchPat is not allocated, if points to something that is,
 * probably either searchPat_e or searchPat_d depending on eqCompare_i.
 */
DCLXTRN(LineLn		matchlen, 0);		// Characters matched
DCLXTRN(LineLn		mlenold,  0);
EXTERN	TEXT*		patmatch;		/* Subject string matched by MAGIC pattern - for undo */
DCLXTRN(LINE*		matchline, NULL);
DCLXTRN(LineLn		matchoff, 0);
EXTERN	TEXT*		searchPat;		/* Search pattern to use	*/
EXTERN	TEXT*		searchPat_e;		/* Search pattern - as entered	*/
EXTERN	TEXT*		searchPat_d;		/* Search pattern - downcased	*/
EXTERN	TEXT*		search_m;		/* Search string matched - ie what found */
EXTERN	TEXT*		searchRep;		/* Replacement pattern		*/
EXTERN	TEXT*		searchPrompt;		/* Search/replace prompt	*/
EXTERN	TEXT*		isearchKeys;		// Interactive search history
DCLXTRN(int		AskReplaceSame, 0);	// If matched == replacement prompt to ask what to do

// What is learned about the search string
EXTERN	int		patternHasUpper;	/* True if there is an UPPER in searchPat_e */
EXTERN	int		patternIsIdent;		/* True if searchPat_e is like C identifier */
EXTERN	int		matchSpaceWhite;	/* What eq actually uses	*/

// Search options - settable in search itself
DCLXTRN(int		canSetEq_i, TRUE);	// eqCompare_i can be set by CheckCaselessSearch, not overridden by C-o
EXTERN	int		eqCompare_i;		/* eq() compare case independent*/
DCLXTRN(int		canSetSpW, TRUE);	// matchSpaceWhite can be set by CheckCaselessSearch, not overridden by C-o
DCLXTRN(int		spaceMatchWhite, 1);	/* eq() consider space & tab as the same - $space-match-white */
DCLXTRN(int		matchNoAdjAlnum, TRUE);	// Do not match if the string has alphanumeric, _, adjacent

#if	MAGIC
/*
 * The variables magical and rmagical determine if there
 * were actual metacharacters in the search and replace strings -
 * if not, then we don't have to use the slower MAGIC mode
 * search functions.
 */
DCLXTRN(int		magical, FALSE);
DCLXTRN(int		rmagical, FALSE);	// Replacement is in rmcpat, else searchRep
EXTERN	MC		mcpat[NPAT];		/* the magic pattern		*/
EXTERN	MC		tapcm[NPAT];		/* the reversed magic pattern	*/
EXTERN	RMC		rmcpat[NPAT];		/* the replacement magic array	*/

#endif


// This will be set by talloc() & textMoreBytes() & so thus the DoprS() functions
EXTERN	int	textOOM;		/* Set TRUE on out of memory */


/* The following are set by fmatch() if it fails to find a matching
 * fence. This is useful if this was 'cos of a C error.
 */
EXTERN	LINE*	FailAtDotp;			/* Line of failure */
EXTERN	LineLn	FailAtDoto;			/* Offset of failure */

EXTERN	LINE*	playLine;		/* For short term temporary use	*/
EXTERN	TEXT*	playText;		/* For short term temporary use	*/
EXTERN	LINE*	playLine2;		/* For short term temporary use	*/
EXTERN	TEXT*	playText2;		/* For short term temporary use	*/
EXTERN	LINE*	playLine3;		/* For short term temporary use	*/
EXTERN	TEXT*	playText3;		/* For short term temporary use	*/
EXTERN	LINE*	playLine4;		/* For short term temporary use	*/
EXTERN	TEXT*	playText4;		/* For short term temporary use	*/
EXTERN	LINE*	playLine5;		/* For short term temporary use	*/
EXTERN	TEXT*	playText5;		/* For short term temporary use	*/
EXTERN	TEXT*	playVar;		/* Variable name - for short term temporary use */
EXTERN	TEXT*	playValue;		/* Expression evaluation */
EXTERN	TEXT*	playDir;		/* Short term use to hold directory names */
EXTERN	TEXT*	cwDir;			/* Current working directory */
EXTERN	TEXT*	playPrompt;		/* Short term use to hold prompts */
EXTERN	TEXT*	playError;		/* Short term use to error messages */
EXTERN	TEXT*	foundFiles;		/* Names of files found by findFile() */
EXTERN	TEXT*	strmakeTmp;		/* Temporary use by utf8_strmake() */
EXTERN	TEXT*	execText;		/* Macro text being executed - prob from LINE */
EXTERN	LineLn	execPos;		/* Offset within execText */
EXTERN	TEXT*	trackLine;		/* Macro debug expression to track */
EXTERN	TEXT*	errorLine;		/* Contains the string ERROR */

EXTERN	TEXT*	strsSrch;		/* strsstrs() pattern string */
EXTERN	TEXT*	strsSubj;		/* strsstrs() subject string */

EXTERN	TEXT*	playCrypt;		/* Use for sensitive things like passwords */
EXTERN	TEXT*	playCrypt2;		/* Use for sensitive things like passwords */


EXTERN	TEXT*	f_backup;		/* Backup file name when relinking */
EXTERN	TEXT*	f_fname;		/* Name of the file that we relink to */

#if	DEBUGM
/*	vars needed for macro debugging output	*/
EXTERN	TEXT*	outline;		/* global string to hold debug line text */
#endif

// Dynamically allocated non buffer LINEs
// These will all have the NUL flag set and UTF-8 if it is a global mode.
EXTERN	LINE**	mlLines[]
#ifdef	maindef
    = {
	&playLine, &playLine2, &playLine3, &playLine4,
	&playLine5,
	(LINE**)NULL
    }
#endif
;
EXTERN	TEXT**	mlTexts[]
#ifdef	maindef
    = {
// &execText, 
	&f_fname, &f_backup, &ffName, &playVar, &playCrypt, &playCrypt2, &errorLine,
	&foundFiles, &trackLine, &playDir, &cwDir, &kbdMacro, &playValue, &searchPrompt,
	&playPrompt, &playText, &playText2, &playText3, &playText4, &playText5,
	&playError, &isearchKeys, &strmakeTmp,
	&searchPat_e, &searchPat_d, &search_m, &searchRep, &patmatch, &strsSrch, &strsSubj,

#if	UNIX
	&statFileName,
#endif

#if	DEBUGM
	&outline,
#endif

	(TEXT**)NULL
    }
#endif
;



/* Directive name table
 * This holds the names of all the directives....
 * dname_len[] helps speed lookup - length of the directives.
 * The directives are ordered to match constants DIF, DELSE, ... DFORCE
 * The constants DIF, etc, are numbered from 1 - see estruct.h
 */
EXTERN	const	CHAR*	dname[]
#ifdef	maindef
	= {
	"if", "else", "endif",
	"goto", "return", "endm",
	"while", "endwhile", "break",
	"force", "continue", "elseif"
	}
#endif
	;
EXTERN	const	char	dname_len[]
#ifdef	maindef
	= { 2, 4, 5, 4, 6, 4, 5, 8, 5, 5, 8, 6 }
#endif
	;

/* Key mapping.
 * Only 1 to 1 mapping, it may be fun at some stage to do string to string
 * mapping. This is initialised to provide a unit mapping (ie no change).
 * 
 * Type is BYTE to avoid sign extension. In spite of this only up to x7F
 * is mapped in UTF8 mode.
 *
 * Making it size 128 means it stores US-ASCII (controls + Basic Latin)
 * and so tgetc() does a straight lookup.
 *
 * CharMapChain is the list of mappings, can't do a table, potentially huge;
 * just hope that the users are sane enough to not have vast numbers of mappings.
 * Note that these are kep in order of chm_from.
 */
EXTERN	BYTE	keymap[128];
EXTERN	CharMap*CharMapChain;

extern	KEYTAB	keytab[];		/* key bind to functions table	*/
extern	PRETAB	preftab[];		/* Prefix binding map */
extern	RMTAB	ismap[];		/* Map functions to INTL keys	*/
extern	NBIND	CmdNames[];		/* name to function table	*/


/* terminal table defined only in TERM.C */

#ifndef	termdef
extern  TERM    term;                   /* Terminal information.        */
#endif

#if	UNIX
#include <sys/resource.h>
#endif

/* Statistics gathering
 */
EXTERN	ST_val	ST_termOut;		/* Bytes written to the terminal */
EXTERN	ST_val	ST_termInBytes;		/* Bytes read from the terminal */
EXTERN	ST_val	ST_termInKeys;		/* Keys/characters read from the terminal */
EXTERN	ST_val	ST_fileReadBytes;	/* Bytes read from files - not ctags */
EXTERN	ST_val	ST_fileWroteBytes;	/* Bytes written to files */

EXTERN	ST_val	ST_wallStart;		/* Program start time - wall clock*/
EXTERN	ST_val	ST_wallElapsed;		/* How long we have been running */
EXTERN	ST_val	ST_commands;		/* # Emacs commands executed */
#if	UNIX && defined(RUSAGE_SELF)
EXTERN	struct rusage	ST_rusage;	/* Resource usage - maybe Linux only */
#endif
#if	UNIX
EXTERN	ST_val	ST_utimeMs;		/* CPU time - ms */
EXTERN	ST_val	ST_stimeMs;		/* System time - ms */
#endif
EXTERN	ST_val	ST_buffers;		/* How many buffers */
EXTERN	ST_val	ST_buffersActive;	/* How many active buffers */
EXTERN	ST_val	ST_buffersInvis;	/* How many invisible buffers */
EXTERN	ST_val	ST_lines;		/* Number of lines in all buffers */
EXTERN	ST_val	ST_bytes;		/* Number of bytes in all buffers */
EXTERN	ST_val	ST_unusedBytes;		/* Allocated but unused - all buffers */
EXTERN	ST_val	ST_unusedPercent;	/* Percent unused */
EXTERN	ST_val	ST_mostUnused;		/* Most unused in any line */
EXTERN	ST_val	ST_maxBytes;		/* Max # bytes in any buffer - ie largest */
EXTERN	ST_val	ST_maxLines;		/* Max # lines in any buffer - ie longest */
EXTERN	ST_val	ST_longestLine;		/* Longest line in any buffer */
EXTERN	ST_val	ST_linesBytes;		/* Size of LINEs */

EXTERN	ST_val	ST_scrollCandidates;	/* Hardware terminal up/down scroll possibilities identified */
EXTERN	ST_val	ST_scrollDont;		/* Scrolls more costly than a repaint */
EXTERN	ST_val	ST_LRscrolls;		/* Hardware terminal left/right scrolls done*/

EXTERN	ST_val	ST_keyBindings;		/* How many keys bound */

EXTERN	ST_val	ST_hashLookups;		/* How many hash lookups were done */
EXTERN	ST_val	ST_hashProbes;		/* How many probes to find the keys */

EXTERN	LINE*	ST_FirstLine;		/* First of the stats line */


EXTERN	ST_tab	STatistics[]
#ifdef	maindef
    = {
	{ &ST_termInBytes,		"Bytes read from the terminal" },
	{ &ST_termInKeys,		"Keys/characters read from the terminal" },
	{ &ST_termOut,			"Bytes written to terminal" },
	{ &ST_fileReadBytes,		"Bytes read from files" },
	{ &ST_fileWroteBytes,		"Bytes written to files" },
	{ &ST_buffers,			"Number of buffers" },
	{ &ST_buffersActive,		"Active buffers" },
	{ &ST_buffersInvis,		"Invisible buffers" },
	{ &ST_lines,			"Lines - all buffers" },
	{ &ST_bytes,			"Bytes - all buffers" },
	{ &ST_unusedBytes,		"Allocated but unused - all buffers" },
	{ &ST_unusedPercent,		"Percent unused" },
	{ &ST_mostUnused,		"Most unused in any line" },
	{ &ST_longestLine,		"Longest line in any buffer" },
	{ &ST_maxBytes,			"Max bytes in any buffer" },
	{ &ST_maxLines,			"Max lines in any buffer" },
	{ &ST_linesBytes,		"Size of LINEs" },
	{ &ST_commands,			"Emacs commands executed" },
	{ &ST_wallElapsed,		"Run time - wall clock - s" },
#if	UNIX
	{ &ST_utimeMs,			"CPU time - ms" },
	{ &ST_stimeMs,			"System time - ms" },
#endif
#if	UNIX && defined(RUSAGE_SELF)
	{ &ST_rusage.ru_inblock,	"Block input operations" },
	{ &ST_rusage.ru_oublock,	"Block output operations" },
	{ &ST_rusage.ru_maxrss,		"Maximum resident set size - Kb" },
#endif
	{ &ST_scrollCandidates,		"Candidate hardware up/down scrolls" },
	{ &ST_scrollDont,		"Scrolls not worth it" },
	{ &ST_LRscrolls,		"Terminal left/right hardware scrolls done" },
	{ &ST_keyBindings,		"Key bindings, max " STR_DEFINE(NBINDS) },
	{ &ST_hashLookups,		"Hash lookups" },
	{ &ST_hashProbes,		"Hash probes" },
	{ NULL,				NULL }
    }
#endif
	;

/* Hash definition tables.
 * Some of them are defined elsewhere as they refer to things that
 * are statically declared. But all of the definition tables are
 * globally visible.
 */
extern	hashSt	hashEnv;	// Environment variables
extern	hashSt	hashFunc;	// Macro function names

EXTERN	hashSt	hashCmdNames	// Emacs command names
#ifdef	maindef
     = {
	CmdNames,
	NULL,
	hashStr,
	hashStrcmp,
	offsetof(NBIND, n_name),
	offsetof(NBIND, n_name),
	sizeof(NBIND),
	0,
	0
     }
#endif
	;

/* Key binding.
 * hashKeyRebuild exists to avoid rebuilding the key binding
 * hash too often. An Emacs startup file will often contain many
 * bind-to-key some of which will replace bindings which necessitates
 * the hash index being rebuilt.
 */
DCLXTRN(int	hashKeyRebuild, TRUE);	// Hash for key binding needs rebuilding
EXTERN	hashSt	hashKeyBindings		// Key bindings
#ifdef	maindef
     = {
	keytab,
	NULL,
	hashKeyCode,
	hashKeyCodecmp,
	offsetof(KEYTAB, k_code),
	offsetof(KEYTAB, k_u.k_ufp),
	sizeof(KEYTAB),
	0,
	0
     }
#endif
	;
/* All the keys that are bound to "clear-and-redraw" - refreshScreen
 * This is used in tgetc(), built by getbind()
 * 10 should be vastly more than enough.
 */
EXTERN	KeyCode	RefreshBinds[10];	// Keys
EXTERN	int	NumRefreshBinds;	// How many

/* end */
