/*
 * ADDW SCCS: @(#)spawn.c	1.126 09/22/20 22:44:43
 */

/*	Spawn:	various DOS access commands
		for MicroEMACS
*/

#include	"estruct.h"
#include        "utf8.h"
#include        "edef.h"

#if	SHOWMODREL
char	spawnvers[] = "@(#)spawn.c	1.126 09/22/20 22:44:43";
#endif

#if     AMIGA
#define  NEW   1006L
#endif

#if     VMS
#define EFN     0                               /* Event flag.          */

#include        <ssdef.h>                       /* Random headers.      */
#include        <stsdef.h>
#include        <descrip.h>
#include        <iodef.h>

extern  int     oldmode[3];                     /* In "termio.c"        */
extern  int     newmode[3];                     /* In "termio.c"        */
extern  short   iochan;                         /* In "termio.c"        */
#endif

#if	UNIX
#include	<sys/wait.h>
#include	<fcntl.h>
#include	<sys/uio.h>
#include	<poll.h>

#ifndef	WCOREDUMP		// Sometimes not defined
#define	WCOREDUMP(status)	(status & 0200)
#endif

#endif

#if	MSDOS && (MSC || TURBO)
#include	<process.h>
#endif

#if	MSDOS && MSC
#include	<stdlib.h>
#endif



/* Run an interactive sub-shell.
 *
 * When the command interpreter exits, mark the screen as garbage so that you
 * do a full repaint.
 *
 * If $write - run the command save-many-buffers first.
 *
 * The message at the start in VMS puts out a newline.
 * Under some (unknown) condition, you don't get one free when DCL starts up.
 *
 * Any count is ignored. The default count is not set.
 *
 * Command:  i-shell
 * Bound to: C-x c   M-$
 *
 * Return: TRUE - always
 */
int	spawncli(int f, Cnt n)
{
#if     AMIGA
        long newcli;
#endif

#if	AMIGA
	if(wbuffs)
		savemany(TRUE, 1);
        mlwrite("%IStarting new CLI");
        sgarbf = TRUE;
        Execute("NEWCLI \"CON:0/0/640/200/MicroEMACS Subprocess\"", 0L, 0L);
        return(TRUE);
#endif
#if	VMS
	if(wbuffs)
		savemany(TRUE, 1);
	movecursor(AllocLines - 1, 0);		/* In last line.	*/
	mlwrite("%IStarting DCL");
	TTflush();				/* Ignore "ttcol".	*/
	sgarbf = TRUE;
	return(sys(NULL));			/* NULL => DCL.		*/
#endif
#if	CPM
	mlwrite("%ENot in CP/M-86");
#endif
#if	MSDOS && (AZTEC || MSC || TURBO)
	if(wbuffs)
		savemany(TRUE, 1);
	movecursor(AllocLines - 1, 0);
	TTkclose();
	TTclose();
	TTflush();
	shellprog("");
	TTopen();
	TTkopen(FALSE);
	sgarbf = TRUE;
	return(TRUE);
#endif
#if	ST520 && MWC
	if(wbuffs)
		savemany(TRUE, 1);
	mlerase();	/* clear the message line */
	TTflush();
	TTkclose();
	system("msh.prg");
	TTkopen(FALSE);
        sgarbf = TRUE;
        return(TRUE);
#endif
#if     MSDOS && LATTICE
	if(wbuffs)
		savemany(TRUE, 1);
	movecursor(AllocLines - 1, 0); 	/* Seek to last line.   */
	TTflush();
	TTkclose();
        sys("\\command.com", "");               /* Run CLI.             */
	TTkopen(FALSE);
	sgarbf = TRUE;
	return(TRUE);
#endif
#if	UNIX
	if(wbuffs)
		savemany(TRUE, 1);
	msglCpos(0);				/* Seek to last line	*/

	// Prevent screen refresh while a child controls it:
	WaitOnChild = 1;

	ttcondclose(TTCCkclose | TTCCmsgc | TTCCclose);

	// Use return value to prevent a warning; we don't care what happened
	IGNORE(system(shell))

	agetime = TRUE;	// Files might have become out of date
	WaitOnChild = 0;
	sgarbf = TRUE;

	// Also checks for screen size change
	ttreopen(TTREopen | TTREkopenFALSE | TTREpaint);

        return(TRUE);
#endif
}

/* This code will make Emacs behave intelligently when suspended under
 * shell layers (but only on UniPlus+ System V.2).
 *							pjh@root.
 */

/* Suspend Emacs, ie return to the parent shell as job control.
 *
 * This command is implemented differently depending on operating system.
 *
 * The count is ignored. The default count is unset.
 *
 * Command:  suspend-emacs
 * Bound to: C-z   M-s
 *
 * Return TRUE always.
 */

#if	 USG && defined(SXTIOCBLK) && defined(SXTIOCSWTCH)
#include <sys/types.h>
#include <sys/tty.h>
#include <sys/sxt.h>

int	bktoshell(int f, Cnt n)
{
	/* try to suspend this shell layer.
	 */
	if(wbuffs)
		savemany(TRUE, 1);

	if(ioctl(0, SXTIOCBLK, -1) >= 0) /* no output */
	{
		vttidy();
		ioctl(0, TCSBRK, 1);	/* wait, no break */
		ioctl(0, SXTIOCSWTCH, 0);/* back to shl */
		ioctl(0, SXTIOCWF, -1);  /* wait for control */
		ioctl(0, SXTIOCUBLK, -1);/* yes output */
		ttreopen(TTREopen);
		curwp->w_flag = WFHARD;
		sgarbf = TRUE;
		agetime = TRUE;
		statbufInvalid = 1;	// Things might have changed while suspended
	}

	// Files might have become out of date
	agetime = TRUE;

	return(TRUE);
}
#endif	/* USG && UNI5_2 && defined(nasty things) */

#ifdef	SIGTSTP

/* suspend MicroEMACS and wait to wake up
 */
int	bktoshell(int f, Cnt n)
{
	if(wbuffs)
		savemany(TRUE, 1);

	vttidy();

	/* By replacing getpid() with 0, in the following line, we bypass
	 * all of the problems of trying to guess if the parent shell is
	 * capable of job control.
	 *
	 * If it isnt, we restart immediately - its magic !
	 */
	kill(0, SIGSTOP);

	/* Beware - before we do anything else we need to ensure that the
	 * screen is still the same size as before, etc. In particular
	 * we need to ensure that the buffers are the right size. If we
	 * don't (and the window has grown while we were suspended) then we
	 * blow up accessing bits of buffer that don't exist.
	 */
	RePaint();

	// Files might have become out of date
	agetime = TRUE;
	statbufInvalid = 1;	// Things might have changed while suspended

	return(TRUE);
}
#endif

#ifdef	SIGTSTP		/* USG as well as  BSD_UNIX these days */
/* The prototype always exists in edef.h as SIGTSTP is defined in
 * which is included after edef.h is included.
 */
int	rtfrmshell(void)
{
	/* We have an active child - we have to assume that it has
	 * control of the screen; thus we must leave it alone.
	 */
	if(WaitOnChild)
		return(TRUE);

	InChCnt = 0;

	// Also checks for screen size change
	ttreopen(TTREopen | TTREkopenFALSE | TTREpaint);

	curwp->w_flag = WFHARD;
	WasSuspd = TRUE;
	sgarbf  = TRUE;
	agetime = TRUE;

	// Files might have become out of date
	agetime = TRUE;
	statbufInvalid = 1;	// Things might have changed while suspended

	/* Sitting in a read ? */
	if(in_read)
		siglongjmp(susp_buf, 1);

	return(TRUE);
}
#endif

/* Run a one-liner in a subjob/shell-command.
 *
 * When the command returns, the user will be prompted for the next command; if
 * the user entered ^O to run the previous command they they might be prompted
 * with what was next in the history buffer (if there was anything).
 *
 * After this has happened return, then spawn() above repaints the screen
 * - clearing the command output.
 * The other really imporant thing that RePaint() does is to cope with a screen
 * size change - without that we can crash badly.
 *
 * This used to be more complicated and you could enter "!" "$" "@" to do things,
 * but this is simplfied - other than the use of the generic history mechaism.
 *
 * Q1: Should the user be prompted at subjob end - so that they can see the output ?
 * Might not want that as it interrupts the flow.
 *
 * Q2: Should the user be able to run another command ?
 *
 * 3 cases:
 * * normal interactive use
 *	prompt the user, they get to run another command
 * * macro;
 *	user not prompted unless the count is non zero,
 *	they do not get to run another command
 * * keyboard macro play
 *	prompt the user - but can only enter \n - not enter another command
 *
 * If the count is zero: never prompt the user and only one command is prompted
 * for.
 * 
 * Mark the screen as garbage so a full repaint is done.
 *
 * shell-command and execute-program were once separate commands.
 * Merged as there was no real difference between what they did.
 *
 * The default count is unset.
 * 
 * Command:  shell-command   execute-program
 * Bound to: C-x !   C-x $   M-!
 *
 * Returns FALSE always (I think). Should it do this ? TODO
 *	ABORT C-g
 */
int	spawn(int f, Cnt n)
{
	int	status;

	// Arg to respawn() is true if prompt the user at job end:
	while((status = respawn((f && n == 0) ?
		FALSE :
		(clexec == FALSE || f))
	       ) == TRUE) {

		/* It worked - whatever that means.
		 * If running in a macro or count == 0 do not repeat - else we go into a loop
		 */
		if(clexec == TRUE || (f && n == 0))
			break;	// In a macro: stop

		// Not in a macro do again (prompts the user)
	}

	/* Now safe to trash whatever the command put on the screen */
	DisplayMessageLineOnly = 0;

	/* Complete terminal reset into visual mode,
	 * just function keys reset so far
	 * Also checks for screen size change
	 */
	ttreopen(TTREkopenFALSE | TTREpaint);

	// Files might have become out of date
	agetime = TRUE;

	return(status);
}

/* Does the real work of spawn()
 *
 * Process exit code is stored in global rval.
 *
 * If doPrompt prompt even if the exit code is 0
 *
 * Return TRUE as long as something runs, even if its exit code is non 0
 *		or dies due to receipt of some signal
 *		BUT: when running a macro: return FALSE unless exit code is 0
 *	  FALSE only if prompt error or fork() fails.
 *	  ABORT C-g
 */
int	respawn(int doPrompt)
{
	register int	s;

#if	UNIX
	int		pid;
#endif

#if	AMIGA
	long newcli;
#endif

#if	AMIGA
	if((s = mlprompt("!", MLSHELLCOMM | MLLN0END, bmlCmdHistp)) != TRUE)
		return(s);
	newcli = Open("CON:0/0/640/200/MicroEMACS Subprocess", NEW);
	Execute(ltext(bmlCmdHistp->b_dotp), 0L, newcli);
	Close(newcli);
	tgetc(MGC_MAP, 0);	/* Pause. */
	sgarbf = TRUE;
	return(TRUE);
#endif
#if	VMS
	if((s = mlprompt("!", MLSHELLCOMM | MLLN0END, bmlCmdHistp)) != TRUE)
		return(s);
	TTputc('\n');						/* Already have '\r'    */
	TTflush();
	s = sys(ltext(bmlCmdHistp->b_dotp));			/* Run the command.     */
	mlGetKey(MGC_MAP, NULL, "[End]");
	sgarbf = TRUE;
        return(s);
#endif
#if     CPM
        mlwrite("%ENot in CP/M-86");
        return(FALSE);
#endif
#if	MSDOS && (AZTEC || MSC || TURBO)
	if((s = mlprompt("!", MLSHELLCOMM | MLLN0END, bmlCmdHistp)) != TRUE)
		return(s);
	movecursor(AllocLines - 1, 0);
	TTkclose();
	shellprog(ltext(bmlCmdHistp->b_dotp));
	TTkopen(TRUE);
	/* if we are interactive, pause here */
	if(clexec == FALSE)
		mlwrite("[End]");
	sgarbf = TRUE;
        return(TRUE);
#endif
#if	ST520 && MWC
	if((s = mlprompt("!", MLSHELLCOMM | MLLN0END, bmlCmdHistp)) != TRUE)
		return(s);
	mlerase();
	TTkclose();
	system(ltext(bmlCmdHistp->b_dotp));
	TTkopen(TRUE);
	/* if we are interactive, pause here */
	if(clexec == FALSE)
		mlwrite("[End]");
	sgarbf = TRUE;
	return(TRUE);
#endif
#if     UNIX

	if((s = mlprompt("!", MLSHELLCOMM | MLLN0END, bmlCmdHistp)) != TRUE)
		return(s);

	// fprintf(stderr, "respawn after mlprompt line='%s', cmdhist='%s'\n", ltext(bmlCmdHistp->b_dotp), ltext(bmlCmdHistp->b_dotp));

	// Now we don't own what is on the screen
	DisplayMessageLineOnly = 1;

	/* The trouble with closing/opening the function keys is that on an
	 * Xterm this resets the screen to what it was before we started Emacs.
	 * No problem, 'till at the end we prompt the user to continue, and
	 * he can't see what the command did 'cos it is now showing Emacs
	 * stuff.
	 * So don't do it -- but the tt_close requests that we act as if it had
	 * been done - this is to reset so that arrow keys work.
	 *
	 * The latest fix is that tcapkopen() now takes an argument that tells
	 * it to only restart keypad mode.
	 *
	 * msglClear() to put the cursor on the bottom line. Normally there
	 * unless keyboard macro PLAY - when mlprompt() does not move the cursor.
	 * Want it there for when the command generates output.
	 */
	ttcondclose(TTCCnlcr | TTCCmsgc | TTCCclose);

	// Prevent screen refresh while a child controls it:
	WaitOnChild = 1;

	/*
	 * Please note that we can't have the old system() code in here,
	 * simple though it was, because it doesnt handle signals properly,
	 * with the result that if we dont choose to ignore interrupts then
	 * we die, but if we do choose to ignore interrupts then so do our
	 * children.
	 *
	 * What is below is basically all that system() does anyway, except
	 * for the signal handling stuff.
	 */
	tsetempty(playError);

	mlwrite("%#Shell: %l", bmlCmdHistp->b_dotp);

	switch((pid = doFork())) {
	case 0:
		doExecl(ltext(bmlCmdHistp->b_dotp), TRUE);

	case -1:
		// doFork() has already put something into playError & rval
		s = FALSE;

		break;
	default:
		// Something went wrong when running a macro ?
		if(reapChild(pid) != 0 && clexec == TRUE)
			s = FALSE;
		break;
	}

	// The above leaves an error message in playError

	WaitOnChild = 0;

	ttreopen(TTREopen | TTREkopenTRUE | TTCCmsgl);

	if(doPrompt && TTopened == TTfullyOpened) {
		/* It is irritating if the first character of a new command is
		 * lost, so push it back to input unless in a macro (of which
		 * there are 2 sorts).
		 */
		KeyCode c = mlGetKey(MGC_MAP | MGC_NO_KMACRO, NULL, "%t[End]", playError);
		if(kbdmode != PLAY && clexec == FALSE)
			TTungetc(c);

		/* Clear the command line so that a new one can be entered.
		 * If SPC or \r is entered - return to editing.
		 */
		ttreopen(TTCCmsgl);
	}

	msglFlush();
	sgarbf  = TRUE;
	agetime = TRUE;		/* time to see if the buffers are old	*/
	statbufInvalid = 1;	// Things might have changed while in the command

	return(s);
#endif
}

#if	0	// retired

/* execprg() is retired, use spawn() instead as it does much the same thing.
 *
 * execprg() was execute-program
 * spawn()   was shell-command
 *
 * Code left here as it does no harm - fix ebind.h & efunc.h if you want to resurrect it.
 */

/*
 * Run an external program with arguments.
 *
 * When it returns, wait for a single character to be typed, then mark the
 * screen as garbage so a full repaint is done.
 *
 * Command:  execute-program
 * Bound to: C-x !   C-x $   M-!
 *
 * Return: TODO
 *	ABORT C-g
 */
/*ARGSUSED*/
int	execprg(int f, Cnt n)
{
	int	s;

#if	MSDOS && (TURBO || LATTICE || AZTEC)

	if(wbuffs)
		savemany(TRUE, 1);
	if((s = mlprompt("$", MLSHELLCOMM | MLLN0END, bmlCmdHistp)) != TRUE)
		return(s);
	movecursor(AllocLines - 1, 0);
	ttcondclose(TTCCkclose);
	execprog(ltext(bmlCmdHistp->b_dotp));
	ttreopen(TTREkopenFALSE);

	/* if we are interactive, pause here */
	if(clexec == FALSE) {
		mlwrite("[End]");
		tgetc(MGC_MAP, 0);
	}
	sgarbf = TRUE;
	return(TRUE);
#else
	/* Sorry, it was easier than duplicating all the same code again.
	 * Get respawn() to always issue a prompt.
	 */
	s = respawn(TRUE);

	// respawn() will prob TTungetc() - throw it away else it will be the next command (unwanted)
	if(ungetThere && TTopened == TTfullyOpened)
		TTgetc(0);

	/* Now safe to trash whatever the command put on the screen */
	DisplayMessageLineOnly = 0;

	// Files might have become out of date
	agetime = TRUE;

	return(s);
#endif
}
#endif	// 0 - retired

/* Insert the output of a one line command into the current window.
 *
 * Any count is ignored.
 *
 * Command:  insert-command
 * Bound to: C-x %
 *
 * Return:
 *	TRUE  - worked, lines inserted
 *	FALSE - cannot open pipe
 *		I/O error
 *	ABORT C-g
 */
/* ARGSUSED */
int	inscmd(int f, Cnt n)
{
#if	UNIX
	register int	s;		/* return status from CLI */

	/* get the command to pipe in */
	if((s = mlprompt("%", MLSHELLCOMM | MLLN0END, bmlCmdHistp)) != TRUE)
		return(s);

	// This writes several messages when TTclosed - this should be safe - no term reads
	ttcondclose(TTCCmsgc | TTCCclose);

	tcpyl(playText, bmlCmdHistp->b_dotp);
	tcats(playText," 2>&1");			/* merge stderr and stdout */
	if(pi_open(ttext(playText), "r", -1) == FIOSUC) {
		/* and read the stuff in */
		s = istream((BYTE*)"from shell command");
	} else {
		mlwrite("%ECannot open pipe from command as: %e", errno);
		s = FALSE;
	}

	// Also checks for screen size change
	ttreopen(TTREopen | TTREpaint);

	// Files might have become out of date
	agetime = TRUE;

	return(s);
#endif
}


/* Pipe the output of a one line command into a window
 *
 * Copy the command output to the screen; and the end of command refresh the
 * screen with a page worth displayed in the 'command' buffer.
 * If the count is set (any value) do not copy to the screen.
 *
 * The default count is not set.
 *
 * Command:  pipe-command
 * Bound to: C-x @   M-@
 *
 * Return TRUE if this works
 *	  FALSE if this does not work
 */
int	pipecmd(int f, Cnt n)
{
	register int	s;	/* return status from CLI */
	register BUFFER* bp;	/* pointer to buffer to zot */
	TEXT*	 text;		/* command line send to shell */

#if	AMIGA
	static char filnam[] = "ram:command";
	long newcli;
#else	/* ! AMIGA */
#ifndef	UNIX
	static char filnam[NSTRING] = "command";
#endif	// UNIX
#endif	/* ! AMIGA */

#if	MSDOS || (ST520 && MWC)
	char *tmp;
	char *getenv();
	FILE *fp;
	FILE *fopen();
#endif

#if	MSDOS
	if((tmp = getenv("TMP")) == NULL)
		strcpy(filnam, "command");
	else {
		strcpy(filnam, tmp);
		strcat(filnam,"\\command");
	}
#endif

#if	VMS
	mlwrite("%ENot availible under VMS");
	return(FALSE);
#endif
#if	CPM
	mlwrite("%ENot availible under CP/M");
	return(FALSE);
#endif

	/* Get the command to pipe in */
	if((s = mlprompt("@", MLSHELLCOMM | MLLN0END, bmlCmdHistp)) != TRUE)
		return(s);

	// Create the buffer that we will read this into:
	if( !(bp = bfindCheck(CmdBname, BFNCREATE|BFNACTIVE)))
		return(FALSE);

	/* Soon we won't be able to prompt (after TTclose()) so while
	 * we can check if there is stuff to be discarded and that the
	 * user is OK with that.
	 * The check will be done again in bclear() below - so clear
	 * any changed flag.
	 */
	if((s = bDiscardOK(bp)) != TRUE)
		return(s);
	bp->b_flag &= ~BFCHG;

	CheckCMode(bp);		// In case .c/something suffix. Rare

	// If it is not displayed make it take 1/2 the screen
	if(bp->b_nwnd == 0 && TTopened != TTneverOpened) {
		if(onlywind(FALSE, 1) == FALSE || splitwind(FALSE, 1) == FALSE)
			return(FALSE);

		// Some buffer is displayed twice, disconnect from curwp:
		DisconnectBuffer(curwp);

		// Connect curwp to the buffer, ie set w_dotp, etc:
		ConnectBuffer(bp, curwp, 0);
	}

	/* Copy command to another line so that the one in history does not get
	 * messed up with '2>&1' & similar being appended.
	 */
	text = playText3;
	tcpyl(text, bmlCmdHistp->b_dotp);

	if( !f || n >= 0) {
		// Don't move the cursor if command output goes
		// straight into the buffer, not copied to the screen
#if	UNIX
		// Don't know why only Unix
		ttcondclose(TTCCgotobot | TTCCnlcr);
#else
		ttcondclose(TTCCgotobot);
#endif
	}


#if	AMIGA
	newcli = Open("CON:0/0/640/200/MicroEMACS Subprocess", NEW);
	tcats(text, " >");
	tcats(text, filnam);
	Execute(ttext(text), 0L, newcli);
	s = TRUE;
	Close(newcli);
	sgarbf = TRUE;
#endif
#if	MSDOS || (ST520 && MWC)
	tcats(text, " >>");
	tcats(text, filnam);
	movecursor(AllocLines - 1, 0);
	TTkclose();
#if     MSDOS && (AZTEC || MSC || TURBO)
	shellprog(ttext(text));
#else
	system(ttext(text));
#endif
	TTkopen(FALSE);
	sgarbf = TRUE;
	if((fp = fopen(filnam, "r")) == NULL) {
		s = FALSE;
	} else {
		fclose(fp);
		s = TRUE;
	}
#endif	// MSDOS || (ST520 && MWC)

	msglFlush();
	sgarbf = TRUE;
	agetime = TRUE;				/* time to age buffers	*/
	statbufInvalid = 1;			// Things might have changed while in the command

#if	UNIX

	/* This writes several messages when TTclosed - this should be safe.
	 * No term reads - which is why we did the bDiscardOK() earlier.
	 */
	if( !f || n >= 0)
		ttcondclose(TTCCclose);		// stty to old modes, keyboard signals now happen

	int	lineLen = (int)tused(text);	// We'll set the length back to this later
	tcats(text, " 2>&1");			/* merge stderr and stdout */
	/* open a pipe to child	*/
	if(pi_open(ttext(text), "r", -1) != FIOSUC) {
		mlwrite("%ECannot open pipe from command as: %e", errno);
		s = FALSE;
	} else {
		// and read the stuff in

		pi_echo = !f;			// dont echo characters if flag is set

		tsetused(text, lineLen);	// Remove the 2>&1, use the rest to show the command run
		if((s = readStream(CmdBname, NULL, FALSE)) != TRUE)
			mlwrite("%ECannot read from command as: %e", errno);

		setVisibleFname(bp, ttext(text));

		pi_echo = FALSE;
	}

	if( !f || n >= 0)
		ttreopen(TTREopen);

#else
	if((s = getfile(filnam, FALSE, FALSE)) != TRUE)
		mlwrite("%ECannot read %s as: %e", filnam, errno);
	/* and get rid of the temporary file */
	unlink(filnam);

#endif	// UNIX

	ReconnectWindowsToBuffer(bp);

	/* Put the command buffer in VIEW mode, update all mode lines */
	bp->b_mode |= MDVIEW;
	upmode(bp, WFMODE | WFHARD);

	return(s);
}

/* Pipe the buffer/narrow to a shell command.
 *
 * This only works on UNIX systems.
 *
 * Lines are sent down the pipe with lines ending \n. If the buffer
 * is in DOS mode a \r is not added.
 * The last line always has a \n appended, even in NONL mode.
 *
 * After the command the user is prompted before Emacs continues.
 * This prompt does not happen if this is called from a macro
 * unless the count is set.
 * User also prompted if there was an error or the command returned false.
 *
 * The default count is not set.
 *
 * Command:  pipe-to-command
 * Bound to: C-x |
 *
 * Return: TRUE
 *	   FALSE
 *	   ABORT C-g
 */
int	PipeToCommand(int f, Cnt n)
{
#if	UNIX		// Pipes elsewhere are prob different
	int	status;

	/* Get the command to pipe to */
	while((status = mlprompt("|", MLSHELLCOMM | MLLN0END, bmlCmdHistp)) == TRUE) {
		REGION	reg;

		// Create region consisting of the entire buffer/narrow
		reg.r_linep = lforw(curbp->b_btopline);
		reg.r_offset = 0;
		reg.r_endLinep = curbp->b_abotline;
		reg.r_endOffset = 0;


		ttcondclose(TTCCnlcr | TTCCmsgc | TTCCclose);

		tsetempty(playError);

		/* open a pipe to child	*/
		if(pi_open(ltext(bmlCmdHistp->b_dotp), "w", -1) != FIOSUC) {
			printToText(playError, "Cannot open pipe to command as: %e", errno);
			status = FALSE;
		} else {
			// Write the stuff out
			status = ffWriteRegion(&reg) == FIOSUC;
			if(pi_close() != FIOSUC)
				status = FALSE;
		}

		ttreopen(TTREopen | TTREkopenTRUE | TTCCmsgl);
		msglFlush();

		// Running in a macro: just the one command
		if(clexec == TRUE && !f)
			break;

		// Prompt the user if interactive (ie not macro) or there is an argument
		// clexec will be TRUE if running a macro from the command line
		if(status != TRUE && kbdmode != PLAY) {
			/* It is irritating if the first character of a new command is
			 * lost, so push it back to input.
			 */
			KeyCode c = mlGetKey(MGC_MAP, NULL, "%t[End]", playError);
			TTungetc(c);
		}

	}
	sgarbf = TRUE;			// Everything needs repainting
	agetime = TRUE;			// time to age buffers
	statbufInvalid = 1;		// Things might have changed while in the command

	ttreopen(TTREpaint);

	return(status);
#else
	return(FALSE);
#endif
}


#if	UNIX
/* Filter between start and end through an external command; replace the region
 * with what the command prints on stdout.
 *
 * This filters whole lines, starting at the start of startLine and ending
 * at the start of endLine - ie no character on endLine are filtered.
 *
 * LINE startLine will be destroyed and its replacement will be linked from
 * lback(startLine).
 * LINE endLine will be untouched, but lback(endLine) will have been replaced.
 *
 * Once upon a time: this took arguments of where on start and end lines, but this just
 * makes for complication; shove that back to filterRegion().
 *
 * The terminal is 'closed' while the command runs; this will result in a (possibly
 * needless) RePaint(). Maybe have an option to not close it.
 *
 * Only stdout is put into the buffer, stderr remains on the screen and will be lost
 * after refresh. So if there is an error prompt before continuing.
 * If no error just continue without a prompt.
 *
 * What is read/written here counts towards the stats on file I/O.
 *
 * This attempts to restore "." and mark and alpha marks.
 *
 * Error message(s) are built in playError.
 * Any error is shown & prompt before continuing - not in macro mode
 *
 * Process exit status stored in global rval.
 *
 * Return TRUE is all OK
 *	  FALSE because:
 *	      * shell (filter) command does not exit 0
 *	      * error creating pipes
 *	      * cannot fork
 *	      * poll error - prob problem with filter command
 *	      * error reading/writing from/to a pipe
 *	      * UTF-8 error on what is read in (if buffer in UTF-8 mode)
 */
int	filterLines(LINE* cmd, LINE* startLine, LINE* endLine)
{
	int	inp[2];			// FDs pipe command stdin
	int	outp[2];		// FDs pipe command stdout
	int	i;
	pid_t	pid;			// Child PID

	tsetused(playError, 0);

	// playError containing something is used as an indication of error,
	// all errors result in a message

	// Create the pipes to talk to the filter, one for each end
	if((i = pipe(inp)) || pipe(outp)) {
		mlwrite("%ECannot create pipes to command: %e", errno);
		if(i == 0) {
			close(inp[0]);
			close(inp[1]);
		}
		return(FALSE);
	}

	// Prevent screen refresh while a child controls it:
	WaitOnChild = 1;

	if(FilterCanIntr) {
		/* Interrupt/quit are for the command.
		 * Put the terminal back into cooked mode
		 * so that INTR/QUIT can be generted from
		 * the keyboard.
		 */
		ttcondclose(TTCCnlcr | TTCCmsgc | TTCCclose);
	}

	switch(pid = doFork()) {
	case 0:	// Child

		if(dup2( inp[0], 0) != 0 ||	// Connect to stdin
		   dup2(outp[1], 1) != 1) {	// Connect to stdout
			// Unlikely, but:
			fprintf(stderr, "Pipe dup fail: %s\n", strerror(errno));
			fflush(stderr);
			_exit(127);
		}

		doExecl(ltext(bmlCmdHistp->b_dotp), FilterCanIntr);

	case -1:// Error message already done in doFork()

		break;
	}

	// Close the unwanted ends of the pipes
	close( inp[0]);
	close(outp[1]);

	if(pid < 0) {	// Fork failed
		// Close the pipes that we would have been reading/writing
		close( inp[1]);
		close(outp[0]);

		goto off_forkfail;
	}

	// Don't block on the pipes - else we could wait forever:
	fcntl( inp[1], F_SETFD, (long)(fcntl( inp[1], F_GETFD) | O_NONBLOCK));
	fcntl(outp[0], F_SETFD, (long)(fcntl(outp[0], F_GETFD) | O_NONBLOCK));

	PipeWriteFail = 0;	// Reset

	/* Write to the input of the command (inp[0]) and read from the output (outp[1]).
	 *
	 * The interesting thing is that we must not block, ie write more than the
	 * command has read (+ pipe capacity) or try to read more than it has written; also
	 * not reading enough will cause it to block and not read any more of what we have
	 * written.
	 *
	 * So: we can't use the standard read/write code that takes no heed of this.
	 * Writing a line at a time and flushing is no good either since lines can be
	 * very long.
	 * The size of a pipe is between 4K & 64K, but careful examination of
	 * write() return will ensure that we don't overfill since the pipes
	 * are set non-blocking.
	 *
	 * We also need to be aware that if the command dies we will be hit with SIGPIPE,
	 * so PipeWriteFail will get set, write() should fail EPIPE.
	 *
	 * Input to the command. The obvious way is to copy text from LINEs to a buffer and
	 * flush when it is full. The more interesting way is to write directly
	 * from the LINEs using writev(), eliminates some copying at the cost of complication
	 * in managing some iovec (especially when not everything wrote); but I have
	 * never used writev() before - so a good reason for me to try it.
	 * Note: the LINEs do not contain a trailing \n; but if there is room (l_size)
	 * add it beyond the l_used, otherwise write Nl.
	 *
	 * This use of writev() might well be more expensive than copy to buffer & write().
	 * Look at the writev.c test program, it suggests that writev saves on user time but
	 * adds to system time; no surprise there I suppose. writev is, overall, more expensive
	 * but the test program is very simple and results will depend on line lengths, etc.
	 * Summary: use of writev() is not completely stupid (and is definitely more fun).
	 *
	 * Lines written to commands always end \n, never \r\n regardless of flag MDDOS.
	 * If the region does not end at the start of a line (ie part way down a line)
	 * then the line will be written without a trailing \n and the \n at the end of
	 * the last line read will be discarded.
	 *
	 * Output of the command if just a stream, look for newlines. Take care that
	 * we don't screw up a UTF8 buffer - check the whole buffer after the last read.
	 *
	 * "." and marks; try to preserve their relative position in the
	 * the region that we replace. Note that this region might not be the
	 * same as normal concept of a region - when filtering the whole buffer.
	 *
	 * Could have forked and have the child write the region. No as:
	 * * extra fork, although copy on write pages helps reduce the work of this
	 * * error handling not so easy
	 */
	BYTE		inbuf[1024];	// Read into here
	struct iovec	ovec[30];	// Up to 30 lines at a time
	int		ovmu = -1;	// ovec index of max with something in it

	/* This is given to poll() */
	struct pollfd	pfd[2] = {
		{ outp[0],	POLLIN,	 0 },
		{  inp[1],	POLLOUT, 0 }
	};

	int		MoreToGenerate = 1;	// More lines to put to iovecs
	nfds_t		MoreToWrite = 1;	// MoreToGenerate or stuff still in iovecs

	/* wrTopLn	Top line in an iov; so when something is written 'consume' this and free()
	 *		when move past it.
	 * wrBotLn	Bottom line in an iov; when there is room in the iov add from here
	 *		When this is written: stop writing.
	 * insertAfter	Lines read in are to be chained after this.
	 *
	 * While we write/read there are disconnected LINE chains, ie chains that can't be reached
	 * from the window/buffer or that don't have valid next/previous pointers. Fix up at
	 * EOF.
	 */
	LINE*		wrTopLn = startLine;
	LINE*		wrBotLn;
	LINE*		insertAfter;
	LINE*		origInsertAfter;	// As insertAfter moves

	char		Nl = '\n';		// For when we just write newline

	BufPos		pos;			// Keep position info here

	RecordDotAndMark(&pos, startLine, endLine);

	origInsertAfter = insertAfter = lback(wrTopLn);		// Insert replacement lines after here
	lsetforw(insertAfter, NULL);

	wrBotLn = wrTopLn;			// Both start at the same place

	// Loop: poll, write, read
	while(1) {

		if(PipeWriteFail)	// Got SIGPIPE - don't write, nothing to read it
			MoreToWrite = 0;

		// What can we read ?
		// We can always read

		// Poll: always try to read, only ask to write if we have something to push.
		// Wait forever (no timeout)
		i = poll(pfd, MoreToWrite + 1, -1);

		if(i < 0) {
			// Signal: prob the command died
			if(errno == EINTR)
				continue;

			// Something nasty, put to buffer
			printToText(playError, "%A""Poll error: %e ", errno);

			break;
		}

		// Process write:
		if(MoreToWrite && pfd[1].revents & POLLOUT) {
			// Fill in ovec
			size_t	ilen = 0;
			ssize_t	bwrote;		// Bytes written

			// What can write ?
			// Beware sizeof() on the line below if ovmu is -ve!
			// Beware also: ovmu will be incremented several times in the loop below
			while(ovmu <= (int)(sizeof(ovec) / sizeof(ovec[0])) - 3) {
				// Some room in ovec array
				ovmu++;
				ovec[ovmu].iov_base = ltext(wrBotLn);
				ovec[ovmu].iov_len = (size_t)lused(wrBotLn);

				// need end check
				if(wrBotLn == endLine) {
					MoreToGenerate = 0;
					ovec[ovmu].iov_len -= (size_t)lused(wrBotLn);
					if(ovec[ovmu].iov_len <= 0) {
						// Nothing to write from the last line
						ovmu--;
						break;	// Filling iovec
					}
				}

				// Need to write \n, see if room at LINE end
				// Only if the write writes the last byte of the line,
				// this might only not be the case on the last line if the
				// end offset is not at the line end.
				if(lused(wrBotLn) < lsize(wrBotLn) &&
				   MoreToGenerate) {
					lputc(wrBotLn, lused(wrBotLn), '\n');
					ovec[ovmu].iov_len++;
					ilen += ovec[ovmu].iov_len;
				} else {
					// Write a single byte:
					ilen +=ovec[ovmu].iov_len;
					ovec[++ovmu].iov_base = &Nl;
					ovec[ovmu].iov_len = 1;
					ilen++;
				}

				if(!MoreToGenerate)
					break;

				wrBotLn = lforw(wrBotLn);
			}

			// Try to read (some of) that (i is bytes read):
			bwrote = writev(inp[1], ovec, ovmu + 1);

			if(bwrote < 0) {
				// Some errors let it try again.
				// With EPIPE we should have got a signal & set PipeWriteFail
				if(errno != EAGAIN && errno != EWOULDBLOCK && errno != EINTR &&
				   errno != EPIPE) {
					printToText(playError, "%A""Write error: %e ", errno);

					break;
				}
			} else {
				int	iovi = 0;	// Iov Index
				int	iovct = 0;	// Iov copy to
				// Work through iovec, each one represents a line written
				// or the \n at the end of one
				ST_fileWroteBytes += bwrote;
				while(bwrote > 0) {
					if(bwrote >= (ssize_t)ovec[iovi].iov_len) {

						// The LINE has been written, free it
						// But do not free if what was written was the free standing \n
						if(ovec[iovi].iov_base != &Nl) {
							LINE*	tLn = wrTopLn;

							if(tLn != endLine /* || endOff == 0 */) {
								wrTopLn = lforw(wrTopLn);

								// Loose alpha marks:
								if(lmarked(tLn))
									l_unmark(curbp, tLn);

								// Loose numeric marks:
								if(lisNmarked(tLn))
									l_unNmark(curbp, tLn);

								FreeLine(tLn);
								curbp->b_numLines--;
							}
						}

						bwrote -= (ssize_t)ovec[iovi].iov_len;
						iovi++;
						// Don't patch the chain, it is dangling from wrTopLn with
						// nothing else pointing to it. A new chain is being built
						// by the read code.
					} else {
						// partial write
						ovec[iovi].iov_len -= (size_t)bwrote;
						ovec[iovi].iov_base = (BYTE*)(ovec[iovi].iov_base) + bwrote;
						bwrote = 0;
					}
				}

				// need to move unwritten ones down to start
				while(ovmu >= iovi)
					ovec[iovct++] = ovec[iovi++];

				ovmu = iovct - 1;
				
				/* No more lines to output and iovecs empty
				 * Set to not poll to see if we can write.
				 * Close our end of the pipe so that the command gets EOF.
				 */
				if( !MoreToGenerate && ovmu == -1) {
					MoreToWrite = 0;
					close(inp[1]);
				}
			}

		}

		// Process read.
		// POLLHUP comes at EOF, but the documentation suggests that there might
		// still be data to read. If not the read() returns 0, so no problem:
		if(pfd[0].revents & (POLLIN | POLLHUP)) {
			ssize_t	bread = read(outp[0], inbuf, sizeof(inbuf));

			if(bread == 0)
				break;	// EOF in, all done, don't care if stuff still left to write

			if(bread < 0) {
				// Some errors let it try again.
				if(errno != EAGAIN && errno != EWOULDBLOCK && errno != EINTR) {
					printToText(playError, "%A""Read error: %e ", errno);

					break;
				}
			} else {
				// Read something. Look for \n and put into LINEs
				BYTE*	bp = inbuf;
				BYTE*	newp;		// Pointer to \n in buffer
				int	lineLen;	// Length of line read in

				ST_fileReadBytes += bread;

				while(bread > 0) {
					LINE*	lp = lforw(insertAfter);
					lineLen = (int)((newp = memchr(bp, '\n', (size_t)bread)) ? newp - bp : bread);

					/* Get somewhere to put it.
					 * Either create a new line or make the current one longer.
					 *
					 * Somewhat contorted logic if !lp - the point is that if
					 * we allocate a new line we must increate the line count.
					 */
					if((!lp && !(lp = lalloc(lineLen)) && ++curbp->b_numLines) ||
					   !lineMoreBytes(lp, lused(lp) + lineLen)) {
						// Out of room
						printToText(playError, "%A""%s", MsgOutOfMemory);

						goto end_read;
					}

					// If we just made a new line
					if(!lforw(insertAfter)) {
						// Append to insert point
						lsetforw(insertAfter, lp);
						lsetback(lp, insertAfter);
					}

					// Copy/append new text in:
					lcatm(lp, bp, (LineLn)lineLen);
					bread -= lineLen + 1;	// +1 for the not copied \n (if there)
					bp += lineLen + 1;

					// If the line is complete (we saw the \n) move the
					// line insert point on.
					if(newp)
						insertAfter = lp;
				}
			}
		}
	}

	/* End of stream or some error so that we do not wish to continue to read/write.
	 *
	 * end_read is for crawl out on out of memory.
	 */
end_read:
	/*
	 * Patch up the chain
	 */
	lsetforw(insertAfter, endLine);
	lsetback(endLine, insertAfter);

	/* The command ended but possibly not everything was written.
	 * Throw what was not written away.
	 * This is the right thing to do, consider if the command was: head -4
	 */
	while(wrTopLn != endLine) {
		LINE*	tLn = wrTopLn;
		wrTopLn = lforw(wrTopLn);

		// Loose alpha marks:
		if(lmarked(tLn))
			l_unmark(curbp, tLn);

		// Loose numeric marks:
		if(lisNmarked(tLn))
			l_unNmark(curbp, tLn);

		FreeLine(tLn);
		curbp->b_numLines--;
	}

	RestoreDotAndMark(&pos, lforw(origInsertAfter), endLine);

	curbp->b_flag |= BFCHG;		// Buffer changed

	/* Close the pipe to the command's stdin and stdout.
	 * This is to ensure that the command will terminate, if it has not
	 * already done so - especially in some error situation.
	 * The close inp[1] will prob already have been done, doing it twice is benign.
	 */
	close( inp[1]);
	close(outp[0]);

	reapChild(pid);

	WaitOnChild = 0;

	/* Check UTF8 if the buffer was in that mode.
	 * Note f value -2, special, see top of main.c
	 */
	if((curbp->b_flag & BFCHG) && !utf8_modecheck(curbp, 1, 0, -2, 0)) {
		// Get the error message, clear UTF8 flag
		printToText(playError, "%A""%s ", utf8_errmsg(1));
	}


off_forkfail:
	// Something gone wrong ?
	if(tused(playError) != 0) {
		if(!FilterCanIntr) {
			// Error to the message line:
			mlwrite("%E""%t", playError);
		} else {
			// Delay reopen of screen, etc, until a prompt has happened,
			// allow the user to see what is on the screen.
			// This can/does result in a messed up screen. Fix TODO
			if(clexec == FALSE)
				mlGetKey(MGC_MAP, NULL, "%t  %s", playError, "Press enter to continue: ");
		}
	}

	// Reopen the screen:
	if(FilterCanIntr) {
		sgarbf = TRUE;
		agetime = TRUE;			/* time to age buffers	*/

		ttreopen(TTREopen | TTREpaint);
	}

	// Files might have become out of date
	agetime = TRUE;

	// Return FALSE if it looks that something went wrong:
	return(tused(playError) == 0 ? TRUE : FALSE);
}
#endif

/* Filter a buffer/narrow through an external program.
 *
 * If there is a narrow in effect: just filter that part of the buffer.
 * Prompt the user B# - or N# if there is a narrow in effect.
 *
 * Note that this filters whole lines, filter-region can filter part(s) of
 * lines - maybe just one word.
 *
 * Count is ignored, should be unset.
 *
 * Command:  filter-buffer
 * Bound to: C-x #
 *
 * Return TRUE is all OK
 *	  FALSE because:
 *	      * shell (filter) command does not exit 0
 *	      * error creating pipes
 *	      * cannot fork
 *	      * poll error - prob problem with filter command
 *	      * error reading/writing from/to a pipe
 *	      * UTF-8 error on what is read in (if buffer in UTF-8 mode)
 *	  ABORT C-g
 */
int	filterBuffer(int f, Cnt n)
{
#if	UNIX
	int	i;
	char*	prompt = "B#";

	if(curbp->b_btopline != curbp->b_linep || curbp->b_abotline != curbp->b_linep)
		prompt = "N#";

	// Get the filter command
	if((i = mlprompt(prompt, MLSHELLCOMM | MLLN0END, bmlCmdHistp)) != TRUE)
		return(i);

	// Filter the whole buffer:
	return filterLines(bmlCmdHistp->b_dotp, lforw(curbp->b_btopline), curbp->b_abotline);

#else	// UNIX

	/* Non Unix, achieve filtering by writing the buffer to a file (eg: fltinp),
	 * run the command with output to another file (eg: fltout),
	 * replace the buffer contents.
	 */


        register int    s;		/* return status from CLI */
	register BUFFER *bp;		/* pointer to buffer to zot */
	char*		tmpnam;		/* place to store real file name */
	char*		tmpnamClean;	/* place to store real file name */
	static char	bname1[] = "fltinp";
	int		exitstatus;	/* exit status of command */

#if	AMIGA
	static char filnam1[] = "ram:fltinp";
	static char filnam2[] = "ram:fltout";
        long newcli;
#else
	static char filnam1[] = "fltinp";
	static char filnam2[] = "fltout";
#endif

#if     VMS
	mlwrite("Not availible under VMS");
	return(FALSE);
#endif
#if     CPM
        mlwrite("Not availible under CP/M");
        return(FALSE);
#endif

	/* get the filter name and its args */
	if((s = mlprompt("#", MLSHELLCOMM | MLLN0END, bmlCmdHistp)) != TRUE)
		return(s);

	/* setup the proper file names */
	bp = curbp;
	tmpnam = bp->b_fname;			/* save the original name */
	tmpnamClean = bp->b_fnameClean;
	setFnames(bp, bname1);			/* set it to our new one */

	/* write it out, checking for errors */
	if(writeout(filnam1, WOUT_NONE) != TRUE) {
		mlwrite("%ECannot write filter file");
		free(bp->b_fname);
		bp->b_fname = tmpnam;
		free(bp->b_fnameClean);
		bp->b_fnameClean = tmpnamClean;
		return(FALSE);
	}

#if     AMIGA
        newcli = Open("CON:0/0/640/200/MicroEMACS Subprocess", NEW);
	lcats(bmlCmdHistp->b_dotp, " <ram:fltinp >ram:fltout");
        Execute(ltext(bmlCmdHistp->b_dotp),0L,newcli);
	s = TRUE;
        Close(newcli);
        sgarbf = TRUE;
#endif
#if     MSDOS || (ST520 && MWC)
	lcats(bmlCmdHistp->b_dotp, " <fltinp >fltout");
	movecursor(AllocLines - 1, 0);
	TTkclose();
#if     MSDOS && (AZTEC || MSC || TURBO)
	shellprog(ltext(bmlCmdHistp->b_dotp));
#else
	system(ltext(bmlCmdHistp->b_dotp));
#endif
	TTkopen(FALSE);
        sgarbf = TRUE;
	s = TRUE;
#endif	// MSDOS || (ST520 && MWC)

	/* on failure, escape gracefully */
	if(s != TRUE || (readin(filnam2, FALSE, FALSE, FALSE) == FALSE)) {
		mlwrite("%EExecution failed");
		free(bp->b_fname);
		bp->b_fname = tmpnam;
		free(bp->b_fnameClean);
		bp->b_fnameClean = tmpnamClean;
		unlink(filnam1);
		unlink(filnam2);
		return(s);
	}

	bp->b_flag |= BFCHG;	/* flag it as changed */
	/* reset file name */
	free(bp->b_fname);
	bp->b_fname = tmpnam;	/* restore name */
	free(bp->b_fnameClean);
	bp->b_fnameClean = tmpnamClean;

	/* and get rid of the temporary file */
	unlink(filnam1);
	unlink(filnam2);
	return(TRUE);
#endif	// UNIX
}

/* Filter the current region, replace with the output of the command.
 *
 * Only on UNIX - not bothered with other operating systems -- yet.
 *
 * The command should not write to stderr unless there is a real error.
 *
 * Count is ignored, should be unset.
 *
 * Command:  filter-region
 * Bound to: M-#
 *
 * Return TRUE is all OK
 *	  FALSE because:
 *	      * shell (filter) command does not exit 0
 *	      * error creating pipes
 *	      * cannot fork
 *	      * poll error - prob problem with filter command
 *	      * error reading/writing from/to a pipe
 *	      * UTF-8 error on what is read in (if buffer in UTF-8 mode)
 *	      * there is not a region - ie not a mark
 *	      * the region is empty - ie zero size
 */
int	filterRegion(int f, Cnt n)
{
#if	UNIX
	REGION	region;
	LINE*	endLine;
	LINE*	startLine;
	LINE*	startBack;		// The LINE before startLINE
	LineLn	endOff;
	LineLn	startOff;
	BYTE*	startSave = NULL;	// startOff bytes saved here
	BYTE*	endSave = NULL;		// Text saved after end of region but on the same line
	LineLn	endSaveLen = 0;		// How much is saved at endSave - init to stop compiler winge
	int	retStatus = TRUE;
	int	i;
	int	startDot;		// It is "." that is the start of region
	int	OneLine;		// True if startLine == endLine

	// Find the start of the region -- if we have one
	if((i = getregion(&region)) != TRUE)
		return(i);

	// Abandon if mark and "." are in the same place, zero sized region.
	// curwp->w_dotp == curwp->w_markp && curwp->w_doto == curwp->w_marko
	// Maybe this should succeed by doing nothing; but that might be the wrong
	// thing to do if the command has some side effect.
	if(region.r_size == 0) {
		mlwrite("%WEmpty region. Mark and '.' are at the same place");
		return(FALSE);
	}

	// Work out where the region begins & ends.
	// It could be either the mark OR "." at the start - and the other at the other end
	if(region.r_linep == curwp->w_markp) {
		startDot = 0;

		startLine = curwp->w_markp;
		startOff = curwp->w_marko;

		endLine = curwp->w_dotp;
		endOff = curwp->w_doto;
	} else {
		startDot = 1;

		startLine = curwp->w_dotp;
		startOff = curwp->w_doto;

		endLine = curwp->w_markp;
		endOff = curwp->w_marko;
	}

	// Do now before we change them:
	OneLine = startLine == endLine;
	if(OneLine && endOff < startOff) {
		// Ensure that the end is after the start:
		LineLn	so = startOff;
		startOff = endOff;
		endOff = so;
		startDot = 1 - startDot;
	}

	// Get the filter command
	if((i = mlprompt("R#", MLSHELLCOMM | MLLN0END, bmlCmdHistp)) != TRUE)
		return(i);

	// filterLines() works on whole lines
	// If one/both of the region ends are part way down a line, break
	// the line - then once done join them back together.
	// Beware the case where the region is part of just one line.
	if(startOff) {
		if(startOff == lused(startLine)) {
			// Start at end of line
			// Move start to start of next line, but set offset to -1
			// so that we know that we need to return back
			startLine = lforw(startLine);
			startOff = -1;
		} else {
			// There is some text before the start of what we filter.
			// Save the text up to the offset
			if( !(startSave = malloc((size_t)startOff))) {
				mlwrite(MsgOutOfMemory);
				retStatus = FALSE;
				goto off;
			}
			memcpy(startSave, ltext(startLine), (size_t)startOff);

			// Copy what remains down and shorten
			memmove(ltext(startLine), lgetcaddr(startLine, startOff), (size_t)(lused(startLine) - startOff));
			lsetused(startLine, lused(startLine) - startOff);

			if(startLine == endLine)
				endOff -= startOff;
		}
	}

	if(endOff) {
		if(endOff == lused(endLine)) {
			// End is end of line
			endLine = lforw(endLine);
			endOff = -1;
		} else {
			// Copy off rest of the line after the end point
			endSaveLen = lused(endLine) - endOff;

			if( !(endSave = malloc((size_t)endSaveLen))) {
				mlwrite(MsgOutOfMemory);
				retStatus = FALSE;
				goto off;
			}

			memcpy(endSave, lgetcaddr(endLine, endOff), (size_t)endSaveLen);
			lsetused(endLine, lused(endLine) - endSaveLen);

			endLine = lforw(endLine);
		}
	}


	startBack = lback(startLine);

	// Filter the region:
	if((i = filterLines(bmlCmdHistp->b_dotp, startLine, endLine)) != TRUE)
		return(i);

	startLine = lforw(startBack);

	// if(oneLine) - there should be only one line that came back.
	// unset oneLine if not.
	if(lforw(startLine) != endLine)
		OneLine = 0;

	// Join back together
	if(startOff) {
		if(startOff == -1) {
			// Was at the end of the previous line
			startLine = startBack;
			startOff = lused(startLine);
		} else {
			// The text that is in startSave at the start of
			// the replaced line.
			if(!lineMoreBytes(startLine, lused(startLine) + startOff)) {
				fprintf(stderr, "Whoops malloc\n");	// error
				retStatus = FALSE;
				goto off;
			}
			memmove(lgetcaddr(startLine, startOff), ltext(startLine), (size_t)lused(startLine));
			memcpy(ltext(startLine), startSave, (size_t)startOff);
			lsetused(startLine, lused(startLine) + startOff);

			// Mark/"." will be at the end of what we have just restored
		}
	}

	// endLine should still point to a valid LINE
	if(endOff) {
		if(endOff == -1) {
			endLine = lback(endLine);
			endOff = lused(endLine);
		} else {

			if(OneLine)
				endLine = startLine;
			else
				endLine = lback(endLine);

			// Append what is at endSave to endLine
			// Ignore warnings about uninitialised endSaveLen
			if(!lineMoreBytes(endLine, lused(endLine) + endSaveLen)) {
				fprintf(stderr, "Whoops malloc\n");	// error
				retStatus = FALSE;
				goto off;
			}

			memcpy(lgetcaddr(endLine, lused(endLine)), endSave, (size_t)endSaveLen);
			endOff = lused(endLine);
			lsetused(endLine, lused(endLine) + endSaveLen);
		}
	}

	/* Put the mark & "." back around the region
	 */
	curwp->w_markp = startLine;
	curwp->w_marko = startOff;
	curwp->w_dotp = endLine;
	curwp->w_doto = endOff;
	if(startDot)
		swapmark(FALSE, 0);

off:
	if(startSave)
		free(startSave);
	if(endSave)
		free(endSave);

	return(retStatus);

#else

	// It should not be too hard to do
	mlwrite("%ENot implemented");

	return(FALSE);

#endif	// UNIX
}

#if     VMS
/* Run a command. The "cmd" is a pointer to a command string, or NULL if you
 * want to run a copy of DCL in the subjob (this is how the standard routine
 * LIB$SPAWN works. You have to do wierd stuff with the terminal on the way in
 * and the way out, because DCL does not want the channel to be in raw mode.
 */
int	sys(char* cmd)
{
        struct  dsc$descriptor  cdsc;
        struct  dsc$descriptor  *cdscp;
        long    status;
        long    substatus;
        long    iosb[2];

        status = SYS$QIOW(EFN, iochan, IO$_SETMODE, iosb, 0, 0,
                          oldmode, sizeof(oldmode), 0, 0, 0, 0);
        if(status!=SS$_NORMAL || (iosb[0]&0xFFFF)!=SS$_NORMAL)
                return(FALSE);
        cdscp = NULL;                           /* Assume DCL.          */
        if(cmd != NULL) {                       /* Build descriptor.    */
                cdsc.dsc$a_pointer = cmd;
                cdsc.dsc$w_length  = strlen(cmd);
                cdsc.dsc$b_dtype   = DSC$K_DTYPE_T;
                cdsc.dsc$b_class   = DSC$K_CLASS_S;
                cdscp = &cdsc;
        }
        status = LIB$SPAWN(cdscp, 0, 0, 0, 0, 0, &substatus, 0, 0, 0);
        if(status != SS$_NORMAL)
                substatus = status;
        status = SYS$QIOW(EFN, iochan, IO$_SETMODE, iosb, 0, 0,
                          newmode, sizeof(newmode), 0, 0, 0, 0);
        if(status!=SS$_NORMAL || (iosb[0]&0xFFFF)!=SS$_NORMAL)
                return(FALSE);
        if((substatus&STS$M_SUCCESS) == 0)     /* Command failed.      */
                return(FALSE);
        return(TRUE);
}
#endif

#if	~AZTEC && ~MSC && ~TURBO && MSDOS

/* This routine, once again by Bob McNamara, is a C translation of the "system"
 * routine in the MWC-86 run time library. It differs from the "system" routine
 * in that it does not unconditionally append the string ".exe" to the end of
 * the command name. We needed to do this because we want to be able to spawn
 * off "command.com". We really do not understand what it does, but if you don't
 * do it exactly "malloc" starts doing very very strange things.
 */
int	sys(char* cmd, char* tail)
{
#if MWC
        register unsigned n;
        extern   char     *__end;

        n = __end + 15;
        n >>= 4;
        n = ((n + dsreg() + 16) & 0xFFF0) + 16;
        return(execall(cmd, tail, n));
#endif

#if LATTICE
        return(forklp(cmd, tail, (char *)NULL));
#endif
}
#endif

#if	MSDOS && LATTICE
/*	System: a modified version of lattice's system() function
 *		that detects the proper switchar and uses it
 *		written by Dana Hogget.
 */
int	system(cmd)
	char*	cmd;	/*  Incoming command line to execute  */
{
	static char *swchar = "/C";	/*  Execution switch  */
	union REGS inregs;	/*  parameters for dos call  */
	union REGS outregs;	/*  Return results from dos call  */
	char *p;		/*  Temporary pointer  */
	int ferr;		/*  Error condition if any  */

	/*  get name of system shell  */
	if(shell == (char*)NULL)
		return(-1);		/*  No shell located  */

	p = cmd;
	while(isspace(*p)) {		/*  find out if null command */
		p++;
	}

	/**  If the command line is not empty, bring up the shell  **/
	/**  and execute the command.  Otherwise, bring up the     **/
	/**  shell in interactive mode.   **/

	if(p && *p) {
		/**  detect current switch character and us it  **/
		inregs.h.ah = 0x37;	/*  get setting data  */
		inregs.h.al = 0x00;	/*  get switch character  */
		intdos(&inregs, &outregs);
		*swchar = outregs.h.dl;
		ferr = forkl(shell, "command", swchar, cmd, (char *)NULL);
	} else {
		ferr = forkl(shell, "command", (char *)NULL);
	}

	return(ferr ? ferr : wait());
}
#endif

#if	MSDOS && LATTICE
extern int _oserr;
#endif

#if	MSDOS && AZTEC
extern int errno;
#endif

#if	MSDOS && (TURBO || LATTICE || AZTEC || MSC)
/* SHELLPROG: Execute a command in a subshell
 *
 * cmd	Incoming command line to execute
 */
int	shellprog(char* cmd)
{
	char swchar;		/* switch character to use */
	union REGS regs;	/* parameters for dos call */
	char comline[NSTRING];	/* constructed command line */

	/*  detect current switch character and set us up to use it */
	regs.h.ah = 0x37;	/*  get setting data  */
	regs.h.al = 0x00;	/*  get switch character  */
	intdos(&regs, &regs);
	swchar = (char)regs.h.dl;

	/*  Check that we know about a shell */
	if(shell == (char*)NULL)
		return(FALSE);		/*  No shell located  */

	/* trim leading whitespace off the command */
	while(*cmd == ' ' || *cmd == '\t')	/*  find out if null command */
		cmd++;

	/**  If the command line is not empty, bring up the shell  **/
	/**  and execute the command.  Otherwise, bring up the     **/
	/**  shell in interactive mode.   **/

	if(*cmd) {
		strcpy(comline, shell);
		strcat(comline, " ");
		comline[strlen(comline) + 1] = 0;
		comline[strlen(comline)] = swchar;
		strcat(comline, "c ");
		strcat(comline, cmd);
		return(execprog(comline));
	} else
		return(execprog(shell));
}

/*	EXECPROG:	A function to execute a named program
 *			with arguments
 *
 * cmd	Incoming command line to execute
 *
 * WARNING: potential buffer overflow of prog[]
 */
int	execprog(const char* cmd)
{
	char *sp;		/* temporary string pointer */
	char f1[38];		/* FCB1 area (not initialized */
	char f2[38];		/* FCB2 area (not initialized */
	char prog[NSTRING];	/* program filespec */
	char tail[NSTRING];	/* command tail with length byte */
	union REGS regs;	/* parameters for dos call  */
	struct SREGS segreg;	/* segment registers for dis call */
	struct pblock {		/* EXEC parameter block */
		short envptr;	/* 2 byte pointer to environment string */
		char *cline;	/* 4 byte pointer to command line */
		char *fcb1;	/* 4 byte pointer to FCB at PSP+5Ch */
		char *fcb2;	/* 4 byte pointer to FCB at PSP+6Ch */
	} pblock;

	/* parse the command name from the command line */
	sp = prog;
	while(*cmd && (*cmd != ' ') && (*cmd != '\t'))
		*sp++ = *cmd++;
	*sp = 0;

	/* and parse out the command tail */
	while(*cmd && ((*cmd == ' ') || (*cmd == '\t')))
		++cmd;
	*tail = (char)(strlen(cmd)); /* record the byte length */
	strcpy(&tail[1], cmd);
	strcat(&tail[1], "\r");

	/* look up the program on the path trying various extentions */
	if((sp = flook(prog, TRUE)) == NULL)
		if((sp = flook(strcat(prog, ".exe"), TRUE)) == NULL) {
			strcpy(&prog[strlen(prog)-4], ".com");
			if((sp = flook(prog, TRUE)) == NULL)
				return(FALSE);
		}
	strcpy(prog, sp);

	/* get a pointer to this PSPs environment segment number */
	segread(&segreg);

	/* set up the EXEC parameter block */
	pblock.envptr = 0;	/* make the child inherit the parents env */
	pblock.fcb1 = f1;		/* point to a blank FCB */
	pblock.fcb2 = f2;		/* point to a blank FCB */
        pblock.cline = tail;		/* parameter line pointer */

	/* and make the call */
	regs.h.ah = 0x4b;	/* EXEC Load or Execute a Program */
	regs.h.al = 0x00;	/* load end execute function subcode */
#if	AZTEC
	regs.x.ds = ((unsigned long)(prog) >> 16);	/* program name ptr */
#else
	segreg.ds = ((unsigned long)(prog) >> 16);	/* program name ptr */
#endif
	regs.x.dx = (unsigned int)(prog);
#if	AZTEC
	regs.x.es = regs.x.ds;
	/*regs.x.es = ((unsigned long)(&pblock) >> 16);	* set up param block ptr */
#else
	segreg.es = ((unsigned long)(&pblock) >> 16);	/* set up param block ptr */
#endif
	regs.x.bx = (unsigned int)(&pblock);
#if	LATTICE
#define	CFLAG	1
	if((intdosx(&regs, &regs, &segreg) & CFLAG) == 0) {
		regs.h.ah = 0x4d;	/* get child process return code */
		intdos(&regs, &regs);	/* go do it */
		rval = regs.x.ax;	/* save child's return code */
	} else
		rval = -_oserr;		/* failed child call */
#endif
#if	AZTEC
#define	CFLAG	1
	if((sysint(0x21, &regs, &regs) & CFLAG) == 0) {
		regs.h.ah = 0x4d;	/* get child process return code */
		sysint(0x21, &regs, &regs);	/* go do it */
		rval = regs.x.ax;	/* save child's return code */
	} else
		rval = -errno;		/* failed child call */
#endif
#if	(TURBO || MSC)
	intdosx(&regs, &regs, &segreg);
	if(regs.x.cflag == 0) {
		regs.h.ah = 0x4d;	/* get child process return code */
		intdos(&regs, &regs);	/* go do it */
		rval = regs.x.ax;	/* save child's return code */
	} else
		rval = -_doserrno;	/* failed child call */
#endif
	return((rval < 0) ? FALSE : TRUE);
}
#endif

#if     UNIX
/* Create a child - fork()
 * If that fails generate an error message in playError &
 * display it - appending to current line.
 *
 * Set rval (child exit code) to EXIT_BADFORK.
 *
 * Return what fork() returns.
 */
pid_t	doFork(void)
{
	pid_t	pid;

	if((pid = fork()) == -1) {
		printToText(playError, "Creation of child process failed: %e", errno);
		mlwrite("%A""%E""%t", playError);
		rval = EXIT_BADFORK;
	}

	return(pid);
}

/* Execute the command cmd using the shell.
 * This is intended to be used in a child process - ie after fork().
 *
 * cmd		The command to execute
 * sigDfl	If true reset signals INT & QUIT to default so that the child can be
 *		interrupted. They may have been set to ignore.
 *
 * Close all FDs higher than STDERR. Since we are the child, we don't want all
 * those useless ol' file descriptors for the all the other popens, etc that
 * we've ever done.
 *
 * On error write something to stderr.
 * Don't use mlwrite() - too complicated for here and in the wrong process.
 *
 * Exit the child with code 127 - this is the convention for command
 * (in this case shell) not found ... so prob not quite right.
 */
void	doExecl(const char* cmd, int sigDfl)
{
	int	i;

	// This closes far more than we will have ever opened:
	for(i = STDERR_FILENO + 1; i < 20; i++)
		close(i);

	if(sigDfl) {
		/* We want the children to die on interrupt/quit */
		(void) signal(SIGINT,  SIG_DFL);
		(void) signal(SIGQUIT, SIG_DFL);
	}

	(void) execl(shell, shell_name, "-c", cmd, (char *)NULL);

	// Simple write to stderr, avoid stdio:
	ErrorWriteList("Exec of '", cmd, "' failed: ", strerror(errno), (char*)NULL);

	_exit(127);
}

/* Wait for child pid to die.
 *
 * pid	The process id to wait for
 *
 * Store the process exit status in rval ($rval).
 *
 * Append any comment about the exit status of the child to playError,
 * any such message will have a trailing space.
 * If the process exits code 0 - nothing is appended.
 *
 * It is up to the caller of this function to display playError.
 *
 * Return the process exit code.
 */
int	reapChild(pid_t pid)
{
	int	status;		// Exit status
	pid_t	wpid;		// What wait() returns

	/* Pick up the command exit status, no zombies here!
	 *
	 * Then work out what to say about how the command ended.
	 */
	while((wpid = wait(&status)) != pid)
		if(wpid == -1) {
			if(errno == EINTR)
				continue;

			rval = EXIT_UNKNOWN;
			printToText(playError, "%A""Unknown wait: %e", errno);
			break;
		}

	if(wpid != -1) {
		if(WIFEXITED(status)) {
			rval = WEXITSTATUS(status);
			if(rval != 0)
				printToText(playError, "%A""Exit code %d ", rval);
		} else {
			/* It didn't end cleanly, make a message that can be shown to the
			 * user saying what happened.
			 * If something died as a result of a signal, it would be nice to
			 * show the signal, we might just get the exit code of the shell
			 * that runs the command and different shells report differently, eg
			 * if the command is terminated by signal n:
			 * bash: 128+n	-- if got a signal, do it this way as regards rval
			 * ksh: 256+n
			 */
			if(WIFSIGNALED(status)) {
				// Try & get a name for the signal
				char*	sigdesc = strsignal(WTERMSIG(status));
				if(sigdesc == (char*)NULL)
					sigdesc = "unknown";

				printToText(playError, "%A""Ended by signal %d (%s) ",
					WTERMSIG(status), sigdesc);
				if(WCOREDUMP(status))
					printToText(playError, "%A""(dumped core) ");
				rval = WTERMSIG(status) + EXIT_SIGOFFSET;
			} else {
				printToText(playError, "%A""Command in unknown state ");
				rval = EXIT_UNKNOWN;
			}
		}
	}

	return(rval);
}

#endif	// UNIX

/* end */
