/*
 * ADDW SCCS: @(#)termio.c	1.75 10/15/20 17:45:47
 */

/* If compiling on Linux, we want to use setbuffer(), ensure that we have it.
 * _BSD_SOURCE has been deprecated & replaced by _DEFAULT_SOURCE some time 2015-2016-ish. Glibc 2.20
 */
#ifdef	LINUX5
#define	_DEFAULT_SOURCE	0
#define	_BSD_SOURCE	0
#endif

/*
 * The functions in this file negotiate with the operating system for
 * characters, and write characters in a barely buffered fashion on the display.
 * All operating systems.
 */
#include	"estruct.h"

#include	<signal.h>

#include	"utf8.h"
#include        "edef.h"

#if	SHOWMODREL
char	trmiovers[] = "@(#)termio.c	1.75 10/15/20 17:45:47";
#endif

#if   MSDOS && TURBO
#include <conio.h>
#endif

#if     AMIGA
#define NEW 1006L
#define AMG_MAXBUF      1024L
static long terminal;
static char	scrn_tmp[AMG_MAXBUF+1];
static long	scrn_tmp_p = 0;
#endif

#if     VMS
#include        <stsdef.h>
#include        <ssdef.h>
#include        <descrip.h>
#include        <iodef.h>
#include        <ttdef.h>
#include	<tt2def.h>

#define NIBUF   128                     /* Input buffer size            */
#define NOBUF   1024                    /* MM says bug buffers win!     */
#define EFN     0                       /* Event flag                   */

char	obuf[NOBUF];                    /* Output buffer                */
int     nobuf;				/* # of bytes in above		*/
char    ibuf[NIBUF];                    /* Input buffer			*/
int     nibuf;				/* # of bytes in above		*/
int     ibufi;				/* Read index			*/
int     oldmode[3];                     /* Old TTY mode bits            */
int     newmode[3];                     /* New TTY mode bits            */
short   iochan;				/* TTY I/O channel             */
#endif	/* VMS */

#if     CPM
#include        <bdos.h>
#endif

#if     MSDOS && (LATTICE || MSC || TURBO || AZTEC || MWC86)
union REGS rg;		/* cpu register for use of DOS calls */
int nxtchar = -1;	/* character held from type ahead    */
#endif

#if RAINBOW
#include "rainbow.h"
#endif

#if	USG			/* System V */

#include	<signal.h>

/* Try & work out if we have termio or termios.
 * I don't really want to have to specify this on the command line.
 */
#ifdef	SIGSTOP
#include	<termios.h>
#else
#include	<termio.h>
#endif

#include	<setjmp.h>
#include	<sys/time.h>

int		UxPeekStdin(long ttytimeout);

/* Beware: if we have the termios structure we must use it, if we don't
 * we may exceed the bounds of the c_cc array when setting things like
 * VDISCARD. c_cc is NCC big in termio and NCCS big in termios.
 * We also need to use different system calls to get/set it.
 * Use the presence of the NCCS #define to tell us which case we have.
 */

#ifdef	NCCS
static	struct	termios	otermio;	/* original terminal characteristics */
static	struct	termios	ntermio;	/* charactoristics to use inside */
#else
static	struct	termio	otermio;	/* original terminal characteristics */
static	struct	termio	ntermio;	/* charactoristics to use inside */
#endif

#endif	/* USG */

#if V7 || BSD_UNIX
#undef	CTRL
#include	<sgtty.h>		/* for stty/gtty functions */
#include	<signal.h>
#include	<setjmp.h>
static	struct	sgttyb	ostate;		/* saved tty state */
static	struct	sgttyb	nstate;		/* values for editor mode */
static	struct	tchars	otchars;	/* Saved terminal special character set */
static	struct	tchars	ntchars = { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };
					/* A lot of nothing */
#if  BSD_UNIX
#include <sys/ioctl.h>			/* to get at the typeahead */
#define	TBUFSIZ	128
static	char	tobuf[TBUFSIZ];		/* terminal output buffer */
static	struct	ltchars	oltchars;
static	struct	ltchars	nltchars;
#endif	/*  BSD_UNIX	    */
#endif	/* V7 || BSD_UNIX */

#ifdef	LINUX5
#define	TBUFSIZ		1024
static	char	tobuf[TBUFSIZ];		/* terminal output buffer */
#endif

#if	WINSIZE				/* UNIX Window size change supported		*/

#include <termios.h>
#if	NEEDSYSIOCTL
#include <sys/ioctl.h>
#endif
#include <signal.h>
#include <setjmp.h>

#endif	// WINSIZE

/* This function is called once to set up the terminal device streams.
 * On VMS, it translates TT until it finds the terminal, then assigns
 * a channel to it and sets it raw. On CPM it is a no-op.
 *
 * Always returns 0.
 */
int	ttopen(void)
{
#if     AMIGA
	char oline[NSTRING];
#if	AZTEC
	extern	Enable_Abort;	/* Turn off ctrl-C interrupt */

	Enable_Abort = 0;	/* for the Manx compiler */
#endif
	strcpy(oline, "RAW:0/0/640/200/");
	strcat(oline, PROGNAME);
	strcat(oline, " ");
	strcat(oline, VERSION);
	strcat(oline, "/Amiga");
        terminal = Open(oline, NEW);
#endif
#if     VMS
        struct  dsc$descriptor  idsc;
        struct  dsc$descriptor  odsc;
        char    oname[40];
        int     iosb[2];
        int     status;

        odsc.dsc$a_pointer = "TT";
        odsc.dsc$w_length  = strlen(odsc.dsc$a_pointer);
        odsc.dsc$b_dtype        = DSC$K_DTYPE_T;
        odsc.dsc$b_class        = DSC$K_CLASS_S;
        idsc.dsc$b_dtype        = DSC$K_DTYPE_T;
        idsc.dsc$b_class        = DSC$K_CLASS_S;
        do {
                idsc.dsc$a_pointer = odsc.dsc$a_pointer;
                idsc.dsc$w_length  = odsc.dsc$w_length;
                odsc.dsc$a_pointer = &oname[0];
                odsc.dsc$w_length  = sizeof(oname);
                status = LIB$SYS_TRNLOG(&idsc, &odsc.dsc$w_length, &odsc);
                if (status!=SS$_NORMAL && status!=SS$_NOTRAN)
                        exit(status);
                if (oname[0] == 0x1B) {
                        odsc.dsc$a_pointer += 4;
                        odsc.dsc$w_length  -= 4;
                }
        } while (status == SS$_NORMAL);
        status = SYS$ASSIGN(&odsc, &iochan, 0, 0);
        if (status != SS$_NORMAL)
                exit(status);
        status = SYS$QIOW(EFN, iochan, IO$_SENSEMODE, iosb, 0, 0,
                          oldmode, sizeof(oldmode), 0, 0, 0, 0);
        if (status!=SS$_NORMAL || (iosb[0]&0xFFFF)!=SS$_NORMAL)
                exit(status);
        newmode[0] = oldmode[0];
        newmode[1] = oldmode[1] | TT$M_NOECHO;
        newmode[1] &= ~(TT$M_TTSYNC|TT$M_HOSTSYNC);
        newmode[2] = oldmode[2] | TT2$M_PASTHRU;
        status = SYS$QIOW(EFN, iochan, IO$_SETMODE, iosb, 0, 0,
                          newmode, sizeof(newmode), 0, 0, 0, 0);
        if (status!=SS$_NORMAL || (iosb[0]&0xFFFF)!=SS$_NORMAL)
                exit(status);
        term.t_nrow = (newmode[1]>>24);
        term.t_ncol = newmode[0]>>16;

#endif

#if     CPM
#endif

#if	MSDOS && (HP150 == 0) && LATTICE
	/* kill the ctrl-break interupt */
	rg.h.ah = 0x33;		/* control-break check dos call */
	rg.h.al = 1;		/* set the current state */
	rg.h.dl = 0;		/* set it OFF */
	intdos(&rg, &rg);	/* go for it! */
#endif

#ifdef	LINUX5
	speed_t	ispeed;		// Input speed according to stty termio call
	tcflag_t iflag;		// What is removed from c_iflag

// See man cfsetospeedw
static	int	BaudTable[] = { 0, 50, 75, 110, 134, 150, 200, 300, 600, 1200, 1800,
				2400, 4800, 9600, 19200, 38400, 57600, 115200, 230400 };

#endif

#if	USG

	// This might fail if stdin is not connected to a terminal
#ifdef	NCCS
	if(tcgetattr(0, &otermio) == -1)	/* save old settings */
		Die("Error initialising terminal: %s", strerror(errno));
#else
	if(ioctl(0, TCGETA, &otermio) == -1)	/* save old settings */
		Die("Error initialising terminal: %s", strerror(errno));
#endif

	ntermio = otermio;

#ifndef	OCRNL
#define	OCRNL	0
#endif

	/* Us or OS that does the suspend.
	 * If true - we do it, ie not the OS.
	 */
	if(catchsuspend)
		ntermio.c_lflag &= (tcflag_t)~(ICANON|ECHO|ISIG|IEXTEN);
	else
		ntermio.c_lflag &= (tcflag_t)~(ICANON|ECHO|IEXTEN);	/* ISIG left in for ^Z - addw */

	// What do we remove from c_iflag
	iflag = (ICRNL|INLCR|IGNCR);
	if( !xon_xoff) {			// C-s/C-q (hardware) flow control ?
		iflag |= IXON;			// Switch off on input - ie sent from remove end
		ntermio.c_cc[VSTART] = 0377;	// Remove C-q
		ntermio.c_cc[VSTOP]  = 0377;	// Remove C-s
	}

	ntermio.c_iflag &= (tcflag_t)~iflag;
	ntermio.c_oflag &= (tcflag_t)~(OPOST|ONLCR|OCRNL);	// Disable output processing, includes: \n -> \r\n
	ntermio.c_cc[VMIN] = 1;
	ntermio.c_cc[VTIME] = 0;

	ntermio.c_cc[VINTR] = 0377;
	ntermio.c_cc[VQUIT] = 0377;
#ifdef	VLNEXT
	ntermio.c_cc[VLNEXT] = 0377;
#endif
#ifdef	DSUSP
	if(catchsuspend)
		ntermio.c_cc[DSUSP] = 0377;
#endif
#ifdef	VDSUSP
	ntermio.c_cc[VDSUSP] = 0377;
#endif
#ifdef	VDISCARD
	ntermio.c_cc[VDISCARD] = 0377;
#endif

#ifdef	NCCS
	if(tcsetattr(0, TCSADRAIN, &ntermio) == -1)	/* and activate them */
		Die("Error initialising terminal: %s", strerror(errno));
#else
	if(ioctl(0, TCSETA, &ntermio) == -1)		/* and activate them */
		Die("Error initialising terminal: %s", strerror(errno));
#endif

#ifdef	SIGTSTP				/* USG as well as  BSD_UNIX these days */
	/* Set signals so that we can suspend & restart Emacs.
	 * Might get compiler warning below as rtfrmshell() & bktoshell()
	 * take 2 int args but below we cast to them taking one int arg
	 * (as wanted by signal()). Ignore the warning as neither function
	 * looks at its arguments.
	 */
	signal(SIGTSTP,(SigType(*)(int))bktoshell);
	signal(SIGCONT,(SigType(*)(int))rtfrmshell);
#endif

	/* Find out how big the kernel thinks the tty is. NB we also do this
	 * on de-suspend, in case it got changed when we were asleep.
	 */
	GetTermDims();

#endif	// USG

#if     V7 || BSD_UNIX
	if(gtty(0, &ostate) == -1)		/* save old state */
		Die("Error initialising terminal: %s", strerror(errno));
	nstate = ostate;			/* get base of new state */
#if	CBMODE
	nstate.sg_flags |=  CBREAK;
	nstate.sg_flags &= ~(ECHO | CRMOD | XTABS);
#else
        nstate.sg_flags |= RAW;
        nstate.sg_flags &= ~(ECHO|CRMOD);       /* no echo for now... */
#endif	/* CBMODE */
	if(stty(0, &nstate) == -1)		/* set mode */
		Die("Error initialising terminal: %s", strerror(errno));

#if	CBMODE
	if(ioctl (0, TIOCGETC, &otchars) == -1)
		Die("Error initialising terminal: %s", strerror(errno));
	ntchars = otchars;
	ntchars.t_intrc = -1;
	ntchars.t_quitc = -1;
	ntchars.t_startc = 021;
	ntchars.t_stopc = 023;
	ntchars.t_eofc = -1;
	ntchars.t_brkc = -1;
	if(ioctl (0, TIOCSETC, &ntchars) == -1)
		Die("Error initialising terminal: %s", strerror(errno));
#endif
#if	 BSD_UNIX
	if(ioctl (0, TIOCGLTC, &oltchars) == -1)
		Die("Error initialising terminal: %s", strerror(errno));
	nltchars = oltchars;
	nltchars.t_suspc = -1;
	nltchars.t_dsuspc = -1;
	nltchars.t_rprntc = -1;
	nltchars.t_flushc = -1;
	nltchars.t_werasc = -1;
	nltchars.t_lnextc = -1;
	if(ioctl (0, TIOCSLTC, &nltchars) == -1)
		Die("Error initialising terminal: %s", strerror(errno));
	/* provide a smaller terminal output buffer so that
	   the type ahead detection works better (more often) */
	setbuffer(stdout, &tobuf[0], TBUFSIZ);
	signal(SIGTSTP,SIG_DFL);	/* set signals so that we can */
	signal(SIGCONT,rtfrmshell);	/* suspend & restart Emacs */
#endif	/*  BSD_UNIX */
#endif	// V7 || BSD_UNIX

#ifdef	LINUX5
	/* A smaller terminal output buffer has to be flushed more often
	 * and so slowed and better type ahead detection.
	 * As long as kernel/networking/... buffers are not too big.
	 *
	 * Note that termOutBufSize is also used in updateline() to work out
	 * if the output buffer has been flushed before doing a typahead().
	 * It does not matter to updateline() if it is 0.
	 *
	 * First: how big the buffer is, our maximum:
	 */
	termOutBufSize = TBUFSIZ;

	if(OutputSlowness) {
		// Request from the command line
		termOutBufSize /= (size_t)OutputSlowness;
	} else {
		/* Try and get a speed from the operating system.
		 * Use that to guess how many bytes we can output in 3 seconds.
		 * Set that to the buffer size.
		 */
		ispeed = cfgetospeed(&otermio);
		if(ispeed > 0 && ispeed <= sizeof(BaudTable) / sizeof(BaudTable[0])) {
			int	bps = BaudTable[ispeed] / 10;	// Speed chars/second, roughly
			bps *= 3;	// What we can output in 3 seconds
			if(bps < 32)	// Minimum buffer size when it is really slow
				bps = 32;
			if(bps <= TBUFSIZ)
				termOutBufSize = (SETBsize_t)bps;
		}
	}

	// fprintf(stderr, "OutputSlowness=%d speed=%d ispeed=%d termOutBufSize=%d\n", OutputSlowness, cfgetospeed(&otermio), ispeed, (int)termOutBufSize);fflush(stderr);
	
#if	TERMDEBUG
	// When debugging: no buffering at all help to see what the program is doing
	if(TermDebug > 1)	// -K option
		setvbuf(stdout, (char*)NULL, _IONBF, 0);
	else
#endif
	setbuffer(stdout, tobuf, termOutBufSize);
#endif

	/* on all screens we are not sure of the initial position
	   of the cursor					*/
	ttrow = TERM_HUGE;
	ttcol = TERM_HUGE;

	TTopened = TTfullyOpened;	// In cooked mode

	return(0);	// Keep compiler happy
}

/*
 * act	What to do. Flags, ORed together:
 *	TTCCgotobot	Goto bottom of screen: (AllocLines - 1, 0)
 *	TTCCnlcr	Send \n\r
 *	TTCCkclose	Do TTkclose()
 *	TTCCmsgc	Do msglClear() & msglFlush()
 *			If this is set msglFlush() is always called
 *	TTCCclose	Do TTclose()
 */
void	ttcondclose(int act)
{
	if(TTopened == TTneverOpened) {
		if((act & TTCCmsgc) != 0)
			msglFlush();
		return;
	}

	if((act & TTCCgotobot) != 0)
		movecursor(AllocLines - 1, 0);

	if((act & TTCCnlcr) != 0) {
		TTputc('\n');
		TTputc('\r');
	}

	if((act & TTCCkclose) != 0)
		TTkclose();

	if((act & TTCCmsgc) != 0) {
		msglClear();
		msglFlush();
	}

	if((act & TTCCclose) != 0)
		TTclose();
}

/* Reopen the terminal.
 *
 * act	What to do. Flags, ORed together:
 *	TTREopen	Do TTopen()
 *	TTREkopenTRUE	Do TTkopen(TRUE)
 *	TTREkopenFALSE	Do TTkopen(FALSE)
 *			Only one of TTREkopenTRUE or TTREkopenFALSE
 *	TTREpaint	RePaint()
 *	TTCCmsgl	msglGarbage() & msglCpos(0)
 *
 * If the terminal has never been opened, do nothing.
 */
void	ttreopen(int act)
{
	if(TTopened == TTneverOpened)
		return;

	if((act & TTREopen) != 0)
		TTopen();

	if((act & TTREkopen) != 0)
		TTkopen((act & 0x04) ? TRUE : FALSE);

	if((act & TTREpaint) != 0)
		RePaint();

	if((act & TTCCmsgl) != 0) {
		msglGarbage();
		msglCpos(0);
	}
}

/* Some UNIX boxes support dynamic window sizes.
 */
#if	WINSIZE		/* UNIX Window size change supported ? */

/* Signal handler called when the screen window changes size
 *
 * This does a bit more work than it really should in a signal hander.
 * It is safe, most of the time, because Emacs will be sitting in a terminal read;
 * thus quiet, not doing other things, eg malloc - which screws badly when we resize.
 *
 * WasSuspd is set if Emacs was stopped (job control) OR window size changed.
 *
 * s is the signal number - but this will only be called as a result of WINCH.
 */
void	sigWinchHandler(int s)
{
	WasSuspd = TRUE;
	sgarbf  = TRUE;

	GetTermDims();

	/* Sitting in a read ? */
	if(in_read)
		siglongjmp(susp_buf, 1);
}
#endif

/* Read the screen size, override what we get from termcap.
 * Elsewhere this is referred to as the window size - a terminal window.
 * Be careful, there is an unholy aliance between the window
 * size change code and being suspended (^z), code that isn't
 * used on one version of UNIX is used with another.
 */
void	GetTermDims(void)
{
#if	WINSIZE		/* UNIX Window size change supported ? */
	struct winsize	ws;

	signal(SIGWINCH, sigWinchHandler);

	if(ioctl(0, TIOCGWINSZ, &ws) >= 0) {
		term.t_mrow = (short)ws.ws_row;
		term.t_mcol = (short)ws.ws_col;

#if	TERMDEBUG
		if(TermDebFD != (FILE*)NULL) {
			char	buf[100];

			// Debug write not use stdio - we could be in an interrupt handler
			sprintf(buf, "TERM dimensions: t_mrow=%d t_mcol=%d\n", term.t_mrow, term.t_mcol);
			write(fileno(TermDebFD), buf, strlen(buf));
		}
#endif
	}
#endif

	// Sanity check. This will prob mess a tiny screen up, but it stops a crash
	if(term.t_mrow < MIN_SCREEN_LINES)
		term.t_mrow = MIN_SCREEN_LINES;
	if(term.t_mcol < MIN_SCREEN_COLS)
		term.t_mcol = MIN_SCREEN_COLS;

	term.t_nrow = term.t_mrow;	// Set SCREEN_LINES
	term.t_ncol = term.t_mcol;	// Set SCREEN_COLUMNS
}

/* This function gets called just before we go back home to the command
 * interpreter. On VMS it puts the terminal back in a reasonable state.
 * Another no-operation on CPM.
 */
void	ttclose(void)
{
	/* Do nothing if we don't know what to go back to
	 *
	 * This is needed so that we don't reset to garbage if we try to do
	 * so very early - eg on receipt of a signal.
	 */
	if(TTopened == TTneverOpened)
		return;

	/* Say that we are (will shortly be) in cooked mode
	 * mlFlush() checks this to see if the message line should
	 * just be written to stdout.
	 */
	TTopened = TTwasOpened;

#if     AMIGA
#if	LATTICE
        amg_flush();
        Close(terminal);
#endif	/* LATTICE */
#if	AZTEC
        amg_flush();
	Enable_Abort = 1;	/* Fix for Manx */
        Close(terminal);
#endif	/* AZTEC */
#endif	/* AMIGA */

#if     VMS
        int     status;
        int     iosb[1];

        ttflush();
        status = SYS$QIOW(EFN, iochan, IO$_SETMODE, iosb, 0, 0,
                 oldmode, sizeof(oldmode), 0, 0, 0, 0);
        if (status!=SS$_NORMAL || (iosb[0]&0xFFFF)!=SS$_NORMAL)
                exit(status);
        status = SYS$DASSGN(iochan);
        if (status != SS$_NORMAL)
                exit(status);
#endif

#if     CPM
#endif

#if	MSDOS && (HP150 == 0) && LATTICE
	/* restore the ctrl-break interupt */
	rg.h.ah = 0x33;		/* control-break check dos call */
	rg.h.al = 1;		/* set the current state */
	rg.h.dl = 1;		/* set it ON */
	intdos(&rg, &rg);	/* go for it! */
#endif

#if	USG
#ifdef	NCCS
	if(tcsetattr(0, TCSADRAIN, &otermio) == -1)	/* restore terminal settings */
		Die("Error closing terminal: %s", strerror(errno));
#else
	if(ioctl(0, TCSETA, &otermio) == -1)		/* restore terminal settings */
		Die("Error closing terminal: %s", strerror(errno));
#endif
#endif

#if     V7 || BSD_UNIX
	if(stty(0, &ostate) == -1)
		Die("Error closing terminal: %s", strerror(errno));
#if	CBMODE
	if(ioctl(0, TIOCSETC, &otchars) == -1)
		Die("Error closing terminal: %s", strerror(errno));
#endif
#if	 BSD_UNIX
	if(ioctl(0, TIOCSLTC, &oltchars) == -1)
		Die("Error closing terminal: %s", strerror(errno));
#endif	/*  BSD_UNIX */
#endif
}

/* Write a character to the display. On VMS, terminal output is buffered, and
 * we just put the characters in the big array, after checking for overflow.
 * On CPM terminal I/O unbuffered, so we just write the byte out. Ditto on
 * MS-DOS (use the very very raw console output routine).
 *
 * Flush any pending attributes before we do this.
 *
 * This must return int -- this is what the system termcap routines (tputs) expect.
 */
#if     AMIGA
int	ttputc(c)
	char c;
#else
int	ttputc(int c)
#endif
{
	ST_termOut++;

	// Need to flush attribute change before other output ?
	if(needNewAttrib)
		AttribSet();

#if     AMIGA
        scrn_tmp[scrn_tmp_p++] = c;
        if(scrn_tmp_p>=AMG_MAXBUF)
                amg_flush();
#endif
#if     VMS
        if (nobuf >= NOBUF)
                ttflush();
        obuf[nobuf++] = c;
#endif

#if     CPM
        bios(BCONOUT, c, 0);
#endif

#if     MSDOS && MWC86
        putcnb(c);
#endif

#if	MSDOS && (LATTICE || AZTEC) && ~IBMPC
	bdos(6, c, 0);
#endif

#if RAINBOW
        Put_Char(c);                    /* fast video */
#endif

#if	UNIX
	fputc(c, stdout);
#endif

	return(0);
}

#if	AMIGA
amg_flush()
{
        if(scrn_tmp_p)
                Write(terminal,scrn_tmp,scrn_tmp_p);
        scrn_tmp_p = 0;
}
#endif

/* Write out a NUL terminated string.
 * Flush any pending attributes before we do this.
 */
void	ttputs(const char* str)
{
	ST_termOut += (ST_val)strlen(str);
#if	UNIX
	// Need to flush attribute change before other output ?
	if(needNewAttrib)
		AttribSet();

	fputs(str, stdout);
#else
	while(*str)
		ttputc(*str++);
#endif
}

/* Write out a NUL terminated string.
 * Do NOT flush any pending attributes before we do this.
 *
 * If str is NULL do nothing.
 */
void	ttputs_noNA(const char* str)
{
	if( !str)
		return;

#if	UNIX
	fputs(str, stdout);
#else
	// Do this a little more long winded
	int	nna = needNewAttrib;
	needNewAttrib = 0;

	while(*str)
		ttputc(*str++);	

	needNewAttrib = nna;
#endif

	ST_termOut += (ST_val)strlen(str);
}

/* Flush terminal buffer. Does real work where the terminal output is buffered
 * up. A no-operation on systems where byte at a time terminal I/O is done.
 * On UNIX TtyWriteFailure is set to the errno value if a write failure happens,
 * it is cleared (to 0) if there is no error. But first: if errno is EGAIN, sleep
 * a bit and try again, see if that works.
 *
 * Flush any pending attributes before we do this.
 *
 * Return TRUE on OK.
 */
int	ttflush(void)
{
	// Need to flush attribute changes ?
	if(needNewAttrib)
		AttribSet();

#if     AMIGA
        amg_flush();
#endif
#if     VMS
        int     status;
        int     iosb[2];

        status = SS$_NORMAL;
        if (nobuf != 0) {
                status = SYS$QIOW(EFN, iochan, IO$_WRITELBLK|IO$M_NOFORMAT,
                         iosb, 0, 0, obuf, nobuf, 0, 0, 0, 0);
                if (status == SS$_NORMAL)
                        status = iosb[0] & 0xFFFF;
                nobuf = 0;
        }
        return (status);
#endif

#if     CPM
#endif

#if     MSDOS
#endif

#if	UNIX
	TtyWriteFailure = 0;

	if(fflush(stdout) != EOF)
		return(TRUE);

	if(errno == EAGAIN) {
		// See if things get better shortly:
		sleep(1);
		if(fflush(stdout) != EOF)
			return(TRUE);
	}

	// Whoops ... record the error
	TtyWriteFailure = errno;

	return(FALSE);
#endif
}

/* Read a character from the terminal, performing no editing and doing no echo
 * at all. More complex in VMS that almost anyplace else, which figures. Very
 * simple on CPM, because the system can do exactly what you want.
 *
 * With UNIX we are into possibly reading multiple characters to see if they
 * are part of a termcap defined sequence (ie is it a function key).
 * Just to make things awkward, most function key sequences start with escape,
 * a character of some importance. So we need to time a sequence out if it
 * doesn't all arrive within a reasonable time. This could cause problems over
 * networks where characters can get delayed & so a sequence stretched in time.
 *
 * If the current buffer is in UTF8 mode then try to read input as UTF8 - ie if top bit set.
 *
 * If timeout is non zero, input must come within that time.
 * The purpose is to allow a prompt timeout and some other action happen.
 * If non-zero it should specify at least one second; any less than
 * that and there is a risk of seeing the individual bytes that make up
 * something like an arrow key.
 * timeout is measured in microseconds.
 *
 * If this fails it returns
 *   KEY_TIMEOUT	nothing read from the keyboard within timeout
 *   KEY_END_OF_FILE	End of file - when the terminal has not been initialised
 *			termEOF will be set TRUE
 *   UTF8_REPLACEMENT	because: the sequence is not valid UTF8
 *   abortc		because: a read failure at the OS level
 *   first:		not enough characters have been received (eg part of a multi byte sequence) in time,
 * 			so return the first character.
 */
KeyCode	ttgetc(long timeout)
{
	// Something been pushed back to input ?
	if(ungetThere) {
		ungetThere = 0;
		return(ungetKey);	// The ungot character
	}

#if     AMIGA
        char ch;
        amg_flush();
        Read(terminal, &ch, 1L);
	ST_termInBytes++;
	ST_termInKeys++;
        return(0xFF & (int)ch);
#endif
#if     VMS
        int     status;
        int     iosb[2];
        int     term[2];

        while (ibufi >= nibuf) {
                ibufi = 0;
                term[0] = 0;
                term[1] = 0;
                status = SYS$QIOW(EFN, iochan, IO$_READLBLK|IO$M_TIMED,
                         iosb, 0, 0, ibuf, NIBUF, 0, term, 0, 0);
                if (status != SS$_NORMAL)
                        exit(status);
                status = iosb[0] & 0xFFFF;
                if (status!=SS$_NORMAL && status!=SS$_TIMEOUT)
                        exit(status);
                nibuf = (iosb[0]>>16) + (iosb[1]>>16);
                if (nibuf == 0) {
                        status = SYS$QIOW(EFN, iochan, IO$_READLBLK,
                                 iosb, 0, 0, ibuf, 1, 0, term, 0, 0);
                        if (status != SS$_NORMAL
                        || (status = (iosb[0]&0xFFFF)) != SS$_NORMAL)
                                exit(status);
                        nibuf = (iosb[0]>>16) + (iosb[1]>>16);
                }
        }
        return (ibuf[ibufi++] & 0xFF);    /* Allow multinational  */
#endif

#if     CPM
        return (biosb(BCONIN, 0, 0));
#endif

#if RAINBOW
        int Ch;

        while ((Ch = Read_Keyboard()) < 0);

        if ((Ch & Function_Key) == 0)
                if (!((Ch & 0xFF) == 015 || (Ch & 0xFF) == 0177))
                        Ch &= 0xFF;
	ST_termInBytes++;
	ST_termInKeys++;

        return Ch;
#endif

#if     MSDOS && MWC86
	return (getcnb());
#endif

#if	MSDOS && (LATTICE || MSC || TURBO || AZTEC)
	int c;		/* character read */

	/* if a char already is ready, return it */
	if (nxtchar >= 0) {
		c = nxtchar;
		nxtchar = -1;
		ST_termInBytes++;
		ST_termInKeys++;
		return(c);
	}

	/* call the dos to get a char */
	rg.h.ah = 7;		/* dos Direct Console Input call */
	intdos(&rg, &rg);
	c = rg.h.al;		/* grab the char */
	ST_termInBytes++;
	ST_termInKeys++;
	return(c & 0xFF);
#endif

#if	UNIX
	/* Use the bytes in the global InChBuf. This is longish to capitalise
	 * on, maybe, being able to read several bytes on one system call.
	 * Note that there may by 'consumed' bytes at the start - InChOff;
	 * Try to match what is there, call UxGetChar() when we run out.
	 *
	 * If we see the start of a multi-byte/character sequence but not all of it,
	 * then call UxGetChar(true) - which times out if the rest don't come
	 * within ttytimeout microseconds.
	 * This is for: Function/arrow keys & UTF8 characters.
	 */

	while(1) {
		int	needMore = 0;

		if(InChCnt) {
			BYTE*	InBytes = InChBuf + InChOff;
			KeyCode	Token;		/* Function key that we read */
			int	i;

			/* Do we recognise it as an arrow key or similar ? */
			if((i = TcapFun(InBytes, InChCnt, &Token)) == -1) {
				needMore = 1;
			} else if(i > 0) {
				/* Got a token, remove however many chars made
				 * up the token & return the special value.
				 */
				InChCnt -= i;
				InChOff += i;

				ST_termInKeys++;

				return(Token);
			}

			/* If UTF8 mode - try to interpert the input characters to a Unicode point.
			 * If there are not enough they should arrive quickly enough.
			 * The user will have copy/pasted the character or typed something like ctrl/shft/u
			 * followed by hex chars.
			 * Don't process single chars - screws termcap above.
			 */
			if((curbp->b_mode & MDUTF8) && CHAR_LEN(*InBytes) > 1 ) {
				if(InChCnt >= CHAR_LEN(*InBytes)) {
					UniChar	retch;		/* What we return - Unicode */

					if((retch = utf8_decode(InBytes)) >= 0) {
						// Consume those bytes:
						InChCnt -= CHAR_LEN(*InBytes);
						InChOff += CHAR_LEN(*InBytes);

						if(retch > UTF8_MAX_CODE_POINT)
							retch = -1;
					} else {
						// Should not happen, just take the first byte
						// and leave the rest for later processing.
						InChCnt--;
						InChOff++;
					}
					

					ST_termInKeys++;

					return((KeyCode)(retch < 0 ? UTF8_REPLACEMENT : retch));
				}

				needMore = 1;
			}

			/* We have at least one character.
			 * If we are not waiting for more of a sequence, return the
			 * first character.
			 * In UTF8 mode do not return something like the byte 0x81, this is
			 * continuation byte which, in our system, has length 0.
			 * This should not be found in the wild - famous last words.
			 */
			if( !needMore) {
				UniChar	chr = *InBytes;

				if((curbp->b_mode & MDUTF8) && chr > UTF8_MAX_CP1)
					chr = UTF8_REPLACEMENT;

				InChCnt--;
				InChOff++;

				ST_termInKeys++;

				return((KeyCode)chr);
			}
		}

		/* Need more chars before we can make our mind up.
		 *
		 * If we need more chars (ie seen the start of a multi byte key) then
		 * set a timeout of ttytimeout.
		 */
		switch(UxGetChar(timeout ? timeout : (needMore ? ttytimeout : 0))) {
		  case -3:	// EOF in cooked mode
			return(KEY_END_OF_FILE);

		  case -2:	// Error
			InChCnt = 0;
			ST_termInKeys++;
			return(abortc);	/* Bell, abort, ^g - stop whatever */

		  case -1:	// Timeout - return what we have (if any)
			if(InChCnt > 0) {
				BYTE	ch = (BYTE)InChBuf[InChOff++];
				InChCnt--;

				ST_termInKeys++;

				return(ch);
			}
			// Don't have anything at all
			return(KEY_TIMEOUT);
		}
	}

#endif
}

#if	UNIX
/* Read some more into InChBuf.
 * Return values:
 *  0	Read something without error
 * -1	Timeout, ie a character wasn't read in time
 * -2	Error, on UNIX TtyReadFailure will be set to errno.
 * -3	End Of File - no more input. Only when the terminal has not been fully
 *	opened and is still in cooked mode.
 *	termEOF will be set TRUE
 *
 * This detects us being brought back to foreground (job control) & repaints
 * the screen.
 *
 * If timeout is not zero: timeout the read if the character isn't got quickly.
 * This is so that we can detect if characters are part of some keyboard
 * function key (where they should all arrive quickly).
 * This is also done so that, if the user has not responded, another action
 * can be done: like putting up a secondary prompt.
 *
 * timeout is measured in microseconds.
 *
 * If there are characters buffered in InChBuf, return them.
 *
 * This is misnamed, should be UxGetBytes() - this works at below the level of
 * characters, this reads bytes that we will later 'convert' into characters,
 * sometimes more than one byte making up a character - or a key code (eg arrow).
 */
int	UxGetChar(long timeout)
{
	int		i = 0;	// Init to keep compiler quiet
	int		loopy;

	TtyReadFailure = 0;	/* Reset error condition */

	/* Got some left over from a previous read that are not at the buffer start ?
	 * Move them down.
	 * Set the read offset to just after these bytes.
	 */
	if(InChCnt && InChOff)
		memmove(InChBuf, InChBuf + InChOff, (size_t)InChCnt);

	InChOff = 0;	// First 'unconsumed' byte is now (or soon will be) at the start of the buffer

	for(loopy = 0; loopy < 5; loopy++) {
		if(sigsetjmp(susp_buf, 0)) { /* got SIGWINCH */
			sigset_t clear, res;

			in_read = 0;	// We no longer are but we might get another SIGWINCH

			/* If we were suspended redraw */
			RePaint();

			/* Because we came out of the signal handler by siglongjmp() and not return
			 * the signal remains blocked. Must unblock it to handle multiple resizes.
			 */
			sigemptyset(&clear);
			sigaddset(&clear, SIGWINCH);
			sigprocmask(SIG_UNBLOCK, &clear, &res);

			loopy = 0;    /* May get lots of window size changes */

			continue;
		}

		/* Abandon if we don't get quickly enough ?
		 * If the timeout is set to 0 wait forever.
		 * A negative timeout will cause problems - avoid that.
		 */
		if(timeout > 0 && (i = UxPeekStdin(timeout)) != 1)
			return(i - 1);

		/* Note that susp_buf is valid & read - may take some time */
		in_read = 1;
#if	USG
		i = (int)read(0, InChBuf + InChCnt, sizeof(InChBuf) - (size_t)InChCnt);
#else
		i = read(0, InChBuf + InChCnt, 1);
#endif
		in_read = 0;

		/* Did we read something ?
		 * Return after increasing the count of what is in the buffer: InChCnt.
		 */
		if(i > 0) {
#if	TERMDEBUG	/* Just what do those pesky function keys return ? */
			if(TermDebFD) {
				int	j;

				fprintf(TermDebFD, "\nREAD %d '", i);
				for(j = 0; j < i; j++)
					fprintf(TermDebFD, "%2.2x ",
						InChBuf[InChCnt + j] & 255);
				fprintf(TermDebFD, "'\n");
			}
#endif

#if	TRACEBUFFER	// Trace input keys
			lcatm(traceKeys, InChBuf + InChCnt, i);
#endif

			InChCnt += i;
			ST_termInBytes += i;

			return(0);
		}

		/* Interrupted read ?, try again */
		if(i == -1 && errno == EINTR) {
			if(WasSuspd)
				RePaint();
			continue;
		}

		/* Not an interrupted read - error or EOF */

		if(i == 0 && TTopened == TTneverOpened) {
			termEOF = TRUE;
			return(-3);
		}

		break;
	}

	fprintf(stderr, "tty read failure %d, errno %d: %s", i, errno, strerror(errno));

	/* Note what happened - part of detecting when the terminal
	 * evaporates - aka HUP.
	 */
	TtyReadFailure = errno;

	return(-2);	/* Error */
}
#endif

#if	TYPEAH && (~ST520 || ~LATTICE)
/* typahead:	Check to see if any characters are already in the
 *		keyboard buffer
 *
 * An ungot character counts as something being available.
 *
 * If alwaysCheck then always actually do a check.
 * Otherwise optimise out the check if not many characters have been written to the terminal,
 * so avoiding a select()/whatever.
 * Don't optimise if we have slept since we last did this: DoTypahead tells us.
 *
 * Return TRUE if there is something.
 * BEWARE: what is in the buffer might be the start of a multibyte sequence, eg: arrow key
 */
int	typahead(int alwaysCheck)
{
#if	USG
	/* Have we already read something that is waiting to be processed ?
	 * We always do this - it is cheap.
	 */
	if(InChCnt)
		return(TRUE);
#endif

	/* Is there pending input ?
	 * Only do this test if we might have flushed buffer - tty speed dependent in size.
	 * It is benign if termOutChecked is out of date.
	 */
	if(!alwaysCheck && !DoTypahead && ST_termOut < termOutChecked + (ST_val)termOutBufSize)
		return(FALSE);

	if(ungetThere)
		return(TRUE);	// There is an ungot character

	termOutChecked = ST_termOut;
	DoTypahead = 0;

#if	MSDOS && (MSC || TURBO)
	if (kbhit() != 0)
		return(TRUE);
	else
		return(FALSE);
#endif

#if	MSDOS && (LATTICE || AZTEC || MWC86)
	int c;		/* character read */
	int flags;	/* cpu flags from dos call */

	if (nxtchar >= 0)
		return(TRUE);

	rg.h.ah = 6;	/* Direct Console I/O call */
	rg.h.dl = 255;	/*         does console input */
#if	LATTICE || AZTEC
	flags = intdos(&rg, &rg);
#else
	intcall(&rg, &rg, 0x21);
	flags = rg.x.flags;
#endif
	c = rg.h.al;	/* grab the character */

	/* no character pending */
	if ((flags & 64) != 0)
		return(FALSE);

	/* save the character and return true */
	nxtchar = c;
	return(TRUE);
#endif	/* 	MSDOS && (LATTICE || AZTEC || MWC86) */

/* the _RET definitions in the following ensures that the compiler does not
 * produce the "warning: statement not reached" error.
 */

#if	 BSD_UNIX
#define	_RET
	int x;	/* holds # of pending chars */

	return((ioctl(0,FIONREAD,&x) < 0) ? 0 : x);
#endif	/* BSD_UNIX */

#if	USG
#define	_RET
	/* Do not give this any time to see if something will come in.
	 * This function may be called several times, we do not want to
	 * wait a multiple of even a short time.
	 * Treat nothing there & error as the same thing: return nothing available.
	 */
	return(UxPeekStdin(0) == 1 ? TRUE : FALSE);
#endif

#ifndef	_RET
	return(FALSE);
#endif	/* _RET */
}
#endif

#if	USG
/* Check if there is something ready to be read from the TTY
 * ttytimeout is how long to wait if something is not available,
 * 	measured in microseconds. This may specify more than 1 second.
 *
 * BEWARE: ttytimeout MUST NOT be negative - this does not check for it.
 * If it were negative select() will fail, code EINVAL on Linux.
 *
 * Return:
 * -1	error
 *  0	nothing to read
 *  1	something to read
 */
int	UxPeekStdin(long ttyTimeout)
{
	struct timeval	timstr;
	int		i;
	fd_set		readfds;

	/* On Linux these values are modified after EINTR to reflect the time
	 * elapsed.
	 */
	timstr.tv_sec  = ttyTimeout / MILLION;
	timstr.tv_usec = ttyTimeout % MILLION;

	while(1) {
		FD_ZERO(&readfds);
		FD_SET(0, &readfds);
		if((i = select(1, &readfds, (fd_set*)NULL, (fd_set*)NULL,
				&timstr)) == -1 && errno == EINTR)
			continue;	// EINTR prob because of job control suspend

		return(i);
	}
}
#endif	/* USG */

/* Push a character back to keyboard, the previous ungot key is returned.
 * If there is not an ungot key: return KEY_NONE.
 *
 * Only one key can be ungot. The value of key is not checked for validity in any way.
 *
 * If key is KEY_NONE any ungot key is removed/invalidated.
 */
KeyCode	ttungetc(KeyCode key)
{
	KeyCode	ret = ungetThere ? ungetKey : KEY_NONE;

	ungetKey = key;
	ungetThere = key != KEY_NONE;

	return(ret);
}

/* end */
